(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[10],{

/***/ "./src/common/butlerd/index.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return messages; });
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "a", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["a"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "b", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["b"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "c", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["c"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "d", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["d"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "e", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["e"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "f", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["f"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "g", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["g"]; });

/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


const messages = common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__;


/***/ }),

/***/ "./src/common/butlerd/utils.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ call; });
__webpack_require__.d(__webpack_exports__, "f", function() { return /* binding */ hookLogging; });
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ getCaveSummary; });
__webpack_require__.d(__webpack_exports__, "g", function() { return /* binding */ isInternalError; });
__webpack_require__.d(__webpack_exports__, "d", function() { return /* binding */ getErrorStack; });
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ asRequestError; });
__webpack_require__.d(__webpack_exports__, "e", function() { return /* binding */ getRpcErrorData; });

// UNUSED EXPORTS: hookProgress, getErrorMessage, mergeLogAndError

// EXTERNAL MODULE: ./node_modules/butlerd/lib/index.js
var lib = __webpack_require__("./node_modules/butlerd/lib/index.js");

// EXTERNAL MODULE: ./src/common/logger/index.ts
var common_logger = __webpack_require__("./src/common/logger/index.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// EXTERNAL MODULE: ./src/common/types/index.ts
var types = __webpack_require__("./src/common/types/index.ts");

// CONCATENATED MODULE: ./src/main/reactors/delay.ts
/** returns a promise that resolves after 'ms' milliseconds */
function delay(ms) {
    return new Promise((resolve, reject) => setTimeout(resolve, ms));
}

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__("./src/common/format/datetime.ts");

// CONCATENATED MODULE: ./src/common/butlerd/utils.ts






var clientPromises = new WeakMap();
async function makeClient(store, parentLogger) {
    const logger = parentLogger.childWithName("butlerd/make-client");
    while (true) {
        const { endpoint } = store.getState().butlerd;
        if (endpoint) {
            const client = new lib["Client"](endpoint);
            client.onWarning((msg) => {
                logger.warn(`(butlerd) ${msg}`);
            });
            return client;
        }
        logger.info(`Waiting for butlerd endpoint...`);
        await delay(1000);
    }
}
async function getClient(store, parentLogger) {
    let p;
    if (clientPromises.has(store)) {
        p = clientPromises.get(store);
    }
    else {
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    const client = await p;
    const currentEndpoint = store.getState().butlerd.endpoint;
    if (client.endpoint !== currentEndpoint) {
        parentLogger.warn(`(butlerd) Endpoint changed (${client.endpoint.tcp.address} => ${currentEndpoint.tcp.address}), making fresh client`);
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    return p;
}
async function call(store, logger, rc, params, setup) {
    const client = await getClient(store, logger);
    try {
        logger.debug(`Calling ${rc({})(client).method}`);
        return await client.call(rc, params, setup);
    }
    catch (e) {
        if (Object(types["isCancelled"])(e)) {
            // nvm
        }
        else if (Object(types["isAborted"])(e)) {
            // nvm
        }
        else {
            logger.error(`Caught butler error:`);
            if (isInternalError(e)) {
                const ed = getRpcErrorData(e);
                if (ed) {
                    logger.error(`butler version: ${ed.butlerVersion}`);
                    logger.error(`Golang stack:\n${ed.stack}`);
                }
                logger.error(`JavaScript stack: ${e.stack}`);
            }
            else {
                logger.error(`${e.message}`);
            }
        }
        throw e;
    }
}
function hookProgress(convo, ctx) {
    convo.onNotification(messages["Progress"], (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages["Log"], async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = Object(datetime["d" /* formatDate */])(new Date(obj.time), "en-US", datetime["a" /* DATE_FORMAT */]);
                    let level = common_logger["c" /* levels */][obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}
function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}


/***/ }),

/***/ "./src/common/constants/platform-data.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return hasPlatforms; });
const data = {
    windows: { icon: "windows8", platform: "windows", emoji: "🏁" },
    linux: { icon: "tux", platform: "linux", emoji: "🐧" },
    osx: { icon: "apple", platform: "osx", emoji: "🍎" },
};
/* harmony default export */ __webpack_exports__["a"] = (data);
function hasPlatforms(target) {
    for (const key of Object.keys(data)) {
        if (target.platforms[key]) {
            return true;
        }
    }
    if (target.type === "html") {
        return true;
    }
    return false;
}


/***/ }),

/***/ "./src/common/format/filesize.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return fileSize; });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ "./src/common/format/show-in-explorer.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return showInExplorerString; });
function showInExplorerString() {
    switch (process.platform) {
        case "linux": {
            return ["grid.item.open_file_location.linux"];
        }
        case "darwin": {
            return ["grid.item.open_file_location.osx"];
        }
        case "win32":
        default: {
            return ["grid.item.open_file_location.windows"];
        }
    }
}


/***/ }),

/***/ "./src/common/format/upload.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return formatUploadTitle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return formatUploadTitleFancy; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatBuildVersionInfo; });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ "./src/common/util/action-for-game.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ actionForGame; });

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// CONCATENATED MODULE: ./src/common/constants/classification-actions.ts

const classificationActions = {
    [messages["GameClassification"].Game]: "launch",
    [messages["GameClassification"].Tool]: "launch",
    [messages["GameClassification"].Assets]: "open",
    [messages["GameClassification"].GameMod]: "open",
    [messages["GameClassification"].PhysicalGame]: "open",
    [messages["GameClassification"].Soundtrack]: "open",
    [messages["GameClassification"].Other]: "open",
    [messages["GameClassification"].Comic]: "open",
    [messages["GameClassification"].Book]: "open",
};

// CONCATENATED MODULE: ./src/common/util/action-for-game.ts

/**
 * Returns whether a game can be "launched" or "opened", where "launching" means
 * starting an executable, serving a web game, etc., and "opening" means showing files
 * in a file explorer.
 */
function actionForGame(game, cave) {
    // FIXME: we're not using the cave at all here - we probably should.
    return classificationActions[game.classification] || "launch";
}


/***/ }),

/***/ "./src/renderer/basics/FormattedDuration.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/format/datetime.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react-intl/lib/src/components/message.js");



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ __webpack_exports__["a"] = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], Object.assign({}, Object(common_format_datetime__WEBPACK_IMPORTED_MODULE_0__[/* formatDurationAsMessage */ "e"])(secs)))));


/***/ }),

/***/ "./src/renderer/basics/LastPlayed.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/action-for-game.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/TimeAgo.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/t.tsx");





class LastPlayed extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
    render() {
        const { game, cave, short = false, className } = this.props;
        const { lastTouchedAt = null } = cave || {};
        const classification = game.classification || "game";
        const classAction = Object(common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__[/* actionForGame */ "a"])(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement("div", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()("last-playthrough", className) }, lastTouchedAt ? (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement("label", null, short ? (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { date: lastTouchedAt })) : (Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])([
            `usage_stats.last_${xed}_time_ago`,
            {
                time_ago: react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { date: lastTouchedAt }),
            },
        ])))) : (Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])([`usage_stats.never_${xed}`]))));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (LastPlayed);


/***/ }),

/***/ "./src/renderer/basics/TotalPlaytime.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/action-for-game.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/FormattedDuration.tsx");




class TotalPlaytime extends react__WEBPACK_IMPORTED_MODULE_1___default.a.PureComponent {
    render() {
        const { game, cave, short = false } = this.props;
        let { secondsRun = 0 } = (cave || {});
        const classification = game.classification || "game";
        const classAction = Object(common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__[/* actionForGame */ "a"])(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        if (secondsRun > 0 && classAction === "launch") {
            return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null,
                short ? null : (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("label", null,
                    Object(renderer_t__WEBPACK_IMPORTED_MODULE_2__[/* T */ "a"])([`usage_stats.has_${xed}_for_duration`]),
                    " ")),
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("span", { className: "total-playtime" },
                    react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { secs: secondsRun }))));
        }
        return null;
    }
}
/* harmony default export */ __webpack_exports__["a"] = (TotalPlaytime);


/***/ }),

/***/ "./src/renderer/basics/UploadIcon.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__("./src/common/format/filesize.ts");

// EXTERNAL MODULE: ./src/common/constants/platform-data.ts
var platform_data = __webpack_require__("./src/common/constants/platform-data.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// CONCATENATED MODULE: ./src/main/reactors/make-upload-button.ts



function makeUploadButton(upload, opts = { showSize: true }) {
    let label = `${upload.displayName || upload.filename}`;
    let tags = [];
    if (upload.size > 0 && opts.showSize) {
        tags.push({
            label: `${Object(filesize["a" /* fileSize */])(upload.size)}`,
        });
    }
    if (upload.demo) {
        tags.push({
            label: ["pick_update_upload.tags.demo"],
        });
    }
    for (const prop of Object.keys(platform_data["a" /* default */])) {
        if (upload[prop]) {
            tags.push({
                icon: platform_data["a" /* default */][prop].icon,
            });
        }
    }
    const timeAgo = {
        date: upload.updatedAt,
    };
    const icon = uploadIcon(upload) || "download";
    return { label, tags, icon, timeAgo };
}
const uploadIcons = {
    [messages["UploadType"].Default]: "gamepad",
    [messages["UploadType"].Flash]: "neutral",
    [messages["UploadType"].Unity]: "neutral",
    [messages["UploadType"].Java]: "neutral",
    [messages["UploadType"].HTML]: "html5",
    [messages["UploadType"].Soundtrack]: "music",
    [messages["UploadType"].Book]: "book",
    [messages["UploadType"].Video]: "video",
    [messages["UploadType"].Documentation]: "book",
    [messages["UploadType"].Mod]: "shirt",
    [messages["UploadType"].AudioAssets]: "file-music",
    [messages["UploadType"].GraphicalAssets]: "images",
    [messages["UploadType"].Sourcecode]: "code",
    [messages["UploadType"].Other]: "zip",
};
function uploadIcon(upload) {
    return uploadIcons[upload.type];
}
// TODO: i18n that stuff
const uploadTypeHints = {
    [messages["UploadType"].Default]: "File",
    [messages["UploadType"].Flash]: "Flash embed",
    [messages["UploadType"].Unity]: "Unity embed (legacy)",
    [messages["UploadType"].Java]: "Java applet",
    [messages["UploadType"].HTML]: "HTML5 app",
    [messages["UploadType"].Soundtrack]: "Soundtrack",
    [messages["UploadType"].Book]: "Book",
    [messages["UploadType"].Video]: "Video",
    [messages["UploadType"].Documentation]: "Documentation",
    [messages["UploadType"].Mod]: "Mod",
    [messages["UploadType"].AudioAssets]: "Audio assets",
    [messages["UploadType"].GraphicalAssets]: "Graphical assets",
    [messages["UploadType"].Sourcecode]: "Source code",
    [messages["UploadType"].Other]: "Other",
};
function uploadTypeHint(upload) {
    return uploadTypeHints[upload.type];
}

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/UploadIcon.tsx



class UploadIcon_UploadIcon extends react_default.a.PureComponent {
    render() {
        const { upload } = this.props;
        if (!upload) {
            return null;
        }
        return react_default.a.createElement(Icon["a" /* default */], { icon: uploadIcon(upload), hint: uploadTypeHint(upload) });
    }
}
/* harmony default export */ var basics_UploadIcon = __webpack_exports__["a"] = (UploadIcon_UploadIcon);


/***/ }),

/***/ "./src/renderer/basics/modal-styles.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return ModalButtons; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalButtonSpacer; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const ModalButtons = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  width: 100%;
  flex-shrink: 0;
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
`;
const ModalButtonSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-shrink: 0;
  flex-grow: 0;
  width: 1em;
`;


/***/ }),

/***/ "./src/renderer/modal-widgets/ManageCave.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/format/filesize.ts");
/* harmony import */ var common_format_show_in_explorer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/common/format/show-in-explorer.ts");
/* harmony import */ var common_format_upload__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/common/format/upload.ts");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Cover__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/basics/Cover/index.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_basics_LastPlayed__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/basics/LastPlayed.tsx");
/* harmony import */ var renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/renderer/basics/RowButton.tsx");
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./src/renderer/basics/TimeAgo.tsx");
/* harmony import */ var renderer_basics_TotalPlaytime__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/basics/TotalPlaytime.tsx");
/* harmony import */ var renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__("./src/renderer/basics/UploadIcon.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__("./src/renderer/modal-widgets/styles.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__("./src/renderer/basics/modal-styles.tsx");
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__("./src/renderer/basics/Filler.tsx");





















const CaveItem = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  padding: 4px;

  display: flex;
  flex-direction: column;
  align-items: flex-start;

  .time-ago,
  .total-playtime {
    color: ${(props) => props.theme.secondaryText} !important;
  }
`;
const CaveDetails = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  display: flex;
  flex-direction: column;
`;
const CaveDetailsRow = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  padding: 8px 0;

  display: flex;
  flex-direction: row;
  align-items: center;

  &.smaller {
    font-size: 90%;
  }
`;
const Spacer = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  height: 1px;
  width: 8px;
`;
const SpacerLarge = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  height: 1px;
  width: 16px;
`;
const CaveItemBigActions = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  display: flex;
  flex-direction: column;
  margin-top: 20px;
  margin-bottom: 20px;

  & > * {
    margin-right: 4px;
  }
`;
const Title = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  font-weight: bold;

  display: flex;
  flex-direction: row;
  align-items: center;
`;
const FileSize = renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"].div `
  font-weight: normal;
`;
const ManageCaveDiv = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_17__[/* default */ "h"])(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_16__[/* ModalWidgetDiv */ "a"]) `
  min-width: 600px;
`;
class ManageCave extends react__WEBPACK_IMPORTED_MODULE_6___default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onSwitchVersion = (ev) => {
            const cave = this.props.modal.widgetParams.cave;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].closeModal({
                wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_5__[/* ambientWind */ "d"])(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].switchVersionCaveRequest({ cave }),
            }));
        };
        this.onBack = () => {
            const { dispatch } = this.props;
            const { wind, id } = this.props.modal;
            const { game } = this.props.modal.widgetParams.cave;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].closeModal({
                wind,
                id,
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].manageGame({ game }),
            }));
        };
        this.onUninstall = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].closeModal({
                wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_5__[/* ambientWind */ "d"])(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].queueCaveUninstall({ caveId }),
            }));
        };
        this.onReinstall = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].closeModal({
                wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_5__[/* ambientWind */ "d"])(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].queueCaveReinstall({ caveId }),
            }));
        };
        this.onUpdateCheck = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].closeModal({
                wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_5__[/* ambientWind */ "d"])(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].checkForGameUpdate({ caveId }),
            }));
        };
        this.onExplore = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].exploreCave({ caveId }));
        };
    }
    render() {
        return react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(ManageCaveDiv, null, this.renderCave());
    }
    renderCave() {
        const { cave } = this.props.modal.widgetParams;
        const { game } = cave;
        const u = cave.upload;
        const caveSummary = Object(common_butlerd__WEBPACK_IMPORTED_MODULE_1__[/* getCaveSummary */ "c"])(cave);
        return (react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveItem, { key: cave.id },
            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement("div", { style: {
                    width: "100%",
                    display: "flex",
                    flexDirection: "row",
                    justifyContent: "space-between",
                    alignItems: "center",
                } },
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveDetails, null,
                    react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveDetailsRow, null,
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Title, null, formatUpload(u))),
                    cave.build ? (react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_6___default.a.Fragment, null,
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveDetailsRow, { className: "smaller" },
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__[/* default */ "a"], { icon: "pin" }),
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                            Object(common_format_upload__WEBPACK_IMPORTED_MODULE_4__[/* formatBuildVersionInfo */ "a"])(cave.build),
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { date: cave.build.createdAt }),
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(SpacerLarge, null),
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__[/* default */ "a"], { icon: "checkmark" }),
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                            Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["table.column.powered_by"]),
                            "\u00A0",
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement("a", { target: "_popout", href: "https://itch.io/docs/butler/" }, "butler")))) : null,
                    react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveDetailsRow, { className: "smaller" },
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__[/* default */ "a"], { icon: "tag" }),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                        Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["table.column.published"]),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                        u ? react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { date: u.createdAt }) : null,
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(SpacerLarge, null),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__[/* default */ "a"], { icon: "install" }),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                        Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["table.column.installed"]),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { date: cave.stats.installedAt })),
                    react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveDetailsRow, { className: "smaller" },
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__[/* default */ "a"], { icon: "history" }),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_LastPlayed__WEBPACK_IMPORTED_MODULE_10__[/* default */ "a"], { game: game, cave: caveSummary }),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(SpacerLarge, null),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_9__[/* default */ "a"], { icon: "stopwatch" }),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_TotalPlaytime__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], { game: game, cave: caveSummary }))),
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement("div", { style: { width: "60px" } },
                    react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Cover__WEBPACK_IMPORTED_MODULE_8__[/* default */ "b"], { hover: false, gameId: game.id, coverUrl: game.coverUrl, stillCoverUrl: game.stillCoverUrl }))),
            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(CaveItemBigActions, null,
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* default */ "d"], { icon: "folder-open", onClick: this.onExplore },
                    react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* BigButtonContent */ "a"], null,
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* BigButtonRow */ "b"], null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(Object(common_format_show_in_explorer__WEBPACK_IMPORTED_MODULE_3__[/* showInExplorerString */ "a"])())),
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* BigButtonRow */ "b"], null,
                            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* Tag */ "c"], null, cave.installInfo.installFolder),
                            cave.installInfo.installedSize ? (react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* Tag */ "c"], null,
                                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(FileSize, null, Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_2__[/* fileSize */ "a"])(cave.installInfo.installedSize)))) : null))),
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* default */ "d"], { icon: "repeat", onClick: this.onUpdateCheck },
                    react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* BigButtonContent */ "a"], null,
                        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* BigButtonRow */ "b"], null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["grid.item.check_for_update"])))),
                u ? (react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_6___default.a.Fragment, null, u.channelName == "" ? ("") : (react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_11__[/* default */ "d"], { icon: "shuffle", onClick: this.onSwitchVersion }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["grid.item.revert_to_version"]))))) : null),
            react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_19__[/* ModalButtons */ "b"], null,
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], { icon: "arrow-left", onClick: this.onBack }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["prompt.action.back"])),
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_20__[/* default */ "a"], null),
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], { icon: "repeat", onClick: this.onReinstall, className: "manage-reinstall" }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["prompt.uninstall.reinstall"])),
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_19__[/* ModalButtonSpacer */ "a"], null),
                react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], { icon: "uninstall", onClick: this.onUninstall, className: "manage-uninstall" }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_18__[/* T */ "a"])(["prompt.uninstall.uninstall"])))));
    }
}
/* harmony default export */ __webpack_exports__["default"] = (Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_15__[/* hook */ "a"])()(ManageCave));
function formatUpload(upload) {
    return (react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_6___default.a.Fragment, null,
        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_14__[/* default */ "a"], { upload: upload }),
        react__WEBPACK_IMPORTED_MODULE_6___default.a.createElement(Spacer, null),
        Object(common_format_upload__WEBPACK_IMPORTED_MODULE_4__[/* formatUploadTitle */ "b"])(upload)));
}


/***/ }),

/***/ "./src/renderer/modal-widgets/styles.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalWidgetDiv; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* heavyInput */ "j"]};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=10.chunk.js.map