(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[14],{

/***/ "./src/main/net/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return isNetworkError; });
/* unused harmony export RequestError */
/* unused harmony export RequestTimeout */
/* unused harmony export RequestAborted */
/* unused harmony export RequestFormattingFailure */
/* unused harmony export RequestParsingFailure */
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


/**
 * Returns true if this is a network error
 */
function isNetworkError(e) {
    // this operates under the assumption that:
    //   * all our internal network errors should start with "err::"
    //   * all of chrome's already do
    //   * we transform fetch's into err:: variants.
    // we coerce e.message into a string on the off chance that it's not defined
    // or not a string.
    const isJavaScriptNetworkError = e && ("" + e.message).indexOf("net::") === 0;
    if (isJavaScriptNetworkError) {
        return true;
    }
    const re = Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re) {
        if (re.rpcError.code === common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__["Code"].NetworkDisconnected) {
            return true;
        }
    }
    return false;
}
class RequestError extends Error {
    constructor(message) {
        super(message.indexOf("net::") == 0 ? message : "net::REQUEST_ERROR::");
    }
}
class RequestTimeout extends RequestError {
    constructor() {
        super("TIMED_OUT");
    }
}
class RequestAborted extends RequestError {
    constructor() {
        super("ABORTED");
    }
}
class RequestFormattingFailure extends RequestError {
    constructor(message) {
        super("FORMATTING_FAILURE: " + message);
    }
}
class RequestParsingFailure extends RequestError {
    constructor(message) {
        super("PARSING_FAILURE: " + message);
    }
}


/***/ }),

/***/ "./src/renderer/basics/EmptyState.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/t.tsx");





const EmptyStateDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  color: ${(props) => props.theme.secondaryText};
  width: 100%;
  text-align: center;
  margin: 60px 0;

  .leader {
    display: inline-block;
    font-size: 170px;
    margin-bottom: 20px;
  }

  h1 {
    font-size: ${(props) => props.theme.fontSizes.enormous};
    font-weight: bold;
    margin-bottom: 10px;
  }

  h2 {
    font-size: ${(props) => props.theme.fontSizes.huge};
  }
`;
const ButtonContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  margin: 20px;
  display: inline-block;
`;
const EmptyStateContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  overflow: hidden;
`;
class EmptyState extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
    render() {
        const { bigText, smallText, icon, buttonIcon, buttonText, buttonAction, componentAction, className, } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(EmptyStateContainer, null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(EmptyStateDiv, { className: className },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { icon: icon, className: "leader" }),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h1", null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(bigText)),
                smallText ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h2", null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(smallText)) : null,
                componentAction,
                buttonAction ? (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
                    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(ButtonContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"], { icon: buttonIcon, primary: true, onClick: buttonAction }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(buttonText))))) : null)));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (EmptyState);


/***/ }),

/***/ "./src/renderer/pages/CollectionsPage/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./src/renderer/hocs/withProfile.tsx
var withProfile = __webpack_require__("./src/renderer/hocs/withProfile.tsx");

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// EXTERNAL MODULE: ./src/renderer/basics/TimeAgo.tsx + 1 modules
var TimeAgo = __webpack_require__("./src/renderer/basics/TimeAgo.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/GameStripe.tsx
var GameStripe = __webpack_require__("./src/renderer/pages/common/GameStripe.tsx");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/CollectionsPage/CollectionPreview.tsx








const CollectionGameStripe = Object(GameStripe["a" /* makeGameStripe */])(butlerd["h" /* messages */].FetchCollectionGames);
const CollectionInfo = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;

  font-size: ${(props) => props.theme.fontSizes.baseText};
  color: ${(props) => props.theme.ternaryText};
  font-weight: 700;
  margin: 0 0.5em;
`;
const CollectionInfoSpacer = styles["h" /* default */].div `
  width: 0.4em;
`;
class CollectionPreview_CollectionPreview extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.getGame = CollectionGameStripe.getGameCallback((cg) => cg.game);
        this.renderTitleExtras = () => {
            const { coll } = this.props;
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(CollectionInfoSpacer, null),
                react_default.a.createElement(CollectionInfo, null, Object(t["a" /* T */])(["collection.item_count", { itemCount: coll.gamesCount }])),
                react_default.a.createElement(CollectionInfo, null,
                    Object(t["a" /* T */])(["collection.info.updated"]),
                    react_default.a.createElement(CollectionInfoSpacer, null),
                    react_default.a.createElement(TimeAgo["a" /* default */], { date: coll.updatedAt }))));
        };
    }
    render() {
        const { profile, coll } = this.props;
        return (react_default.a.createElement(CollectionGameStripe, { title: coll.title, href: Object(navigation["h" /* urlForCollection */])(coll.id), params: { profileId: profile.id, collectionId: coll.id }, renderTitleExtras: this.renderTitleExtras, getGame: this.getGame }));
    }
}
/* harmony default export */ var CollectionsPage_CollectionPreview = (Object(withProfile["b" /* withProfile */])(CollectionPreview_CollectionPreview));

// EXTERNAL MODULE: ./src/renderer/series/Series.tsx
var series_Series = __webpack_require__("./src/renderer/series/Series.tsx");

// EXTERNAL MODULE: ./node_modules/reselect/es/index.js
var es = __webpack_require__("./node_modules/reselect/es/index.js");

// CONCATENATED MODULE: ./src/renderer/series/CollectionSeries.tsx




let fallbackGetKey = (c) => c.id;
function makeCollectionSeries(rc) {
    const Series = Object(series_Series["a" /* makeSeries */])(rc);
    class CollectionRecordComponent extends CollectionSeries_GenericCollectionRecordComponent {
    }
    class CollectionSeries extends react_default.a.PureComponent {
        constructor(props, context) {
            super(props, context);
            this.selector = Object(es["a" /* createStructuredSelector */])({});
        }
        render() {
            const { props } = this;
            return (react_default.a.createElement(Series, Object.assign({}, props, { fallbackGetKey: fallbackGetKey, RecordComponent: CollectionRecordComponent, extraProps: this.selector(props) })));
        }
        static getRecordCallback(f) {
            return f;
        }
        static renderItemExtrasCallback(f) {
            return f;
        }
    }
    return CollectionSeries;
}
class CollectionSeries_GenericCollectionRecordComponent extends react_default.a.PureComponent {
    render() {
        const { item, record } = this.props;
        const coll = record;
        return react_default.a.createElement(CollectionsPage_CollectionPreview, { coll: coll });
    }
}

// EXTERNAL MODULE: ./src/renderer/pages/common/SearchControl.tsx + 1 modules
var SearchControl = __webpack_require__("./src/renderer/pages/common/SearchControl.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__("./src/common/constants/urls.ts");

// EXTERNAL MODULE: ./src/renderer/pages/common/Sort.tsx
var Sort = __webpack_require__("./src/renderer/pages/common/Sort.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/CollectionsPage/index.tsx















const ProfileCollectionsSeries = makeCollectionSeries(butlerd["h" /* messages */].FetchProfileCollections);
const CollectionsDiv = styles["h" /* default */].div `
  ${styles["l" /* meat */]};
`;
class CollectionsPage_CollectionsPage extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.getRecord = ProfileCollectionsSeries.getRecordCallback((c) => c);
        this.renderMainFilters = () => {
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(SearchControl["a" /* default */], null),
                react_default.a.createElement(SortsAndFilters["e" /* FilterSpacer */], null),
                react_default.a.createElement(IconButton["a" /* default */], { icon: "more_vert", onClick: this.onMore })));
        };
        this.renderExtraFilters = () => {
            return (react_default.a.createElement(SortsAndFilters["f" /* SortsAndFilters */], null,
                react_default.a.createElement(SortsAndFilters["a" /* FilterGroup */], null,
                    react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "title", label: Object(t["c" /* _ */])("sort_by.collections.title") }),
                    react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "updatedAt", label: Object(t["c" /* _ */])("sort_by.collections.updated_at") }))));
        };
        this.onMore = (ev) => {
            const { dispatch, tab, url } = this.props;
            const { clientX, clientY } = ev;
            dispatch(actions["a" /* actions */].popupContextMenu({
                wind: Object(navigation["d" /* ambientWind */])(),
                clientX,
                clientY,
                template: [
                    {
                        localizedLabel: ["outlinks.manage_collections"],
                        action: actions["a" /* actions */].navigate({
                            wind: Object(navigation["d" /* ambientWind */])(),
                            url: urls["a" /* default */].myCollections,
                        }),
                    },
                ],
            }));
        };
    }
    render() {
        const { profile, search, sortBy, sortDir } = this.props;
        return (react_default.a.createElement(CollectionsDiv, null,
            react_default.a.createElement(ProfileCollectionsSeries, { label: Object(t["c" /* _ */])("sidebar.collections"), getRecord: this.getRecord, params: {
                    profileId: profile.id,
                    sortBy,
                    reverse: sortDir === "reverse",
                    search,
                }, renderMainFilters: this.renderMainFilters, renderExtraFilters: this.renderExtraFilters })));
    }
}
const hooked = Object(hook["b" /* hookWithProps */])(CollectionsPage_CollectionsPage)((map) => ({
    url: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.url),
    sortBy: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.sortBy),
    sortDir: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.sortDir),
    search: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.search),
}))(CollectionsPage_CollectionsPage);
/* harmony default export */ var pages_CollectionsPage = __webpack_exports__["default"] = (Object(withTab["b" /* withTab */])(Object(withProfile["b" /* withProfile */])(hooked)));


/***/ }),

/***/ "./src/renderer/pages/common/GameStripe.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return makeGameStripe; });
/* unused harmony export makeStripeCallbacks */
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var main_net_errors__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/main/net/errors.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/ErrorState.tsx");
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/Floater.tsx");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/pages/common/StandardGameCover.tsx");














const StripeDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  display: flex;
  flex-direction: row;
  align-items: center;
  width: 100%;
  overflow: hidden;
  position: relative;

  height: ${renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__[/* standardCoverHeight */ "b"] + 2}px;

  padding: 1.2em 0;
  margin-bottom: 32px;
`;
const FloaterContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  background: ${(props) => props.theme.breadBackground};
  opacity: 0.7;
  padding: 4px;

  position: absolute;
  left: 5px;
  top: 5px;
  z-index: 20;
`;
const ViewAll = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].a `
  position: absolute;
  background: ${(props) => props.theme.breadBackground};
  box-shadow: 0 0 30px ${(props) => props.theme.breadBackground};
  padding: 0 4em;
  top: 0;
  bottom: 0;
  right: 0;
  display: flex;
  flex-direction: row;
  align-items: center;
  overflow: hidden;

  z-index: 4;
`;
const StripeItemDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* boxy */ "c"]};
  flex-shrink: 0;
  margin-right: 0.8em;
`;
const stripeLimit = 12;
function makeGameStripe(rc) {
    const Call = Object(renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_6__[/* default */ "b"])(rc);
    const hasItems = (result) => {
        if (!result) {
            return false;
        }
        return !Object(underscore__WEBPACK_IMPORTED_MODULE_12__[/* isEmpty */ "k"])(result.items);
    };
    class Stripe extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.renderCallContents = Call.renderCallback(({ result, error, loading }) => (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null,
                this.renderTitle(loading, result, error),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeDiv, null,
                    loading ? (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(FloaterContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], null))) : null,
                    this.renderViewAll(),
                    this.renderItems(result),
                    this.renderEmpty()))));
        }
        render() {
            const { params, sequence } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(Call, { params: Object.assign(Object.assign({}, params), { limit: stripeLimit }), sequence: sequence, loadingHandled: true, errorsHandled: true, render: this.renderCallContents }));
        }
        renderTitle(loading, result, error) {
            const { linkId, href, title, renderTitleExtras = renderNoop, } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null,
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__[/* TitleBox */ "c"], null,
                    react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__[/* Title */ "b"], null,
                        react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement("a", { id: linkId, href: href }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_11__[/* T */ "a"])(title)),
                        renderTitleExtras())),
                this.renderError(result, error)));
        }
        renderError(result, error) {
            if (!error) {
                return null;
            }
            if (hasItems(result) && Object(main_net_errors__WEBPACK_IMPORTED_MODULE_2__[/* isNetworkError */ "a"])(error)) {
                return null;
            }
            return react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { error: error });
        }
        renderItems(result) {
            if (!result) {
                return null;
            }
            if (Object(underscore__WEBPACK_IMPORTED_MODULE_12__[/* isEmpty */ "k"])(result.items)) {
                return null;
            }
            const doneSet = new Set();
            const { getGame } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null, result.items.map((item) => {
                const game = getGame(item);
                if (!game || doneSet.has(game.id)) {
                    return null;
                }
                doneSet.add(game.id);
                return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItem, { key: game.id, className: "stripe--item", "data-game-id": game.id, game: game }));
            })));
        }
        renderEmpty() {
            const { dispatch } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((id) => (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItem, { key: `empty-${id}` })))));
        }
        renderViewAll() {
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(ViewAll, { href: this.props.href }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_11__[/* T */ "a"])(["game_stripe.view_all"])));
        }
    }
    let result = Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_8__[/* withTab */ "b"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__[/* hookWithProps */ "b"])(Stripe)((map) => ({
        sequence: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).sequence),
    }))(Stripe));
    function identity(t) {
        return t;
    }
    let augmentedResult = result;
    augmentedResult.getGameCallback = identity;
    return augmentedResult;
}
function makeStripeCallbacks(rc) {
    return {
        getGame(f) {
            return f;
        },
    };
}
function renderNoop() {
    return null;
}
class StripeItem extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
    render() {
        const _a = this.props, { game } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["game"]);
        return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItemDiv, Object.assign({}, restProps),
            react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], { game: game, showInfo: true })));
    }
}


/***/ }),

/***/ "./src/renderer/pages/common/ItemList.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

/* harmony default export */ __webpack_exports__["a"] = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-grow: 1;
  overflow-y: auto;
  padding: 0 12px;

  user-select: none;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;
`);


/***/ }),

/***/ "./src/renderer/pages/common/SearchControl.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// CONCATENATED MODULE: ./src/renderer/pages/common/FilterInput.tsx


const StyledInput = styles["h" /* default */].input `
  ${styles["q" /* searchInput */]};
  width: 20em;
  padding-left: 10px;
  margin-left: 1.4em;
  border: 1px solid rgba(255, 255, 255, 0.1);
  background: rgba(0, 0, 0, 0.3);
`;
/* harmony default export */ var FilterInput = ((props) => react_default.a.createElement(StyledInput, Object.assign({ type: "search" }, props)));

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__("./node_modules/react-intl/lib/src/components/injectIntl.js");

// CONCATENATED MODULE: ./src/renderer/pages/common/SearchControl.tsx









class SearchControl_SearchControl extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onSearchChange = (e) => {
            this.setSearch(e.currentTarget.value);
        };
        this.setSearch = Object(index_all["a" /* debounce */])((search) => {
            const { url } = this.props;
            Object(tab_utils["c" /* dispatchTabEvolve */])(this.props, {
                replace: true,
                url: Object(tab_utils["l" /* urlWithParams */])(url, { search }),
            });
        }, 250);
    }
    render() {
        const { defaultValue } = this.props;
        return (react_default.a.createElement(FilterInput, { defaultValue: defaultValue, placeholder: Object(t["b" /* TString */])(this.props.intl, ["grid.criterion.filter"]), onChange: this.onSearchChange }));
    }
}
/* harmony default export */ var common_SearchControl = __webpack_exports__["a"] = (Object(withTab["b" /* withTab */])(Object(injectIntl["c" /* default */])(Object(hook["b" /* hookWithProps */])(SearchControl_SearchControl)((map) => ({
    url: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.url),
    defaultValue: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.search),
}))(SearchControl_SearchControl))));


/***/ }),

/***/ "./src/renderer/pages/common/Sort.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SortOption; });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/t.tsx");








const SortOptionBase = (props) => {
    const { url, active, reverse, sortBy, label } = props;
    let href;
    let baseClass = `sortby--${sortBy}`;
    if (!active) {
        baseClass = `${baseClass}--default`;
        href = Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__[/* urlWithParams */ "l"])(url, { sortBy, sortDir: "default" });
    }
    else {
        if (!reverse) {
            baseClass = `${baseClass}--reverse`;
            href = Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__[/* urlWithParams */ "l"])(url, { sortBy, sortDir: "reverse" });
        }
        else {
            baseClass = `${baseClass}--disable`;
            href = Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__[/* urlWithParams */ "l"])(url, { sortBy: undefined, sortDir: undefined });
        }
    }
    return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_6__[/* FilterOptionLink */ "d"], { target: "_replace", href: href, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(baseClass, { active }) },
        react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_6__[/* FilterOptionIcon */ "c"], { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ inactive: !active }), icon: active && reverse ? "sort-amount-desc" : "sort-amount-asc" }),
        Object(renderer_t__WEBPACK_IMPORTED_MODULE_7__[/* T */ "a"])(label)));
};
const hooked = Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_3__[/* hookWithProps */ "b"])(SortOptionBase)((map) => ({
    url: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.url),
    active: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.query.sortBy === props.sortBy),
    reverse: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.query.sortDir === "reverse"),
}))(SortOptionBase);
const SortOption = Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_5__[/* withTab */ "b"])(hooked);


/***/ }),

/***/ "./src/renderer/pages/common/SortsAndFilters.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return SortsAndFilters; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FilterGroup; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return FilterOptionLink; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FilterOptionButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return FilterOptionIcon; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return FilterSpacer; });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const SortsAndFilters = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__[/* FiltersContainerDiv */ "a"]) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* css */ "g"] `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  ${optionButtonLike};
`;
const FilterOptionIcon = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ }),

/***/ "./src/renderer/series/Series.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return makeSeries; });
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var main_net_errors__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/main/net/errors.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var react_fast_compare__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/react-fast-compare/index.js");
/* harmony import */ var react_fast_compare__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react_fast_compare__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var renderer_basics_EmptyState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/EmptyState.tsx");
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/ErrorState.tsx");
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/basics/Floater.tsx");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_common_ItemList__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./src/renderer/pages/common/ItemList.tsx");
/* harmony import */ var renderer_pages_common_Page__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/pages/common/Page.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");

















const LoadMoreContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_14__[/* default */ "h"].div `
  height: 200px;
  display: flex;
  align-items: center;
  justify-content: center;

  &:hover {
    cursor: pointer;
  }
`;
const LoadMoreText = renderer_styles__WEBPACK_IMPORTED_MODULE_14__[/* default */ "h"].div `
  font-size: ${(props) => props.theme.fontSizes.huge};
`;
const limit = 15;
function makeSeries(rc) {
    const Call = Object(renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__[/* default */ "b"])(rc);
    const hasItems = (result) => {
        if (!result) {
            return false;
        }
        return !Object(underscore__WEBPACK_IMPORTED_MODULE_16__[/* isEmpty */ "k"])(result.items);
    };
    class NextPageButton extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.loadNextPage = () => {
                const { cursor, loadNextPage } = this.props;
                loadNextPage(cursor);
            };
        }
        render() {
            const { gotLoadMore } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(LoadMoreContainer, { ref: gotLoadMore, onClick: this.loadNextPage },
                react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(LoadMoreText, null, "Load more...")));
        }
    }
    class SeriesPage extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.renderCallContents = Call.renderCallback(({ result, loading, error }) => {
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_2___default.a.Fragment, null,
                    this.renderError(result, error),
                    this.renderItems(result, loading),
                    this.renderNextPage(result, loading)));
            });
        }
        render() {
            const { params, cursor, limit, sequence } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(Call, { errorsHandled: true, loadingHandled: true, params: Object.assign(Object.assign({}, params), { cursor, limit }), sequence: sequence, render: this.renderCallContents }));
        }
        renderNextPage(result, loading) {
            const { gotLoadMore, loadNextPage, isLast } = this.props;
            if (result && result.nextCursor && isLast) {
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(NextPageButton, { cursor: result.nextCursor, gotLoadMore: gotLoadMore, loadNextPage: loadNextPage }));
            }
            if (!hasItems(result) && loading) {
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(LoadMoreContainer, null,
                    react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], null)));
            }
            return null;
        }
        renderError(result, error) {
            if (!error) {
                return null;
            }
            if (hasItems(result) && Object(main_net_errors__WEBPACK_IMPORTED_MODULE_1__[/* isNetworkError */ "a"])(error)) {
                return null;
            }
            return react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { error: error });
        }
        renderItems(result, loading) {
            if (!hasItems(result)) {
                if (loading) {
                    return null;
                }
                else {
                    return this.renderEmpty();
                }
            }
            const { items } = result;
            const { fallbackGetKey, getKey, getRecord, RecordComponent, extraProps, } = this.props;
            let doneSet = new Set();
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_2___default.a.Fragment, null, items.map((item) => {
                const record = getRecord(item);
                if (!record) {
                    return null;
                }
                const key = getKey ? getKey(item) : fallbackGetKey(record);
                if (doneSet.has(key)) {
                    return null;
                }
                doneSet.add(key);
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(RecordComponent, Object.assign({ key: key, item: item, record: record }, extraProps)));
            })));
        }
        renderEmpty() {
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_EmptyState__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { bigText: Object(renderer_t__WEBPACK_IMPORTED_MODULE_15__[/* _ */ "c"])("empty_state.nothing_to_see_here"), icon: "neutral" }));
        }
    }
    class Series extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
        constructor(props, context) {
            super(props, context);
            this.gotItemList = (itemList) => {
                this.itemList = itemList;
            };
            this.lastScrollTop = 0;
            this.onScroll = Object(underscore__WEBPACK_IMPORTED_MODULE_16__[/* throttle */ "s"])(() => {
                const { itemList } = this;
                if (!itemList) {
                    return;
                }
                const { scrollTop, scrollHeight, clientHeight } = itemList;
                if (scrollTop < this.lastScrollTop) {
                    if (this.restoreScrollInterval) {
                        console.log(`Cancelling scroll restore (scrolled up!)`);
                        clearInterval(this.restoreScrollInterval);
                        this.restoreScrollInterval = null;
                    }
                }
                this.lastScrollTop = scrollTop;
                const runwayLeft = scrollHeight - clientHeight - scrollTop;
                const shouldLoadMore = runwayLeft < 1200;
                const { loadMore } = this;
                if (shouldLoadMore && loadMore) {
                    loadMore.click();
                }
                Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__[/* dispatchTabPageUpdate */ "i"])(this.props, { scrollTop });
            }, 100);
            this.gotLoadMore = (loadMore) => {
                this.loadMore = loadMore;
            };
            this.loadNextPage = (cursor) => {
                this.setState((state) => ({
                    cursors: [...state.cursors, cursor],
                }));
            };
            this.state = {
                cursors: [null],
                lastParams: null,
            };
            if (props.restoredScrollTop) {
                console.log(`Aiming for scrollTop ${props.restoredScrollTop}`);
                this.restoreScrollInterval = window.setInterval(() => {
                    if (this.itemList) {
                        this.itemList.scrollTop = props.restoredScrollTop;
                        const { scrollTop } = this.itemList;
                        if (scrollTop === props.restoredScrollTop) {
                            console.log(`Done adjusting, final scrollTop = ${scrollTop}`);
                            clearInterval(this.restoreScrollInterval);
                            this.restoreScrollInterval = null;
                        }
                    }
                }, 160);
            }
        }
        componentWillUnmount() {
            if (this.restoreScrollInterval) {
                clearInterval(this.restoreScrollInterval);
                this.restoreScrollInterval = null;
            }
        }
        static getDerivedStateFromProps(props, state) {
            if (!react_fast_compare__WEBPACK_IMPORTED_MODULE_3___default()(props.params, state.lastParams)) {
                return {
                    cursors: [null],
                    lastParams: props.params,
                };
            }
            return null;
        }
        getSnapshotBeforeUpdate(prevProps, prevState) {
            if (!react_fast_compare__WEBPACK_IMPORTED_MODULE_3___default()(this.props.params, prevProps.params)) {
                return {
                    resetScroll: true,
                };
            }
            return null;
        }
        componentDidUpdate(props, state, snapshot) {
            if (snapshot && snapshot.resetScroll && this.itemList) {
                console.log(`resetting scrollTop!`);
                this.itemList.scrollTop = 0;
                Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__[/* dispatchTabPageUpdate */ "i"])(this.props, { scrollTop: 0 });
            }
        }
        componentDidMount() {
            const { label } = this.props;
            if (label) {
                Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__[/* dispatchTabPageUpdate */ "i"])(this.props, { label });
            }
        }
        render() {
            const { params, sequence } = this.props;
            const { renderMainFilters = renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__[/* renderNoop */ "c"], renderExtraFilters = renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__[/* renderNoop */ "c"], fallbackGetKey, getKey, getRecord, RecordComponent, extraProps, } = this.props;
            const { cursors } = this.state;
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_Page__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], null,
                react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_6__[/* default */ "b"], { loading: false }, renderMainFilters ? renderMainFilters() : null),
                renderExtraFilters ? renderExtraFilters() : null,
                react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_ItemList__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { className: "series--itemlist", onScroll: this.onScroll, ref: this.gotItemList }, cursors.map((cursor, i) => (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(SeriesPage, { key: i, params: params, cursor: cursor, limit: limit, sequence: sequence, isLast: i === cursors.length - 1, gotLoadMore: this.gotLoadMore, loadNextPage: this.loadNextPage, fallbackGetKey: fallbackGetKey, getKey: getKey, getRecord: getRecord, RecordComponent: RecordComponent, extraProps: extraProps }))))));
        }
    }
    return Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_11__[/* withTab */ "b"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_9__[/* hookWithProps */ "b"])(Series)((map) => ({
        sequence: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_0__[/* ambientTab */ "c"])(rs, props).sequence),
        restoredScrollTop: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_0__[/* ambientPage */ "b"])(rs, props).restoredScrollTop),
    }))(Series));
}


/***/ })

}]);
//# sourceMappingURL=14.chunk.js.map