(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[15],{

/***/ "./src/common/format/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return getDownloadError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return getInstallPlanInfoError; });
/* unused harmony export getButlerdErrorFromTuple */
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");


function formatError(e, apiErrorPrefix) {
    const re = Object(common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re && re.rpcError) {
        const { code, data } = re.rpcError;
        if (data && data.apiError && apiErrorPrefix) {
            const { messages } = data.apiError;
            const message = Object(underscore__WEBPACK_IMPORTED_MODULE_1__[/* first */ "h"])(messages);
            if (message) {
                const snakeCaseMessage = message.replace(/\s/g, "_").toLowerCase();
                return [
                    `errors.api.${apiErrorPrefix}.${snakeCaseMessage}`,
                    {
                        defaultValue: `{message}`,
                        message,
                    },
                ];
            }
        }
        const { message } = re.rpcError;
        return [
            `butlerd.codes.${code}`,
            {
                defaultValue: `{message}`,
                message,
            },
        ];
    }
    return e.message;
}
function getDownloadError(item) {
    return getButlerdErrorFromTuple(item);
}
function getInstallPlanInfoError(item) {
    return getButlerdErrorFromTuple(item);
}
function getButlerdErrorFromTuple(item) {
    if (!item.errorMessage) {
        return null;
    }
    let rawError = new Error(item.errorMessage);
    rawError.stack = item.error;
    rawError.rpcError = {
        code: item.errorCode,
        message: item.errorMessage,
        data: {
            stack: item.error,
        },
    };
    return rawError;
}


/***/ }),

/***/ "./src/common/format/upload.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return formatUploadTitle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return formatUploadTitleFancy; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatBuildVersionInfo; });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ "./src/renderer/basics/EmptyState.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/t.tsx");





const EmptyStateDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  color: ${(props) => props.theme.secondaryText};
  width: 100%;
  text-align: center;
  margin: 60px 0;

  .leader {
    display: inline-block;
    font-size: 170px;
    margin-bottom: 20px;
  }

  h1 {
    font-size: ${(props) => props.theme.fontSizes.enormous};
    font-weight: bold;
    margin-bottom: 10px;
  }

  h2 {
    font-size: ${(props) => props.theme.fontSizes.huge};
  }
`;
const ButtonContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  margin: 20px;
  display: inline-block;
`;
const EmptyStateContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  overflow: hidden;
`;
class EmptyState extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
    render() {
        const { bigText, smallText, icon, buttonIcon, buttonText, buttonAction, componentAction, className, } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(EmptyStateContainer, null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(EmptyStateDiv, { className: className },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { icon: icon, className: "leader" }),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h1", null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(bigText)),
                smallText ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h2", null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(smallText)) : null,
                componentAction,
                buttonAction ? (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
                    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(ButtonContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"], { icon: buttonIcon, primary: true, onClick: buttonAction }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(buttonText))))) : null)));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (EmptyState);


/***/ }),

/***/ "./src/renderer/basics/Link.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* secondaryLink */ "r"]};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_1___default.a.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Link);
class Props {
}


/***/ }),

/***/ "./src/renderer/basics/MainAction.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/helpers/get-game-status.ts");
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/common/util/action-for-game.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/basics/IconButton.tsx");
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var common_helpers_secret_click__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/common/helpers/secret-click.ts");












class MainAction extends react__WEBPACK_IMPORTED_MODULE_4___default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            e.stopPropagation();
            const { dispatch, game, status } = this.props;
            const { operation, update, cave, access } = status;
            if (Object(common_helpers_secret_click__WEBPACK_IMPORTED_MODULE_11__[/* isSecretClick */ "a"])(e)) {
                if (cave) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].viewCaveDetails({ caveId: cave.id }));
                }
                return;
            }
            if (operation) {
                if (operation.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Download) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].navigate({ wind: "root", url: "itch://downloads" }));
                }
                else if (operation.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Task) {
                    if (operation.name === "launch") {
                        dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].forceCloseGameRequest({ game }));
                    }
                }
            }
            else if (cave) {
                if (update) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].showGameUpdate({ update }));
                }
                else {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].queueGame({ game }));
                }
            }
            else {
                if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].None) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].initiatePurchase({ game }));
                }
                else {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].queueGame({ game }));
                }
            }
        };
    }
    render() {
        const { wide } = this.props;
        const { cave, access, operation, update } = this.props.status;
        let translucent = false;
        let iconComponent;
        let icon;
        let label;
        let primary = false;
        if (operation) {
            const { type, progress } = operation;
            translucent = true;
            if (operation.paused) {
                iconComponent = react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__[/* default */ "a"], { icon: "stopwatch" });
            }
            else if (!operation.active) {
                iconComponent = react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__[/* default */ "a"], { icon: "stopwatch" });
            }
            else {
                iconComponent = (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_8__[/* default */ "a"], { bare: true, wide: wide, progress: progress > 0 ? progress : 0.1 }));
            }
            if (type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Download) {
                if (operation.paused) {
                    label = ["grid.item.downloads_paused"];
                }
                else if (operation.active) {
                    label = ["grid.item.installing"];
                }
                else {
                    label = ["grid.item.queued"];
                }
            }
            else if (type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Task) {
                const { name, stage } = operation;
                if (name === "launch") {
                    if (stage === "prepare") {
                        label = ["grid.item.running.prepare"];
                    }
                    else if (stage === "clean") {
                        label = ["grid.item.running.clean"];
                    }
                    else {
                        label = ["grid.item.running"];
                    }
                }
                else if (name === "uninstall") {
                    label = ["grid.item.uninstalling"];
                }
                else if (name === "install-queue") {
                    label = ["grid.item.queueing"];
                }
                else {
                    label = ["grid.item.installing"];
                }
            }
        }
        else if (cave) {
            if (update) {
                label = ["grid.item.update"];
                icon = "star";
            }
            else {
                const action = Object(common_util_action_for_game__WEBPACK_IMPORTED_MODULE_3__[/* actionForGame */ "a"])(this.props.game, cave);
                label = [`grid.item.${action}`];
                if (action === "open") {
                    icon = "folder-open";
                }
                else {
                    icon = "play2";
                }
                primary = true;
            }
        }
        else {
            if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Demo || access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Press) {
                label = ["grid.item.review"];
                icon = "install";
            }
            else if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Pwyw ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Free ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Key ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Edit) {
                label = ["grid.item.install"];
                icon = "install";
            }
            else {
                label = ["grid.item.buy_now"];
                icon = "shopping_cart";
            }
        }
        if (!label) {
            return null;
        }
        const { iconOnly, className } = this.props;
        if (iconOnly) {
            if (!iconComponent) {
                if (icon) {
                    iconComponent = react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__[/* default */ "a"], { icon: icon });
                }
            }
            return (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], { onClick: this.onClick, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(className, "main-action"), "data-game-id": this.props.game.id, icon: iconComponent, hint: label, hintPosition: "left" }));
        }
        return (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { onClick: this.onClick, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(className, "main-action"), wide: wide, translucent: translucent, iconComponent: iconComponent, label: Object(renderer_t__WEBPACK_IMPORTED_MODULE_9__[/* T */ "a"])(label), primary: primary, "data-game-id": this.props.game.id }));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__[/* hook */ "a"])()(MainAction));


/***/ }),

/***/ "./src/renderer/basics/UploadIcon.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__("./src/common/format/filesize.ts");

// EXTERNAL MODULE: ./src/common/constants/platform-data.ts
var platform_data = __webpack_require__("./src/common/constants/platform-data.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// CONCATENATED MODULE: ./src/main/reactors/make-upload-button.ts



function makeUploadButton(upload, opts = { showSize: true }) {
    let label = `${upload.displayName || upload.filename}`;
    let tags = [];
    if (upload.size > 0 && opts.showSize) {
        tags.push({
            label: `${Object(filesize["a" /* fileSize */])(upload.size)}`,
        });
    }
    if (upload.demo) {
        tags.push({
            label: ["pick_update_upload.tags.demo"],
        });
    }
    for (const prop of Object.keys(platform_data["a" /* default */])) {
        if (upload[prop]) {
            tags.push({
                icon: platform_data["a" /* default */][prop].icon,
            });
        }
    }
    const timeAgo = {
        date: upload.updatedAt,
    };
    const icon = uploadIcon(upload) || "download";
    return { label, tags, icon, timeAgo };
}
const uploadIcons = {
    [messages["UploadType"].Default]: "gamepad",
    [messages["UploadType"].Flash]: "neutral",
    [messages["UploadType"].Unity]: "neutral",
    [messages["UploadType"].Java]: "neutral",
    [messages["UploadType"].HTML]: "html5",
    [messages["UploadType"].Soundtrack]: "music",
    [messages["UploadType"].Book]: "book",
    [messages["UploadType"].Video]: "video",
    [messages["UploadType"].Documentation]: "book",
    [messages["UploadType"].Mod]: "shirt",
    [messages["UploadType"].AudioAssets]: "file-music",
    [messages["UploadType"].GraphicalAssets]: "images",
    [messages["UploadType"].Sourcecode]: "code",
    [messages["UploadType"].Other]: "zip",
};
function uploadIcon(upload) {
    return uploadIcons[upload.type];
}
// TODO: i18n that stuff
const uploadTypeHints = {
    [messages["UploadType"].Default]: "File",
    [messages["UploadType"].Flash]: "Flash embed",
    [messages["UploadType"].Unity]: "Unity embed (legacy)",
    [messages["UploadType"].Java]: "Java applet",
    [messages["UploadType"].HTML]: "HTML5 app",
    [messages["UploadType"].Soundtrack]: "Soundtrack",
    [messages["UploadType"].Book]: "Book",
    [messages["UploadType"].Video]: "Video",
    [messages["UploadType"].Documentation]: "Documentation",
    [messages["UploadType"].Mod]: "Mod",
    [messages["UploadType"].AudioAssets]: "Audio assets",
    [messages["UploadType"].GraphicalAssets]: "Graphical assets",
    [messages["UploadType"].Sourcecode]: "Source code",
    [messages["UploadType"].Other]: "Other",
};
function uploadTypeHint(upload) {
    return uploadTypeHints[upload.type];
}

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/UploadIcon.tsx



class UploadIcon_UploadIcon extends react_default.a.PureComponent {
    render() {
        const { upload } = this.props;
        if (!upload) {
            return null;
        }
        return react_default.a.createElement(Icon["a" /* default */], { icon: uploadIcon(upload), hint: uploadTypeHint(upload) });
    }
}
/* harmony default export */ var basics_UploadIcon = __webpack_exports__["a"] = (UploadIcon_UploadIcon);


/***/ }),

/***/ "./src/renderer/pages/DownloadsPage/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/main/reactors/downloads/getters.ts
var getters = __webpack_require__("./src/main/reactors/downloads/getters.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__("./src/renderer/basics/Button.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/EmptyState.tsx
var EmptyState = __webpack_require__("./src/renderer/basics/EmptyState.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Link.tsx
var Link = __webpack_require__("./src/renderer/basics/Link.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./src/renderer/basics/Cover/index.tsx + 2 modules
var Cover = __webpack_require__("./src/renderer/basics/Cover/index.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/TimeAgo.tsx + 1 modules
var TimeAgo = __webpack_require__("./src/renderer/basics/TimeAgo.tsx");

// EXTERNAL MODULE: ./src/renderer/helpers/whenClickNavigates.ts
var whenClickNavigates = __webpack_require__("./src/renderer/helpers/whenClickNavigates.ts");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./src/common/format/upload.ts
var format_upload = __webpack_require__("./src/common/format/upload.ts");

// CONCATENATED MODULE: ./src/renderer/pages/DownloadsPage/GameUpdateRow.tsx












const GameUpdateRowDiv = styles["h" /* default */].div `
  flex-shrink: 0;
  line-height: 1.6;

  background-color: ${(props) => props.theme.itemBackground};

  display: flex;
  flex-direction: row;
  align-items: center;

  margin: 0.4em 0;
  padding: 0 4px;
  border-radius: 2px;
`;
const GameUpdateInfo = styles["h" /* default */].div `
  margin: 0;
  padding: 8px;
`;
const GameUpdateControls = styles["h" /* default */].div `
  margin: 0;
  padding: 8px;
`;
const GameCover = styles["h" /* default */].div `
  flex-basis: 60px;
  padding: 8px;
`;
const GameTitle = styles["h" /* default */].div `
  display: inline-block;
  font-weight: bold;
  cursor: pointer;
`;
const StyledTimeAgo = Object(styles["h" /* default */])(TimeAgo["a" /* default */]) `
  color: ${(props) => props.theme.secondaryText};
`;
const VersionInfo = styles["h" /* default */].div `
  color: ${(props) => props.theme.secondaryText};
`;
class GameUpdateRow_GameUpdateRow extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onUpdate = () => {
            const { update, dispatch } = this.props;
            dispatch(actions["a" /* actions */].showGameUpdate({ update }));
        };
        this.onNavigate = (e) => {
            const { update, dispatch } = this.props;
            const { game } = update;
            dispatch(actions["a" /* actions */].navigate({
                wind: "root",
                url: Object(navigation["i" /* urlForGame */])(game.id),
                background: Object(whenClickNavigates["a" /* doesEventMeanBackground */])(e),
            }));
        };
    }
    render() {
        const { update } = this.props;
        const { game } = update;
        const { upload, build } = update.choices[0];
        let updatedAt = build ? build.updatedAt : upload.updatedAt;
        let versionInfo = Object(format_upload["a" /* formatBuildVersionInfo */])(build);
        return (react_default.a.createElement(GameUpdateRowDiv, null,
            react_default.a.createElement(GameCover, null,
                react_default.a.createElement(Cover["b" /* default */], { gameId: game.id, coverUrl: game.coverUrl, stillCoverUrl: game.stillCoverUrl, showGifMarker: false, onClick: this.onNavigate, hover: false })),
            react_default.a.createElement(GameUpdateInfo, null,
                react_default.a.createElement(GameTitle, { onClick: this.onNavigate }, game.title),
                react_default.a.createElement(VersionInfo, null,
                    versionInfo ? react_default.a.createElement(react_default.a.Fragment, null,
                        versionInfo,
                        " \u2014 ") : null,
                    react_default.a.createElement(StyledTimeAgo, { date: updatedAt }))),
            react_default.a.createElement(Filler["a" /* default */], null),
            react_default.a.createElement(GameUpdateControls, null,
                react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["pick_update_upload.buttons.update"]), onClick: this.onUpdate }))));
    }
}
/* harmony default export */ var DownloadsPage_GameUpdateRow = (Object(hook["a" /* hook */])()(GameUpdateRow_GameUpdateRow));

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/common/format/errors.ts
var errors = __webpack_require__("./src/common/format/errors.ts");

// EXTERNAL MODULE: ./src/common/format/operation.ts
var format_operation = __webpack_require__("./src/common/format/operation.ts");

// EXTERNAL MODULE: ./src/common/helpers/get-game-status.ts + 1 modules
var get_game_status = __webpack_require__("./src/common/helpers/get-game-status.ts");

// EXTERNAL MODULE: ./src/common/modals/index.ts + 1 modules
var modals = __webpack_require__("./src/common/modals/index.ts");

// EXTERNAL MODULE: ./node_modules/polished/dist/polished.esm.js + 10 modules
var polished_esm = __webpack_require__("./node_modules/polished/dist/polished.esm.js");

// EXTERNAL MODULE: ./src/renderer/basics/DownloadProgressSpan.tsx
var DownloadProgressSpan = __webpack_require__("./src/renderer/basics/DownloadProgressSpan.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/MainAction.tsx
var MainAction = __webpack_require__("./src/renderer/basics/MainAction.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/UploadIcon.tsx + 1 modules
var UploadIcon = __webpack_require__("./src/renderer/basics/UploadIcon.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withHover.tsx + 1 modules
var withHover = __webpack_require__("./src/renderer/hocs/withHover.tsx");

// EXTERNAL MODULE: ./node_modules/react-container-dimensions/lib/index.js
var lib = __webpack_require__("./node_modules/react-container-dimensions/lib/index.js");
var lib_default = /*#__PURE__*/__webpack_require__.n(lib);

// CONCATENATED MODULE: ./src/renderer/pages/DownloadsPage/Chart.tsx



const ChartWrapper = styles["h" /* default */].div `
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  pointer-events: none;
`;
class Chart_ChartGradient extends react_default.a.PureComponent {
    render() {
        return (react_default.a.createElement("linearGradient", { id: "downloadGradient", x1: "0", x2: "0", y1: "0", y2: "1" },
            react_default.a.createElement("stop", { offset: "0%", stopColor: "rgb(158, 150, 131)", stopOpacity: "0.2" }),
            react_default.a.createElement("stop", { offset: "50%", stopColor: "rgb(158, 150, 131)", stopOpacity: "0.2" }),
            react_default.a.createElement("stop", { offset: "100%", stopColor: "rgb(158, 150, 131)", stopOpacity: "0.1" })));
    }
}
class Chart_Chart extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.renderContent = ({ width, height }) => {
            const { data } = this.props;
            let clipPathId = "clipPath" + Date.now();
            let max = 10; // enforce a minimum so we don't get NaNs
            for (const point of data) {
                if (point > max) {
                    max = point;
                }
            }
            max *= 1.1;
            const xs = width / (data.length - 1);
            const ys = height / max;
            let pathString = `M0,${height}`;
            for (let x = 0; x < data.length; x++) {
                let y = data[x];
                pathString += `L${x * xs},${height - y * ys}`;
            }
            pathString += `L${data.length * xs},${height}`;
            pathString += `L0,${height}`;
            pathString += "Z";
            return (react_default.a.createElement("svg", { width: width, height: height, version: "1.1", viewBox: `0 0 ${width} ${height}` },
                react_default.a.createElement("defs", null,
                    react_default.a.createElement("clipPath", { id: clipPathId },
                        react_default.a.createElement("rect", { width: width, height: height, x: 0, y: 0 })),
                    react_default.a.createElement(Chart_ChartGradient, null)),
                react_default.a.createElement("g", { clipPath: `#${clipPathId}` },
                    react_default.a.createElement("path", { d: pathString, fill: "url(#downloadGradient)", height: height, width: width, stroke: "none" }))));
        };
    }
    render() {
        return (react_default.a.createElement(ChartWrapper, null,
            react_default.a.createElement(lib_default.a, null, this.renderContent)));
    }
}
/* harmony default export */ var DownloadsPage_Chart = (Chart_Chart);

// EXTERNAL MODULE: ./src/renderer/pages/PageStyles/games.tsx
var games = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/DownloadsPage/Row.tsx


























const TitleCompact = Object(styles["h" /* default */])(games["b" /* Title */]) `
  font-size: ${(props) => props.theme.fontSizes.larger};
  padding-bottom: 0.2em;
`;
const DownloadRowDiv = styles["h" /* default */].div `
  font-size: ${(props) => props.theme.fontSizes.large};
  position: relative;

  border: 1px solid transparent;
  transition: all 0.4s;

  background-color: ${(props) => props.theme.inputBackground};
  margin: 14px 0;

  &.first {
    padding-bottom: 4px;
  }

  &.has-operation {
    background-color: ${(props) => Object(polished_esm["b" /* lighten */])(0.05, props.theme.inputBackground)};
    border-color: ${(props) => Object(polished_esm["b" /* lighten */])(0.2, props.theme.inputBackground)};
  }

  display: flex;
  flex-direction: row;
  align-items: center;

  .stats {
    flex-grow: 1;
  }

  .stats--control {
    .control-title,
    .control--details {
      white-space: nowrap;
      max-width: 500px;
      text-overflow: ellipsis;
    }

    .control--details,
    .control--status {
      font-size: ${(props) => props.theme.fontSizes.baseText};

      display: flex;
      flex-direction: row;
      align-items: center;

      padding: 0.1em 0;
      padding-top: 0.4em;
    }

    .control--error {
      padding: 0.1em 0;
      line-height: 1.4;

      max-width: 500px;

      color: ${(props) => props.theme.baseColors.carnation};
    }

    .control--details {
      color: ${(props) => props.theme.secondaryText};
    }

    .progress {
      ${styles["o" /* progress */]};

      position: absolute;
      left: 0;
      right: 0;
      bottom: 0;
      height: 4px;

      overflow: hidden;
      &,
      .progress-inner {
        border-radius: 5px;
      }
      .progress-inner.indeterminate {
        animation: ${styles["b" /* animations */].horizontalIndeterminate} 2.4s ease-in-out
          infinite;
      }
    }
  }

  &:not(.first) {
    .progress {
      display: none;
    }
  }
`;
const Row_Filler = styles["h" /* default */].div `
  flex-grow: 1;
`;
const Spacer = styles["h" /* default */].div `
  height: 1px;
  min-width: 8px;
`;
const coverFactor = 1.2;
const coverStyle = () => styles["g" /* css */] `
  flex-shrink: 0;
  width: ${105 * coverFactor}px;
  height: ${80 * coverFactor}px;
  padding-bottom: 0;

  margin-right: 16px;
  box-shadow: 0 0 20px rgba(0, 0, 0, 0.4);
`;
const StyledCover = Object(styles["h" /* default */])(Cover["b" /* default */]) `
  ${coverStyle()};

  &.hasError {
    filter: grayscale(100%);
  }
`;
const Controls = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;
  padding-left: 8px;
  padding-right: 8px;
`;
class Row_DownloadRow extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onCoverContextMenu = (ev) => {
            ev.preventDefault();
            const { item, dispatch } = this.props;
            const { game } = item;
            dispatch(actions["a" /* actions */].openGameContextMenu({
                game,
                wind: Object(navigation["d" /* ambientWind */])(),
                clientX: ev.clientX,
                clientY: ev.pageY,
            }));
        };
        this.onNavigate = (ev) => {
            const { item, dispatch } = this.props;
            if (ev.shiftKey && ev.ctrlKey) {
                dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].exploreJson.make({
                    wind: "root",
                    title: "Download data",
                    message: "",
                    widgetParams: {
                        data: item,
                    },
                })));
                return;
            }
            const background = Object(whenClickNavigates["a" /* doesEventMeanBackground */])(ev);
            const { game } = item;
            dispatch(actions["a" /* actions */].navigate({
                wind: "root",
                url: Object(navigation["i" /* urlForGame */])(game.id),
                background,
            }));
        };
        this.onDiscard = () => {
            const { id } = this.props.item;
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].discardDownload({ id }));
        };
        this.onPrioritize = () => {
            const { id } = this.props.item;
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].prioritizeDownload({ id }));
        };
        this.onShowError = (ev) => {
            ev.stopPropagation();
            const { id } = this.props.item;
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].showDownloadError({ id }));
        };
        this.state = {};
    }
    render() {
        const { first, finished, item, speeds } = this.props;
        const { game } = item;
        const { coverUrl, stillCoverUrl } = game;
        const itemClasses = classnames_default()("download-row-item", {
            first,
            dimmed: !finished && !first,
            finished,
            ["has-operation"]: !!this.props.status.operation,
        });
        const { hover, onMouseEnter, onMouseLeave } = this.props;
        return (react_default.a.createElement(DownloadRowDiv, { className: itemClasses, "data-game-id": item.game.id, onContextMenu: this.onCoverContextMenu, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave },
            first ? react_default.a.createElement(DownloadsPage_Chart, { data: speeds }) : null,
            react_default.a.createElement(StyledCover, { hover: hover, coverUrl: coverUrl, stillCoverUrl: stillCoverUrl, gameId: game.id, onClick: this.onNavigate, className: classnames_default()({ hasError: !!item.error }) }),
            react_default.a.createElement("div", { className: "stats" }, this.progress()),
            this.controls()));
    }
    controls() {
        const { first, status, item } = this.props;
        if (!status.operation && item.error) {
            return (react_default.a.createElement(Controls, null,
                react_default.a.createElement(Button["a" /* default */], { label: Object(t["a" /* T */])(["grid.item.view_details"]), onClick: this.onShowError })));
        }
        let showPrioritize = !item.finishedAt && !first;
        let showMainAction = !status.operation || status.operation.type !== get_game_status["b" /* OperationType */].Download;
        return (react_default.a.createElement(Controls, null,
            showPrioritize ? (react_default.a.createElement(IconButton["a" /* default */], { big: true, hint: Object(t["c" /* _ */])("grid.item.prioritize_download"), icon: "caret-up", onClick: this.onPrioritize })) : null,
            showMainAction ? (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(MainAction["a" /* default */], { game: item.game, status: status, caveId: item.caveId }),
                react_default.a.createElement(Spacer, null))) : null,
            react_default.a.createElement(IconButton["a" /* default */], { big: true, hintPosition: "left", hint: Object(t["c" /* _ */])("grid.item.discard_download"), icon: "cross", onClick: this.onDiscard })));
    }
    progress() {
        const { first, finished, status, downloadsPaused } = this.props;
        const { operation } = status;
        if (finished) {
            return (react_default.a.createElement("div", { className: "stats--control" },
                this.renderTitle(),
                this.renderDetails(),
                this.renderErrorOrTimestamp()));
        }
        const { progress = 0, bps, eta } = status.operation;
        const progressInnerStyle = {};
        const positiveProgress = progress > 0;
        const hasNonDownloadTask = operation && operation.type !== get_game_status["b" /* OperationType */].Download;
        const indeterminate = (first || hasNonDownloadTask) && !downloadsPaused && !positiveProgress;
        if (indeterminate) {
            progressInnerStyle.width = `${100 / 3}%`;
        }
        else {
            progressInnerStyle.width = `${progress * 100}%`;
        }
        if (this.props.downloadsPaused) {
            progressInnerStyle.filter = "grayscale(100%)";
        }
        return (react_default.a.createElement("div", { className: "stats--control" },
            this.renderTitle(),
            this.renderDetails(),
            react_default.a.createElement("div", { className: "progress" },
                react_default.a.createElement("div", { className: classnames_default()("progress-inner", {
                        indeterminate,
                    }), style: progressInnerStyle })),
            react_default.a.createElement("div", { className: "control--status" },
                this.renderStatus(),
                react_default.a.createElement(Row_Filler, null),
                react_default.a.createElement(react_default.a.Fragment, null, !operation.paused && first && eta >= 0 && bps ? (react_default.a.createElement(react_default.a.Fragment, null,
                    react_default.a.createElement(Spacer, null),
                    react_default.a.createElement(DownloadProgressSpan["a" /* default */], { eta: eta, bps: bps, downloadsPaused: operation.paused }))) : null))));
    }
    renderTitle() {
        const { game } = this.props.item;
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(TitleCompact, { className: "control--title" },
                react_default.a.createElement("a", { href: Object(navigation["i" /* urlForGame */])(game.id) }, game.title)),
            react_default.a.createElement(Row_Filler, null)));
    }
    renderDetails() {
        return react_default.a.createElement("div", { className: "control--details" }, this.renderUpload());
    }
    renderErrorOrTimestamp() {
        const { error, finishedAt, reason } = this.props.item;
        if (!error) {
            const outcomeText = Object(format_operation["b" /* formatOutcome */])(reason);
            return (react_default.a.createElement("div", { className: "control--status" },
                react_default.a.createElement(TimeAgo["a" /* default */], { date: finishedAt }),
                outcomeText ? (react_default.a.createElement(react_default.a.Fragment, null,
                    react_default.a.createElement(Spacer, null),
                    "—",
                    react_default.a.createElement(Spacer, null),
                    Object(t["a" /* T */])(outcomeText))) : null));
        }
        return (react_default.a.createElement("div", { className: "control--error" },
            Object(t["a" /* T */])(["prompt.install_error.title"]),
            " ",
            Object(t["a" /* T */])(Object(errors["a" /* formatError */])(Object(errors["b" /* getDownloadError */])(this.props.item)))));
    }
    renderUpload() {
        const { item } = this.props;
        const { upload } = item;
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(UploadIcon["a" /* default */], { upload: upload }),
            react_default.a.createElement(Spacer, null),
            Object(format_upload["b" /* formatUploadTitle */])(upload)));
    }
    renderStatus() {
        const { status, first } = this.props;
        const { operation } = status;
        if (operation.paused || !first) {
            return Object(t["a" /* T */])(["grid.item.queued"]);
        }
        return this.formatOperation(operation);
    }
    formatOperation(op) {
        if (op.type === get_game_status["b" /* OperationType */].Download) {
            const { item } = this.props;
            const reasonText = Object(format_operation["c" /* formatReason */])(op.reason);
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(TimeAgo["a" /* default */], { before: Object(t["a" /* T */])(["download.started"]), date: new Date(item.startedAt) }),
                reasonText ? (react_default.a.createElement(react_default.a.Fragment, null,
                    react_default.a.createElement(Spacer, null),
                    "—",
                    react_default.a.createElement(Spacer, null),
                    Object(t["a" /* T */])(reasonText))) : ("")));
        }
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(LoadingCircle["a" /* default */], { progress: op.progress }),
            Object(t["a" /* T */])(Object(format_operation["a" /* formatOperation */])(op))));
    }
}
/* harmony default export */ var Row = (Object(withHover["a" /* default */])(Object(hook["b" /* hookWithProps */])(Row_DownloadRow)((map) => ({
    speeds: map((rs) => rs.downloads.speeds),
    downloadsPaused: map((rs) => rs.downloads.paused),
    status: map((rs, props) => Object(get_game_status["c" /* default */])(rs, props.item.game, props.item.caveId)),
}))(Row_DownloadRow)));

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// CONCATENATED MODULE: ./src/renderer/pages/DownloadsPage/index.tsx

















const PauseResumeButton = Object(styles["h" /* default */])(Button["a" /* default */]) `
  min-width: 210px;
`;
const DownloadsDiv = styles["h" /* default */].div `
  ${styles["l" /* meat */]};
`;
const DownloadsContentDiv = styles["h" /* default */].div `
  overflow-y: auto;
  padding: 0 20px 20px 10px;
  padding-top: 15px;
  position: relative;

  .global-controls {
    float: right;
  }

  .section-bar {
    display: flex;
    flex-direction: row;
    align-items: center;
    margin: 20px 0 20px 10px;
    flex-shrink: 0;

    .spacer {
      height: 1px;
      width: 1em;
    }

    .filler {
      flex-grow: 1;
    }

    .clear {
      margin-left: 8px;
      ${styles["d" /* clickable */]};
    }
  }

  .game-actions .main-action {
    padding: 3px 10px;
  }
`;
class DownloadsPage_DownloadsPage extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.visitFeatured = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].navigate({ wind: "root", url: "itch://featured" }));
        };
        this.onTogglePause = () => {
            const { downloadsPaused, dispatch } = this.props;
            dispatch(actions["a" /* actions */].setDownloadsPaused({ paused: !downloadsPaused }));
        };
        this.clearFinishedDownloads = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].clearFinishedDownloads({}));
        };
        this.onUpdateAll = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].queueAllGameUpdates({}));
        };
    }
    componentDidMount() {
        Object(tab_utils["i" /* dispatchTabPageUpdate */])(this.props, {
            label: ["sidebar.downloads"],
        });
    }
    render() {
        return react_default.a.createElement(DownloadsDiv, null, this.renderContents());
    }
    renderContents() {
        const { items, finishedItems, updates, dispatch } = this.props;
        const allEmpty = Object(index_all["k" /* isEmpty */])(items) && Object(index_all["k" /* isEmpty */])(finishedItems) && Object(index_all["k" /* isEmpty */])(updates);
        if (allEmpty) {
            return (react_default.a.createElement(DownloadsContentDiv, null,
                this.renderControls(),
                react_default.a.createElement(EmptyState["a" /* default */], { className: "no-active-downloads", icon: "download", bigText: Object(t["c" /* _ */])("status.downloads.no_active_downloads"), smallText: Object(t["c" /* _ */])("status.downloads.no_active_downloads_subtext"), buttonIcon: "earth", buttonText: Object(t["c" /* _ */])("status.downloads.find_games_button"), buttonAction: this.visitFeatured })));
        }
        const firstItem = Object(index_all["h" /* first */])(items);
        const queuedItems = Object(index_all["o" /* rest */])(items);
        return (react_default.a.createElement(DownloadsContentDiv, null,
            this.renderControls(),
            this.renderFirstItem(firstItem),
            this.renderQueuedItems(queuedItems),
            this.renderRecentActivity(),
            this.renderUpdates()));
    }
    renderFirstItem(firstItem) {
        if (!firstItem) {
            return null;
        }
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement("div", { className: "section-bar" },
                react_default.a.createElement(games["b" /* Title */], null, Object(t["a" /* T */])(["status.downloads.category.active"]))),
            react_default.a.createElement(Row, { key: firstItem.id, item: firstItem, first: true })));
    }
    renderQueuedItems(queuedItems) {
        if (Object(index_all["k" /* isEmpty */])(queuedItems)) {
            return null;
        }
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement("div", { className: "section-bar" },
                react_default.a.createElement(games["b" /* Title */], null, Object(t["a" /* T */])(["status.downloads.category.queued"]))),
            Object(index_all["l" /* map */])(queuedItems, (item, i) => (react_default.a.createElement(Row, { key: item.id, item: item })))));
    }
    renderUpdates() {
        const { updates, updateCheckHappening, updateCheckProgress } = this.props;
        if (Object(index_all["k" /* isEmpty */])(updates) && !updateCheckHappening) {
            return null;
        }
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement("div", { className: "section-bar" },
                react_default.a.createElement(games["b" /* Title */], { className: "finished-header" },
                    react_default.a.createElement("span", null,
                        Object(t["a" /* T */])(["status.downloads.updates_available"]),
                        " (",
                        Object(index_all["q" /* size */])(updates),
                        ")")),
                react_default.a.createElement(SortsAndFilters["e" /* FilterSpacer */], null),
                react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["status.downloads.update_all"]), onClick: this.onUpdateAll }),
                updateCheckHappening ? (react_default.a.createElement(react_default.a.Fragment, null,
                    react_default.a.createElement("div", { className: "spacer" }),
                    react_default.a.createElement(LoadingCircle["a" /* default */], { progress: updateCheckProgress }))) : null),
            Object(index_all["l" /* map */])(updates, (update, k) => (react_default.a.createElement(DownloadsPage_GameUpdateRow, { key: k, update: update })))));
    }
    renderControls() {
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement("div", { className: "global-controls" }, this.props.downloadsPaused ? (react_default.a.createElement(PauseResumeButton, { icon: "triangle-right", onClick: this.onTogglePause }, Object(t["a" /* T */])(["status.downloads.resume_downloads"]))) : (react_default.a.createElement(PauseResumeButton, { icon: "pause", onClick: this.onTogglePause }, Object(t["a" /* T */])(["status.downloads.pause_downloads"]))))));
    }
    renderRecentActivity() {
        const { finishedItems, dispatch } = this.props;
        if (Object(index_all["k" /* isEmpty */])(finishedItems)) {
            return null;
        }
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement("div", { key: "finished-header", className: "section-bar" },
                react_default.a.createElement(games["b" /* Title */], { className: "finished-header" }, Object(t["a" /* T */])(["status.downloads.category.recent_activity"])),
                react_default.a.createElement(SortsAndFilters["e" /* FilterSpacer */], null),
                react_default.a.createElement(Link["a" /* default */], { className: "downloads-clear-all", onClick: this.clearFinishedDownloads }, Object(t["a" /* T */])(["status.downloads.clear_all_finished"]))),
            Object(index_all["l" /* map */])(finishedItems, (item) => (react_default.a.createElement(Row, { key: item.id, item: item, finished: true })))));
    }
}
/* harmony default export */ var pages_DownloadsPage = __webpack_exports__["default"] = (Object(withTab["b" /* withTab */])(Object(hook["a" /* hook */])((map) => ({
    items: map((rs) => Object(getters["c" /* getPendingDownloads */])(rs.downloads)),
    finishedItems: map((rs) => Object(getters["b" /* getFinishedDownloads */])(rs.downloads)),
    updates: map((rs) => rs.gameUpdates.updates),
    updateCheckHappening: map((rs) => rs.gameUpdates.checking),
    updateCheckProgress: map((rs) => rs.gameUpdates.progress),
    downloadsPaused: map((rs) => rs.downloads.paused),
}))(DownloadsPage_DownloadsPage)));


/***/ }),

/***/ "./src/renderer/pages/common/SortsAndFilters.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return SortsAndFilters; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FilterGroup; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return FilterOptionLink; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FilterOptionButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return FilterOptionIcon; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return FilterSpacer; });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const SortsAndFilters = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__[/* FiltersContainerDiv */ "a"]) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* css */ "g"] `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  ${optionButtonLike};
`;
const FilterOptionIcon = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ })

}]);
//# sourceMappingURL=15.chunk.js.map