(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[17],{

/***/ "./src/common/butlerd/index.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return messages; });
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "a", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["a"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "b", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["b"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "c", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["c"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "d", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["d"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "e", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["e"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "f", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["f"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "g", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["g"]; });

/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


const messages = common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__;


/***/ }),

/***/ "./src/common/butlerd/utils.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ call; });
__webpack_require__.d(__webpack_exports__, "f", function() { return /* binding */ hookLogging; });
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ getCaveSummary; });
__webpack_require__.d(__webpack_exports__, "g", function() { return /* binding */ isInternalError; });
__webpack_require__.d(__webpack_exports__, "d", function() { return /* binding */ getErrorStack; });
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ asRequestError; });
__webpack_require__.d(__webpack_exports__, "e", function() { return /* binding */ getRpcErrorData; });

// UNUSED EXPORTS: hookProgress, getErrorMessage, mergeLogAndError

// EXTERNAL MODULE: ./node_modules/butlerd/lib/index.js
var lib = __webpack_require__("./node_modules/butlerd/lib/index.js");

// EXTERNAL MODULE: ./src/common/logger/index.ts
var common_logger = __webpack_require__("./src/common/logger/index.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// EXTERNAL MODULE: ./src/common/types/index.ts
var types = __webpack_require__("./src/common/types/index.ts");

// CONCATENATED MODULE: ./src/main/reactors/delay.ts
/** returns a promise that resolves after 'ms' milliseconds */
function delay(ms) {
    return new Promise((resolve, reject) => setTimeout(resolve, ms));
}

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__("./src/common/format/datetime.ts");

// CONCATENATED MODULE: ./src/common/butlerd/utils.ts






var clientPromises = new WeakMap();
async function makeClient(store, parentLogger) {
    const logger = parentLogger.childWithName("butlerd/make-client");
    while (true) {
        const { endpoint } = store.getState().butlerd;
        if (endpoint) {
            const client = new lib["Client"](endpoint);
            client.onWarning((msg) => {
                logger.warn(`(butlerd) ${msg}`);
            });
            return client;
        }
        logger.info(`Waiting for butlerd endpoint...`);
        await delay(1000);
    }
}
async function getClient(store, parentLogger) {
    let p;
    if (clientPromises.has(store)) {
        p = clientPromises.get(store);
    }
    else {
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    const client = await p;
    const currentEndpoint = store.getState().butlerd.endpoint;
    if (client.endpoint !== currentEndpoint) {
        parentLogger.warn(`(butlerd) Endpoint changed (${client.endpoint.tcp.address} => ${currentEndpoint.tcp.address}), making fresh client`);
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    return p;
}
async function call(store, logger, rc, params, setup) {
    const client = await getClient(store, logger);
    try {
        logger.debug(`Calling ${rc({})(client).method}`);
        return await client.call(rc, params, setup);
    }
    catch (e) {
        if (Object(types["isCancelled"])(e)) {
            // nvm
        }
        else if (Object(types["isAborted"])(e)) {
            // nvm
        }
        else {
            logger.error(`Caught butler error:`);
            if (isInternalError(e)) {
                const ed = getRpcErrorData(e);
                if (ed) {
                    logger.error(`butler version: ${ed.butlerVersion}`);
                    logger.error(`Golang stack:\n${ed.stack}`);
                }
                logger.error(`JavaScript stack: ${e.stack}`);
            }
            else {
                logger.error(`${e.message}`);
            }
        }
        throw e;
    }
}
function hookProgress(convo, ctx) {
    convo.onNotification(messages["Progress"], (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages["Log"], async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = Object(datetime["d" /* formatDate */])(new Date(obj.time), "en-US", datetime["a" /* DATE_FORMAT */]);
                    let level = common_logger["c" /* levels */][obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}
function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}


/***/ }),

/***/ "./src/renderer/butlerd/rcall.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return rcall; });
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var renderer_store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/store.ts");
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/logger/index.ts");



if (process.type !== "renderer") {
    throw new Error(`rcall cannot be required from main process`);
}
const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_2__[/* rendererLogger */ "a"].childWithName("rcall");
/**
 * Perform a butlerd call from the renderer process
 */
async function rcall(rc, params, setup) {
    return await Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* call */ "b"])(renderer_store__WEBPACK_IMPORTED_MODULE_1__["default"], logger, rc, params, setup);
}


/***/ }),

/***/ "./src/renderer/helpers/doAsync.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return doAsync; });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ "./src/renderer/modal-widgets/SecretSettings.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/butlerd/lib/index.js");
/* harmony import */ var butlerd__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(butlerd__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/butlerd/rcall.ts");
/* harmony import */ var renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/helpers/doAsync.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/modal-widgets/styles.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var common_modals__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/common/modals/index.ts");











const ControlsDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_9__[/* default */ "h"].div `
  display: flex;
  align-items: flex-start;
  flex-flow: row wrap;
  max-width: 600px;

  .control {
    margin: 8px;
  }

  label {
    padding: 8px;
    display: flex;
    flex-direction: row;
    align-items: center;
    border-left: 2px solid ${(props) => props.theme.prefBorder};
  }

  input[type="checkbox"] {
    margin-right: 0.4em;
  }
`;
class SecretSettings extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onReload = () => {
            window.location.reload();
        };
        this.onReloadLocales = () => {
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].reloadLocales({}));
        };
        this.onViewAppState = async () => {
            const chromeStore = (await Promise.resolve(/* import() */).then(__webpack_require__.bind(null, "./src/renderer/store.ts"))).default;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].openModal(common_modals__WEBPACK_IMPORTED_MODULE_10__[/* modals */ "a"].exploreJson.make({
                wind: "root",
                title: "Redux app state",
                widgetParams: {
                    data: chromeStore.getState(),
                },
                fullscreen: true,
            })));
        };
        this.onGPUFeatureStatus = () => {
            const app = __webpack_require__("electron").remote.app;
            const data = app.getGPUFeatureStatus();
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].openModal(common_modals__WEBPACK_IMPORTED_MODULE_10__[/* modals */ "a"].exploreJson.make({
                wind: "root",
                title: "GPU feature status",
                widgetParams: {
                    data,
                },
            })));
        };
        this.onBadButlerdCall = () => {
            const FakeRequest = Object(butlerd__WEBPACK_IMPORTED_MODULE_0__["createRequest"])("This.Is.Definitely.Not.A.Butlerd.Method");
            Object(renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_6__[/* doAsync */ "a"])(async () => {
                let e;
                try {
                    await Object(renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_5__[/* rcall */ "a"])(FakeRequest, {});
                }
                catch (ee) {
                    e = ee;
                }
                const { dispatch } = this.props;
                dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].openModal(common_modals__WEBPACK_IMPORTED_MODULE_10__[/* modals */ "a"].showError.make({
                    wind: "root",
                    title: "test butlerd internal error",
                    message: "This is a test butlerd error",
                    detail: "It's fun to snoop!",
                    widgetParams: {
                        rawError: e,
                        log: "no log",
                    },
                    buttons: [
                        {
                            label: ["prompt.action.continue"],
                        },
                    ],
                })));
            });
        };
        this.onDoubleTwice = () => {
            Object(renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_6__[/* doAsync */ "a"])(async () => {
                await Object(renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_5__[/* rcall */ "a"])(common_butlerd__WEBPACK_IMPORTED_MODULE_2__[/* messages */ "h"].TestDoubleTwice, { number: 7 }, (client) => {
                    client.onRequest(common_butlerd__WEBPACK_IMPORTED_MODULE_2__[/* messages */ "h"].TestDouble, async ({ number }) => {
                        return { number: number * 2 };
                    });
                });
            });
        };
        this.onExpireAll = () => {
            Object(renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_6__[/* doAsync */ "a"])(async () => {
                await Object(renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_5__[/* rcall */ "a"])(common_butlerd__WEBPACK_IMPORTED_MODULE_2__[/* messages */ "h"].FetchExpireAll, {});
            });
        };
        this.onOpenCrashy = () => {
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].navigate({ wind: "root", url: "itch://crashy" }));
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].closeModal({ wind: "root" }));
        };
        this.onRestartButler = async () => {
            const { dispatch } = this.props;
            const chromeStore = (await Promise.resolve(/* import() */).then(__webpack_require__.bind(null, "./src/renderer/store.ts"))).default;
            const butlerState = chromeStore.getState().broth.packages["butler"];
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].packageGotVersionPrefix({
                name: "butler",
                version: butlerState.version,
                versionPrefix: butlerState.versionPrefix,
            }));
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].closeModal({ wind: "root" }));
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].statusMessage({ message: "Butler restarted!" }));
        };
        this.toggleReduxLogging = () => {
            const enabled = !this.props.status.reduxLoggingEnabled;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].setReduxLoggingEnabled({
                enabled,
            }));
            if (enabled) {
                dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].openDevTools({ wind: "root" }));
            }
        };
    }
    render() {
        const { status } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_8__[/* ModalWidgetDiv */ "a"], null,
            react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(ControlsDiv, null,
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement("label", { className: "control" },
                    react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement("input", { type: "checkbox", value: "Redux logging", checked: status.reduxLoggingEnabled, onChange: this.toggleReduxLogging }),
                    react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement("span", null, "Enable redux logging")),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "repeat", onClick: this.onReload, label: "Reload entire page" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "earth", onClick: this.onReloadLocales, label: "Reload locales" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "bug", onClick: this.onViewAppState, label: "View app state" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "palette", onClick: this.onGPUFeatureStatus, label: "View GPU feature status" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "bug", onClick: this.onBadButlerdCall, label: "Call non-existent butlerd endpoint" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "leaf", onClick: this.onDoubleTwice, label: "Double twice" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "close", onClick: this.onExpireAll, label: "Expire all data in local database" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "bug", onClick: this.onOpenCrashy, label: "Open crashy tab" }),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { className: "control", primary: true, icon: "checkbox-checked", onClick: this.onRestartButler, label: "Force butlerd restart" }))));
    }
}
/* harmony default export */ __webpack_exports__["default"] = (Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__[/* hook */ "a"])((map) => ({
    status: map((rs) => rs.status),
}))(SecretSettings));


/***/ }),

/***/ "./src/renderer/modal-widgets/styles.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalWidgetDiv; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* heavyInput */ "j"]};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=17.chunk.js.map