(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[2],{

/***/ "./src/common/butlerd/index.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return messages; });
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "a", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["a"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "b", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["b"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "c", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["c"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "d", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["d"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "e", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["e"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "f", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["f"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "g", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["g"]; });

/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


const messages = common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__;


/***/ }),

/***/ "./src/common/butlerd/utils.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ call; });
__webpack_require__.d(__webpack_exports__, "f", function() { return /* binding */ hookLogging; });
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ getCaveSummary; });
__webpack_require__.d(__webpack_exports__, "g", function() { return /* binding */ isInternalError; });
__webpack_require__.d(__webpack_exports__, "d", function() { return /* binding */ getErrorStack; });
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ asRequestError; });
__webpack_require__.d(__webpack_exports__, "e", function() { return /* binding */ getRpcErrorData; });

// UNUSED EXPORTS: hookProgress, getErrorMessage, mergeLogAndError

// EXTERNAL MODULE: ./node_modules/butlerd/lib/index.js
var lib = __webpack_require__("./node_modules/butlerd/lib/index.js");

// EXTERNAL MODULE: ./src/common/logger/index.ts
var common_logger = __webpack_require__("./src/common/logger/index.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// EXTERNAL MODULE: ./src/common/types/index.ts
var types = __webpack_require__("./src/common/types/index.ts");

// CONCATENATED MODULE: ./src/main/reactors/delay.ts
/** returns a promise that resolves after 'ms' milliseconds */
function delay(ms) {
    return new Promise((resolve, reject) => setTimeout(resolve, ms));
}

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__("./src/common/format/datetime.ts");

// CONCATENATED MODULE: ./src/common/butlerd/utils.ts






var clientPromises = new WeakMap();
async function makeClient(store, parentLogger) {
    const logger = parentLogger.childWithName("butlerd/make-client");
    while (true) {
        const { endpoint } = store.getState().butlerd;
        if (endpoint) {
            const client = new lib["Client"](endpoint);
            client.onWarning((msg) => {
                logger.warn(`(butlerd) ${msg}`);
            });
            return client;
        }
        logger.info(`Waiting for butlerd endpoint...`);
        await delay(1000);
    }
}
async function getClient(store, parentLogger) {
    let p;
    if (clientPromises.has(store)) {
        p = clientPromises.get(store);
    }
    else {
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    const client = await p;
    const currentEndpoint = store.getState().butlerd.endpoint;
    if (client.endpoint !== currentEndpoint) {
        parentLogger.warn(`(butlerd) Endpoint changed (${client.endpoint.tcp.address} => ${currentEndpoint.tcp.address}), making fresh client`);
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    return p;
}
async function call(store, logger, rc, params, setup) {
    const client = await getClient(store, logger);
    try {
        logger.debug(`Calling ${rc({})(client).method}`);
        return await client.call(rc, params, setup);
    }
    catch (e) {
        if (Object(types["isCancelled"])(e)) {
            // nvm
        }
        else if (Object(types["isAborted"])(e)) {
            // nvm
        }
        else {
            logger.error(`Caught butler error:`);
            if (isInternalError(e)) {
                const ed = getRpcErrorData(e);
                if (ed) {
                    logger.error(`butler version: ${ed.butlerVersion}`);
                    logger.error(`Golang stack:\n${ed.stack}`);
                }
                logger.error(`JavaScript stack: ${e.stack}`);
            }
            else {
                logger.error(`${e.message}`);
            }
        }
        throw e;
    }
}
function hookProgress(convo, ctx) {
    convo.onNotification(messages["Progress"], (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages["Log"], async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = Object(datetime["d" /* formatDate */])(new Date(obj.time), "en-US", datetime["a" /* DATE_FORMAT */]);
                    let level = common_logger["c" /* levels */][obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}
function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}


/***/ }),

/***/ "./src/common/constants/platform-data.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return hasPlatforms; });
const data = {
    windows: { icon: "windows8", platform: "windows", emoji: "🏁" },
    linux: { icon: "tux", platform: "linux", emoji: "🐧" },
    osx: { icon: "apple", platform: "osx", emoji: "🍎" },
};
/* harmony default export */ __webpack_exports__["a"] = (data);
function hasPlatforms(target) {
    for (const key of Object.keys(data)) {
        if (target.platforms[key]) {
            return true;
        }
    }
    if (target.type === "html") {
        return true;
    }
    return false;
}


/***/ }),

/***/ "./src/common/format/truncate.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return truncate; });
/**
 * Returns a truncated version of input. The output length will not exceed
 * opts.length.
 */
function truncate(input, opts) {
    if (!input) {
        return input;
    }
    if (input.length > opts.length) {
        return input.substr(0, opts.length - 3) + "...";
    }
    return input;
}


/***/ }),

/***/ "./src/renderer/basics/ErrorState.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/styles.ts");


const ButlerErrorDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_1__[/* default */ "h"].div `
  display: flex;
  flex-direction: row;
  align-items: center;
  margin: 2em 0;

  .spacer {
    width: 8px;
  }
`;
const ErrorState = ({ error }) => {
    if (!error) {
        return null;
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(ButlerErrorDiv, null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("span", { className: "icon icon-error" }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("abbr", { title: error && error.stack ? error.stack : String(error) }, String(error))));
};
/* harmony default export */ __webpack_exports__["a"] = (ErrorState);


/***/ }),

/***/ "./src/renderer/basics/FiltersContainer.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ filtersContainerHeight; });
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ FiltersContainerDiv; });

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__("./node_modules/tslib/tslib.es6.js");

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__("./src/renderer/hocs/watching.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/NavigationBar.tsx












const HTTPS_RE = /^https:\/\//;
const HTTP_RE = /^http:\/\//;
const ITCH_RE = /^itch:\/\//;
const NavigationBarDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding-right: 4px;

  flex-grow: 1;
  flex-shrink: 1;
  overflow: hidden;
  position: relative;

  &.loading {
    &::after {
      position: absolute;
      bottom: -6px;
      content: " ";
      width: 100%;
      height: 2px;
      background: ${(props) => props.theme.accent};
      animation: ${styles["b" /* animations */].lineSpinner} 2s ease-in-out infinite;
    }
  }
`;
const browserAddressSizing = styles["g" /* css */] `
  height: 28px;
  line-height: 28px;
  border-radius: 2px;
`;
const browserAddressStyle = styles["g" /* css */] `
  ${browserAddressSizing};
  ${styles["s" /* singleLine */]};
  font-size: 14px;
  text-shadow: 0 0 1px black;
  padding: 0;
  padding-left: 8px;
  padding-right: 12px;
  width: 100%;
  color: #fdfdfd;

  border: none;
  background: rgba(255, 255, 255, 0.1);
  box-shadow: none;

  &:focus {
    outline: none;
  }
`;
const AddressWrapper = styles["h" /* default */].div `
  ${browserAddressSizing};
  margin: 0 6px;
  transition: all 0.4s;
  border: 1px solid transparent;
  flex-grow: 1;

  &.editing {
    border-color: rgba(255, 255, 255, 0.4);
  }
`;
const AddressInput = styles["h" /* default */].input `
  ${browserAddressStyle};

  text-shadow: 0 0 1px transparent;
  color: white;
`;
const AddressDiv = styles["h" /* default */].div `
  ${browserAddressStyle};

  .security-theater-bit {
    color: rgb(138, 175, 115);
  }

  .fluff-bit {
    color: rgb(148, 184, 218);
  }
`;
function isHTMLInput(el) {
    return el.tagName === "INPUT";
}
let NavigationBar_NavigationBar = class NavigationBar extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.fresh = true;
        // event handlers
        this.goBack = () => {
            Object(tab_utils["d" /* dispatchTabGoBack */])(this.props);
        };
        this.showBackHistory = (ev) => {
            const { clientX, clientY } = ev;
            ev.preventDefault();
            Object(tab_utils["a" /* dispatchOpenTabBackHistory */])(this.props, { clientX, clientY });
        };
        this.goForward = () => {
            Object(tab_utils["e" /* dispatchTabGoForward */])(this.props);
        };
        this.showForwardHistory = (ev) => {
            const { clientX, clientY } = ev;
            ev.preventDefault();
            Object(tab_utils["b" /* dispatchOpenTabForwardHistory */])(this.props, { clientX, clientY });
        };
        this.stop = () => {
            Object(tab_utils["k" /* dispatchTabStop */])(this.props);
        };
        this.reload = () => {
            Object(tab_utils["j" /* dispatchTabReloaded */])(this.props);
        };
        this.onBrowserAddress = (browserAddress) => {
            this.browserAddress = browserAddress;
            if (!browserAddress) {
                return;
            }
            const { internalPage } = this.props;
            if (this.fresh && internalPage === "new-tab") {
                this.fresh = false;
                this.startEditingAddress();
            }
            if (isHTMLInput(browserAddress)) {
                browserAddress.focus();
                browserAddress.select();
            }
        };
        this.addressKeyDown = (e) => {
            if (e.key === "Enter") {
                const input = e.currentTarget.value;
                const url = Object(navigation["g" /* transformUrl */])(input);
                Object(tab_utils["c" /* dispatchTabEvolve */])(this.props, { url, replace: false });
                this.setState({ editingAddress: false });
            }
            else if (e.key === "Escape") {
                e.preventDefault();
                this.setState({ editingAddress: false });
            }
        };
        this.addressBlur = () => {
            const { browserAddress } = this;
            if (browserAddress && isHTMLInput(browserAddress)) {
                browserAddress.setSelectionRange(0, 0);
            }
        };
        this.startEditingAddress = () => {
            this.setState({ editingAddress: true });
        };
        this.state = {
            editingAddress: false,
            url: null,
        };
    }
    subscribe(w) {
        w.on(actions["a" /* actions */].focusLocationBar, async (store, action) => {
            const { wind, tab } = action.payload;
            if (wind !== Object(navigation["d" /* ambientWind */])()) {
                return;
            }
            if (tab !== this.props.tab) {
                return;
            }
            this.setState({
                editingAddress: true,
            });
            const { browserAddress } = this;
            if (browserAddress && isHTMLInput(browserAddress)) {
                browserAddress.select();
            }
        });
        w.on(actions["a" /* actions */].blurLocationBar, async (store, action) => {
            this.setState({ editingAddress: false });
        });
    }
    render() {
        const { canGoBack, canGoForward, loading } = this.props;
        return (react_default.a.createElement(NavigationBarDiv, { className: classnames_default()({ loading }) },
            react_default.a.createElement(IconButton["a" /* default */], { icon: "arrow-left", disabled: !canGoBack, onClick: this.goBack, onContextMenu: this.showBackHistory }),
            react_default.a.createElement(IconButton["a" /* default */], { icon: "arrow-right", disabled: !canGoForward, onClick: this.goForward, onContextMenu: this.showForwardHistory }),
            this.renderAddressBar()));
    }
    renderAddressBar() {
        const { loading, url } = this.props;
        if (!this.props.showAddressBar) {
            return null;
        }
        let { editingAddress } = this.state;
        return (react_default.a.createElement(react_default.a.Fragment, null,
            loading ? (react_default.a.createElement(IconButton["a" /* default */], { icon: "cross", onClick: this.stop })) : (react_default.a.createElement(IconButton["a" /* default */], { icon: "repeat", onClick: this.reload })),
            react_default.a.createElement(AddressWrapper, { className: classnames_default()({ editing: editingAddress }) }, editingAddress ? (react_default.a.createElement(AddressInput, { className: "browser-address", type: "search", ref: this.onBrowserAddress, defaultValue: url, onKeyDown: this.addressKeyDown, onBlur: this.addressBlur })) : (react_default.a.createElement(AddressDiv, { className: classnames_default()("browser-address"), ref: this.onBrowserAddress, onClick: this.startEditingAddress }, this.renderURL(url))))));
    }
    renderURL(url) {
        let isHTTP = HTTP_RE.test(url);
        let isHTTPS = HTTPS_RE.test(url);
        let isItch = ITCH_RE.test(url);
        if (isHTTPS) {
            return (react_default.a.createElement("span", null,
                react_default.a.createElement("span", { className: "security-theater-bit" }, "https://"),
                url.replace(HTTPS_RE, "")));
        }
        if (isItch) {
            return (react_default.a.createElement("span", null,
                react_default.a.createElement("span", { className: "fluff-bit" }, "itch://"),
                url.replace(ITCH_RE, "")));
        }
        if (!(isHTTP || isHTTPS || isItch)) {
            return null;
        }
        return react_default.a.createElement(react_default.a.Fragment, null, url);
    }
    static getDerivedStateFromProps(props, state) {
        if (props.url !== state.url) {
            return {
                url: props.url,
                editingAddress: false,
            };
        }
        return null;
    }
};
NavigationBar_NavigationBar = Object(tslib_es6["b" /* __decorate */])([
    watching["a" /* default */]
], NavigationBar_NavigationBar);
/* harmony default export */ var basics_NavigationBar = (Object(withTab["b" /* withTab */])(Object(hook["b" /* hookWithProps */])(NavigationBar_NavigationBar)((map) => ({
    url: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.url),
    internalPage: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.internalPage),
    canGoBack: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).status.canGoBack),
    canGoForward: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).status.canGoForward),
}))(NavigationBar_NavigationBar)));

// CONCATENATED MODULE: ./src/renderer/basics/FiltersContainer.tsx




const filtersContainerHeight = 40;
const FiltersContainerDiv = styles["h" /* default */].section `
  display: flex;
  align-items: center;
  padding-bottom: 2px;
  width: 100%;
  overflow: hidden;
  background: ${(props) => props.theme.sidebarBackground};
  box-shadow: 0 4px 8px -4px ${(props) => props.theme.sidebarBackground};
  flex-shrink: 0;
  padding-left: 10px;
  padding-right: 10px;
  height: ${filtersContainerHeight}px;

  position: relative;

  &.loading {
    &::after {
      position: absolute;
      bottom: 0px;
      content: " ";
      width: 100%;
      height: 2px;
      background: ${(props) => props.theme.accent};
      animation: ${styles["b" /* animations */].lineSpinner} 2s ease-in-out infinite;
    }
  }
`;
class FiltersContainer_FiltersContainer extends react_default.a.PureComponent {
    render() {
        const { loading, children, className } = this.props;
        return (react_default.a.createElement(FiltersContainerDiv, { className: classnames_default()(className, { loading }) },
            react_default.a.createElement(basics_NavigationBar, { loading: loading, showAddressBar: !this.props.hideAddressBar }),
            children));
    }
}
/* harmony default export */ var basics_FiltersContainer = __webpack_exports__["b"] = (FiltersContainer_FiltersContainer);


/***/ }),

/***/ "./src/renderer/basics/Floater.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Floater; });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const floaterKeyframes = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* keyframes */ "k"] `
  0% {
    transform: scale(0);
    opacity: .6;
  }

  100% {
    transform: scale(1);
    opacity: 1;
  }
`;
const numDrops = 3;
const duration = 0.5;
const offset = duration / numDrops;
const FloaterDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  width: 30px;
  height: 10px;

  display: flex;
  flex-flow: row;
  align-items: center;
  justify-content: center;

  div {
    width: 8px;
    height: 6px;
    margin: 0 2px;
    border-radius: 50%;
    background: white;
    animation: ${floaterKeyframes} ${duration}s infinite ease-in-out alternate;
  }

  &.tiny {
    width: 20px;
    height: 8px;

    div {
      width: 6px;
      height: 3px;
    }
  }

  div:nth-child(1) {
    animation-delay: -${offset * 2}s;
  }

  div:nth-child(2) {
    animation-delay: -${offset * 1}s;
  }
`;
function Floater(props) {
    const { tiny } = props;
    return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(FloaterDiv, { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ tiny }) },
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null)));
}


/***/ }),

/***/ "./src/renderer/basics/PlatformIcons/PlatformIcon.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PlatformIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var common_constants_platform_data__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/constants/platform-data.ts");



class PlatformIcon extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
    render() {
        const { target, field, before } = this.props;
        if (!target.platforms || !target.platforms[field]) {
            return null;
        }
        const data = common_constants_platform_data__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"][field];
        return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
            before,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"], { hint: data.platform, icon: data.icon })));
    }
}


/***/ }),

/***/ "./src/renderer/basics/PlatformIcons/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/PlatformIcons/PlatformIcon.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var common_constants_platform_data__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/common/constants/platform-data.ts");






const PlatformIconsDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].span `
  .icon {
    margin-left: 8px;

    &:first-child {
      margin-left: 0;
    }
  }
`;
class PlatformIcons extends react__WEBPACK_IMPORTED_MODULE_1___default.a.PureComponent {
    render() {
        const _a = this.props, { target, before } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["target", "before"]);
        if (!Object(common_constants_platform_data__WEBPACK_IMPORTED_MODULE_5__[/* hasPlatforms */ "b"])(target)) {
            return null;
        }
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null,
            before ? before() : null,
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(PlatformIconsDiv, Object.assign({}, restProps),
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { field: "windows", target: target }),
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { field: "osx", target: target }),
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { field: "linux", target: target }),
                target.type === "html" ? react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { icon: "html5", hint: "web" }) : null)));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (PlatformIcons);


/***/ }),

/***/ "./src/renderer/butlerd/rcall.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return rcall; });
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var renderer_store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/store.ts");
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/logger/index.ts");



if (process.type !== "renderer") {
    throw new Error(`rcall cannot be required from main process`);
}
const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_2__[/* rendererLogger */ "a"].childWithName("rcall");
/**
 * Perform a butlerd call from the renderer process
 */
async function rcall(rc, params, setup) {
    return await Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* call */ "b"])(renderer_store__WEBPACK_IMPORTED_MODULE_1__["default"], logger, rc, params, setup);
}


/***/ }),

/***/ "./src/renderer/hocs/butlerCaller/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ renderNoop; });
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ LoadingStateDiv; });

// EXTERNAL MODULE: ./src/common/logger/index.ts
var logger = __webpack_require__("./src/common/logger/index.ts");

// EXTERNAL MODULE: ./src/common/util/watcher.ts + 1 modules
var watcher = __webpack_require__("./src/common/util/watcher.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./node_modules/react-fast-compare/index.js
var react_fast_compare = __webpack_require__("./node_modules/react-fast-compare/index.js");
var react_fast_compare_default = /*#__PURE__*/__webpack_require__.n(react_fast_compare);

// EXTERNAL MODULE: ./src/renderer/basics/ErrorState.tsx
var ErrorState = __webpack_require__("./src/renderer/basics/ErrorState.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__("./src/renderer/basics/Floater.tsx");

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// CONCATENATED MODULE: ./src/renderer/butlerd/invalidators.ts


const invalidators = new Map();
invalidators.set(butlerd["h" /* messages */].FetchProfileOwnedKeys, [actions["a" /* actions */].commonsUpdated]);
invalidators.set(butlerd["h" /* messages */].FetchCaves, [actions["a" /* actions */].commonsUpdated]);
invalidators.set(butlerd["h" /* messages */].FetchCave, [actions["a" /* actions */].commonsUpdated]);
invalidators.set(butlerd["h" /* messages */].InstallLocationsList, [
    actions["a" /* actions */].commonsUpdated,
    actions["a" /* actions */].installLocationsChanged,
]);

// EXTERNAL MODULE: ./src/renderer/butlerd/rcall.ts
var rcall = __webpack_require__("./src/renderer/butlerd/rcall.ts");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// EXTERNAL MODULE: ./node_modules/react-redux/es/index.js + 24 modules
var es = __webpack_require__("./node_modules/react-redux/es/index.js");

// CONCATENATED MODULE: ./src/renderer/hocs/butlerCaller/index.tsx











function renderNoop() {
    return null;
}
const LoadingStateDiv = styles["h" /* default */].div `
  display: flex;
  align-items: center;
  justify-content: center;
  margin: 20px auto;
`;
const butlerCaller = (method) => {
    class Caller extends react_default.a.PureComponent {
        constructor(props, context) {
            super(props, context);
            this.fetchID = 0;
            this.invalidate = Object(index_all["a" /* debounce */])(() => {
                this.queueFetch();
            }, 150);
            this.queueFetch = (additionalParams) => {
                // cf. https://github.com/Microsoft/TypeScript/pull/13288
                let fullParams = this.props.params;
                if (additionalParams) {
                    fullParams = Object.assign(Object.assign({}, fullParams), additionalParams);
                }
                this.setState({
                    loading: true,
                });
                this.fetchID++;
                let { fetchID } = this;
                (async () => {
                    try {
                        const result = await Object(rcall["a" /* rcall */])(method, fullParams);
                        if (this.fetchID !== fetchID) {
                            // discard outdated result
                            return;
                        }
                        this.setResult(result);
                        if (!fullParams.fresh && result.stale) {
                            this.queueFetch({ fresh: true });
                        }
                    }
                    catch (error) {
                        if (this.fetchID !== fetchID) {
                            // discard outdated result
                            return;
                        }
                        this.setError(error);
                    }
                })();
            };
            this.setResult = (r) => {
                if (this.props.onResult) {
                    this.props.onResult(r);
                }
                this.setState({ result: r, error: null, loading: false });
            };
            this.setError = (e) => {
                this.setState({ error: e, loading: false });
            };
            this.state = {
                loading: true,
                error: undefined,
                result: undefined,
            };
            this.invalidators = invalidators.get(method);
        }
        componentDidMount() {
            this.queueFetch();
            if (this.invalidators) {
                this.watcher = new watcher["a" /* Watcher */](new logger["a" /* Logger */](logger["b" /* devNull */]));
                this.props.__store.watcher.addSub(this.watcher);
                for (const invalidatingAction of this.invalidators) {
                    this.watcher.on(invalidatingAction, async (store, action) => {
                        this.invalidate();
                    });
                }
            }
        }
        componentWillUnmount() {
            if (this.watcher) {
                this.props.__store.watcher.removeSub(this.watcher);
            }
        }
        render() {
            const { error, loading, result } = this.state;
            const { render, errorsHandled, loadingHandled } = this.props;
            if (loading) {
                if (!loadingHandled) {
                    return (react_default.a.createElement(LoadingStateDiv, null,
                        react_default.a.createElement(Floater["a" /* default */], null)));
                }
            }
            if (error) {
                if (!errorsHandled) {
                    return react_default.a.createElement(ErrorState["a" /* default */], { error: error });
                }
            }
            return render({ error, loading, result });
        }
        componentDidUpdate(prevProps) {
            if (!react_fast_compare_default()(prevProps.params, this.props.params)) {
                this.queueFetch();
                return;
            }
            if (prevProps.sequence != this.props.sequence) {
                this.queueFetch({ fresh: true });
                return;
            }
        }
    }
    Caller.displayName = `ButlerCall(${method.name})`;
    class Wrapper extends react_default.a.PureComponent {
        render() {
            return (react_default.a.createElement(es["b" /* ReactReduxContext */].Consumer, null, ({ store }) => react_default.a.createElement(Caller, Object.assign({}, this.props, { __store: store }))));
        }
        static renderCallback(f) {
            return f;
        }
        static onResultCallback(f) {
            return f;
        }
    }
    return Wrapper;
};
/* harmony default export */ var hocs_butlerCaller = __webpack_exports__["b"] = (butlerCaller);


/***/ }),

/***/ "./src/renderer/hocs/tab-utils.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return dispatchTabLoadingStateChanged; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return dispatchTabGotWebContents; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return dispatchTabLosingWebContents; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return dispatchTabEvolve; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "i", function() { return dispatchTabPageUpdate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "j", function() { return dispatchTabReloaded; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "k", function() { return dispatchTabStop; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return dispatchTabGoForward; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return dispatchTabGoBack; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return dispatchOpenTabBackHistory; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return dispatchOpenTabForwardHistory; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "l", function() { return urlWithParams; });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var url__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("url");
/* harmony import */ var url__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(url__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("querystring");
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(querystring__WEBPACK_IMPORTED_MODULE_3__);




function dispatchTabLoadingStateChanged(props, loading) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabLoadingStateChanged({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
        loading,
    }));
}
function dispatchTabGotWebContents(props, webContentsId) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabGotWebContents({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
        webContentsId,
    }));
}
function dispatchTabLosingWebContents(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabLosingWebContents({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
    }));
}
function dispatchTabEvolve(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].evolveTab(Object.assign({ wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(), tab }, payload)));
}
function dispatchTabPageUpdate(props, page) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabPageUpdate({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
        page,
    }));
}
function dispatchTabReloaded(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabReloaded({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
    }));
}
function dispatchTabStop(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabStop({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
    }));
}
function dispatchTabGoForward(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabGoForward({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
    }));
}
function dispatchTabGoBack(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].tabGoBack({
        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
        tab,
    }));
}
function dispatchOpenTabBackHistory(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].openTabBackHistory(Object.assign({ wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(), tab }, payload)));
}
function dispatchOpenTabForwardHistory(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].openTabForwardHistory(Object.assign({ wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(), tab }, payload)));
}
function urlWithParams(url, params) {
    const parsed = url__WEBPACK_IMPORTED_MODULE_2__["parse"](url);
    let finalParams = querystring__WEBPACK_IMPORTED_MODULE_3__["parse"](parsed.query);
    for (const k of Object.keys(params)) {
        const v = params[k];
        if (!v) {
            delete finalParams[k];
        }
        else {
            finalParams[k] = v;
        }
    }
    const query = querystring__WEBPACK_IMPORTED_MODULE_3__["stringify"](finalParams);
    parsed.search = query ? `?${query}` : "";
    return url__WEBPACK_IMPORTED_MODULE_2__["format"](parsed);
}


/***/ }),

/***/ "./src/renderer/hocs/withTab.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabProvider; });
/* unused harmony export TabConsumer */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return withTab; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

const spaceContext = react__WEBPACK_IMPORTED_MODULE_0___default.a.createContext(undefined);
const TabProvider = spaceContext.Provider;
const TabConsumer = spaceContext.Consumer;
const withTab = (Component) => (props) => (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(TabConsumer, null, (tab) => react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(Component, Object.assign({}, props, { tab: tab }))));


/***/ }),

/***/ "./src/renderer/pages/PageStyles/games.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return TitleBox; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return Title; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return TitleBreak; });
/* unused harmony export TitleSpacer */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Desc; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

//-----------------------------------
// Description
//-----------------------------------
const TitleBox = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  padding: 12px 0;
  align-self: flex-start;

  display: flex;
  flex-direction: column;
  align-self: stretch;
`;
const Title = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  font-size: ${(props) => props.theme.fontSizes.huger};
  font-weight: bold;
  display: flex;
  flex-flow: row wrap;
  align-items: center;
`;
const TitleBreak = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-basis: 100%;
  width: 0;
  height: 0;
  overflow: hidden;
  margin-top: 8px;
`;
const TitleSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  width: 8px;
`;
const Desc = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  color: ${(props) => props.theme.secondaryText};
`;


/***/ }),

/***/ "./src/renderer/pages/common/StandardGameCover.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ standardCoverWidth; });
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ standardCoverHeight; });

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__("./node_modules/tslib/tslib.es6.js");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/basics/Cover/index.tsx + 2 modules
var Cover = __webpack_require__("./src/renderer/basics/Cover/index.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/common/StandardSaleRibbon.tsx


const SaleRibbon = styles["h" /* default */].div `
  position: absolute;
  right: 0;
  bottom: 0;
  background-color: ${(props) => props.theme.sale};
  padding: 0.5em 1em;
  font-size: ${(props) => props.theme.fontSizes.large};
  font-weight: 700;
  border: 3px solid ${(props) => props.theme.breadBackground};
  border-right: none;
  border-bottom: none;
`;
const SaleRate = styles["h" /* default */].div `
  opacity: 0.9;
  font-weight: 900;
`;
const SaleMiniLabel = styles["h" /* default */].div `
  text-transform: uppercase;
  line-height: 1.1;
  opacity: 0.5;
  font-weight: bold;
`;
/* harmony default export */ var StandardSaleRibbon = (({ game }) => (react_default.a.createElement(react_default.a.Fragment, null, game.sale ? (react_default.a.createElement(SaleRibbon, null,
    react_default.a.createElement(SaleRate, null,
        game.sale.rate.toFixed(),
        "%"),
    react_default.a.createElement(SaleMiniLabel, null, "off"))) : null)));

// EXTERNAL MODULE: ./src/common/format/truncate.ts
var truncate = __webpack_require__("./src/common/format/truncate.ts");

// EXTERNAL MODULE: ./src/renderer/pages/PageStyles/games.tsx
var games = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/PlatformIcons/index.tsx
var PlatformIcons = __webpack_require__("./src/renderer/basics/PlatformIcons/index.tsx");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// CONCATENATED MODULE: ./src/renderer/pages/common/StandardGameCover.tsx













//-----------------------------------
// Cover
//-----------------------------------
const baseWidth = 215;
const baseHeight = 170;
const coverFactor = 0.9;
const standardCoverWidth = baseWidth * coverFactor;
const standardCoverHeight = baseHeight * coverFactor;
const CoverBox = styles["h" /* default */].div `
  flex-shrink: 0;
  width: ${standardCoverWidth}px;
  height: ${standardCoverHeight}px;
  box-shadow: 0 0 20px rgba(0, 0, 0, 0.4);
  position: relative;

  &.showInfo {
    .cover-hover {
      opacity: 0;
      transition: opacity 0.4s;
    }

    img {
      transition: filter 0.4s;
    }

    &:hover {
      img {
        filter: brightness(42%) saturate(42%);
      }

      .cover-hover {
        opacity: 1;
      }
    }
  }
`;
const CoverInfo = styles["h" /* default */].div `
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;

  display: flex;
  flex-direction: row;
  align-items: center;

  pointer-events: none;

  line-height: 1.4;
`;
const DarkBox = styles["h" /* default */].div `
  margin: 0;
  padding: 0;
  align-self: flex-start;
  display: flex;
  flex-direction: column;
  align-self: stretch;
  width: 100%;
  padding: 0.3em 0.7em;
  background: rgba(0, 0, 0, 0.5);
`;
const DarkTitle = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};
  flex-shrink: 0;
  font-size: ${(props) => props.theme.fontSizes.huge};
  font-weight: bold;
  padding: 0.3em 0;
`;
class StandardGameCover_StandardGameCover extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onContextMenu = (ev) => {
            const { game, dispatch } = this.props;
            if (!game) {
                return;
            }
            const { clientX, clientY } = ev;
            ev.preventDefault();
            const wind = Object(navigation["d" /* ambientWind */])();
            dispatch(actions["a" /* actions */].openGameContextMenu({
                clientX,
                clientY,
                game,
                wind,
            }));
        };
    }
    render() {
        const _a = this.props, { game, showInfo, className, children, showGifMarker = true } = _a, restProps = Object(tslib_es6["d" /* __rest */])(_a, ["game", "showInfo", "className", "children", "showGifMarker"]);
        return (react_default.a.createElement(CoverBox, Object.assign({}, restProps, { className: classnames_default()(className, { showInfo }), onContextMenu: this.onContextMenu }),
            game ? (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement("a", { href: Object(navigation["i" /* urlForGame */])(game.id) },
                    react_default.a.createElement(Cover["a" /* GameCover */], { game: game, showGifMarker: !showInfo && showGifMarker }),
                    react_default.a.createElement(StandardSaleRibbon, { game: game }),
                    showInfo ? (react_default.a.createElement(react_default.a.Fragment, null,
                        react_default.a.createElement(CoverInfo, { className: "cover-hover" },
                            react_default.a.createElement(DarkBox, null,
                                react_default.a.createElement(DarkTitle, null, game.title),
                                react_default.a.createElement(games["a" /* Desc */], null, Object(truncate["a" /* truncate */])(game.shortText, { length: 70 })),
                                react_default.a.createElement(Filler["a" /* default */], null),
                                react_default.a.createElement(PlatformIcons["a" /* default */], { target: game }))))) : null))) : null,
            children));
    }
}
/* harmony default export */ var common_StandardGameCover = __webpack_exports__["a"] = (Object(hook["a" /* hook */])()(StandardGameCover_StandardGameCover));


/***/ })

}]);
//# sourceMappingURL=2.chunk.js.map