(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[20],{

/***/ "./src/main/net/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return isNetworkError; });
/* unused harmony export RequestError */
/* unused harmony export RequestTimeout */
/* unused harmony export RequestAborted */
/* unused harmony export RequestFormattingFailure */
/* unused harmony export RequestParsingFailure */
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


/**
 * Returns true if this is a network error
 */
function isNetworkError(e) {
    // this operates under the assumption that:
    //   * all our internal network errors should start with "err::"
    //   * all of chrome's already do
    //   * we transform fetch's into err:: variants.
    // we coerce e.message into a string on the off chance that it's not defined
    // or not a string.
    const isJavaScriptNetworkError = e && ("" + e.message).indexOf("net::") === 0;
    if (isJavaScriptNetworkError) {
        return true;
    }
    const re = Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re) {
        if (re.rpcError.code === common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__["Code"].NetworkDisconnected) {
            return true;
        }
    }
    return false;
}
class RequestError extends Error {
    constructor(message) {
        super(message.indexOf("net::") == 0 ? message : "net::REQUEST_ERROR::");
    }
}
class RequestTimeout extends RequestError {
    constructor() {
        super("TIMED_OUT");
    }
}
class RequestAborted extends RequestError {
    constructor() {
        super("ABORTED");
    }
}
class RequestFormattingFailure extends RequestError {
    constructor(message) {
        super("FORMATTING_FAILURE: " + message);
    }
}
class RequestParsingFailure extends RequestError {
    constructor(message) {
        super("PARSING_FAILURE: " + message);
    }
}


/***/ }),

/***/ "./src/renderer/pages/LocationsPage/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/FiltersContainer.tsx + 1 modules
var FiltersContainer = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/ItemList.tsx
var ItemList = __webpack_require__("./src/renderer/pages/common/ItemList.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__("./src/renderer/pages/common/Page.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/GameStripe.tsx
var GameStripe = __webpack_require__("./src/renderer/pages/common/GameStripe.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__("./src/common/format/filesize.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/LocationsPage/LocationSizeBar.tsx




const LocationSizeDiv = styles["h" /* default */].div `
  width: 400px;

  .progress-wrapper {
    font-size: ${(props) => props.theme.fontSizes.smaller};
    &:hover {
      cursor: pointer;
    }
  }

  .progress {
    background: #555;
    padding: 2px 8px;
    position: relative;
    ${styles["s" /* singleLine */]};

    &,
    .progress-inner {
      border-radius: 2px;
    }

    .progress-inner {
      background: white;
      position: absolute;
      left: 0;
      top: 0;
      bottom: 0;
    }

    .progress-label {
      color: white;
      mix-blend-mode: difference;
    }
  }
`;
class LocationSizeBar_LocationSizeBar extends react_default.a.PureComponent {
    render() {
        const { location } = this.props;
        if (!location) {
            return null;
        }
        const { sizeInfo } = location;
        if (!sizeInfo || sizeInfo.totalSize < 0) {
            return "Not available";
        }
        const { totalSize, freeSize, installedSize } = sizeInfo;
        return (react_default.a.createElement(LocationSizeDiv, null,
            react_default.a.createElement("div", { className: "progress-wrapper", "data-rh": JSON.stringify([
                    "preferences.install_location.size_used_by_games",
                    { installedSize: Object(filesize["a" /* fileSize */])(installedSize) },
                ]) },
                react_default.a.createElement("div", { className: "progress" },
                    react_default.a.createElement("div", { className: "progress-inner", style: {
                            right: `${(freeSize / totalSize) * 100}%`,
                        } }),
                    react_default.a.createElement("span", { className: "progress-label" }, Object(t["a" /* T */])([
                        "preferences.install_location.free_of_total",
                        {
                            freeSize: Object(filesize["a" /* fileSize */])(freeSize),
                            totalSize: Object(filesize["a" /* fileSize */])(totalSize),
                        },
                    ]))))));
    }
}

// EXTERNAL MODULE: ./src/renderer/pages/PageStyles/games.tsx
var games = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/LocationsPage/LocationSummary.tsx













const LocationStripe = Object(GameStripe["a" /* makeGameStripe */])(butlerd["h" /* messages */].FetchCaves);
const SizeTag = styles["h" /* default */].div `
  margin-left: 1em;
  font-size: ${(props) => props.theme.fontSizes.baseText};
`;
class LocationSummary_LocationSummary extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.getGame = LocationStripe.getGameCallback((cave) => cave.game);
        this.renderTitleExtras = () => {
            const { location } = this.props;
            let installedSize;
            if (location && location.sizeInfo && location.sizeInfo.installedSize > 0) {
                installedSize = Object(filesize["a" /* fileSize */])(location.sizeInfo.installedSize);
            }
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(SizeTag, null, installedSize
                    ? Object(t["a" /* T */])(Object(t["c" /* _ */])("preferences.install_location.size_used_by_games", {
                        installedSize,
                    }))
                    : Object(t["a" /* T */])(Object(t["c" /* _ */])("preferences.install_location.empty"))),
                react_default.a.createElement(Filler["a" /* default */], null),
                react_default.a.createElement(games["d" /* TitleBreak */], null),
                react_default.a.createElement(LocationSizeBar_LocationSizeBar, { location: location }),
                react_default.a.createElement(IconButton["a" /* default */], { icon: "more_vert", onClick: this.onMoreActions })));
        };
        this.onMoreActions = (e) => {
            e.preventDefault();
            const { location, numLocations } = this.props;
            const mayDelete = numLocations > 1;
            let template = [];
            template.push({
                localizedLabel: ["preferences.install_location.navigate"],
                action: actions["a" /* actions */].navigate({
                    wind: "root",
                    url: Object(navigation["j" /* urlForInstallLocation */])(location.id),
                }),
                id: "context--install-location-navigate",
            });
            if (mayDelete) {
                template.push({
                    localizedLabel: ["preferences.install_location.delete"],
                    action: actions["a" /* actions */].removeInstallLocation({ id: location.id }),
                    id: "context--install-location-delete",
                });
            }
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].popupContextMenu({
                wind: Object(navigation["d" /* ambientWind */])(),
                clientX: e.clientX,
                clientY: e.clientY,
                template,
            }));
        };
    }
    render() {
        const { location } = this.props;
        return (react_default.a.createElement(LocationStripe, { title: `${location.path}`, renderTitleExtras: this.renderTitleExtras, params: {
                filters: {
                    installLocationId: location.id,
                },
            }, href: `itch://locations/${location.id}`, getGame: this.getGame }));
    }
}
/* harmony default export */ var LocationsPage_LocationSummary = (Object(hook["a" /* hook */])()(LocationSummary_LocationSummary));

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");

// CONCATENATED MODULE: ./src/renderer/pages/LocationsPage/index.tsx


















const ListInstallLocations = Object(butlerCaller["b" /* default */])(butlerd["h" /* messages */].InstallLocationsList);
const Spacer = styles["h" /* default */].div `
  width: 8px;
`;
class LocationsPage_LocationsPage extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.renderCallContents = ListInstallLocations.renderCallback(({ loading, result }) => {
            const { scanningLocations, locationScanProgress } = this.props;
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(FiltersContainer["b" /* default */], { loading: loading }),
                react_default.a.createElement(SortsAndFilters["f" /* SortsAndFilters */], null,
                    react_default.a.createElement(SortsAndFilters["a" /* FilterGroup */], null,
                        react_default.a.createElement(SortsAndFilters["d" /* FilterOptionLink */], { href: "itch://scan-install-locations", className: classnames_default()({ disabled: scanningLocations }) },
                            react_default.a.createElement(SortsAndFilters["c" /* FilterOptionIcon */], { icon: "search" }),
                            Object(t["a" /* T */])(["preferences.scan_install_locations"]),
                            scanningLocations ? (react_default.a.createElement(react_default.a.Fragment, null,
                                react_default.a.createElement(Spacer, null),
                                react_default.a.createElement(LoadingCircle["a" /* default */], { progress: locationScanProgress }))) : null)),
                    react_default.a.createElement(SortsAndFilters["e" /* FilterSpacer */], null),
                    react_default.a.createElement(SortsAndFilters["a" /* FilterGroup */], null,
                        react_default.a.createElement(SortsAndFilters["b" /* FilterOptionButton */], { onClick: this.onAddLocation },
                            react_default.a.createElement(SortsAndFilters["c" /* FilterOptionIcon */], { icon: "plus" }),
                            Object(t["a" /* T */])(["preferences.install_location.add"])))),
                this.renderList(result)));
        });
        this.renderList = (result) => {
            if (!result || Object(index_all["k" /* isEmpty */])(result.installLocations)) {
                return null;
            }
            const locations = result.installLocations;
            const numLocations = Object(index_all["q" /* size */])(locations);
            return (react_default.a.createElement(ItemList["a" /* default */], null, Object(index_all["r" /* sortBy */])(result.installLocations, (location) => -location.sizeInfo.installedSize).map((location) => (react_default.a.createElement(LocationsPage_LocationSummary, { key: location.id, location: location, numLocations: numLocations })))));
        };
        this.onAddLocation = (ev) => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].addInstallLocation({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
    }
    render() {
        return (react_default.a.createElement(Page["a" /* default */], null,
            react_default.a.createElement(ListInstallLocations, { params: { sequence: this.props.sequence }, loadingHandled: true, render: this.renderCallContents })));
    }
    componentDidMount() {
        Object(tab_utils["i" /* dispatchTabPageUpdate */])(this.props, { label: ["install_locations.manage"] });
    }
}
/* harmony default export */ var pages_LocationsPage = __webpack_exports__["default"] = (Object(withTab["b" /* withTab */])(Object(hook["a" /* hook */])((map) => ({
    scanningLocations: map((rs) => rs.system.locationScanProgress !== null),
    locationScanProgress: map((rs) => rs.system.locationScanProgress),
}))(LocationsPage_LocationsPage)));


/***/ }),

/***/ "./src/renderer/pages/common/GameStripe.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return makeGameStripe; });
/* unused harmony export makeStripeCallbacks */
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var main_net_errors__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/main/net/errors.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/ErrorState.tsx");
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/Floater.tsx");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/pages/common/StandardGameCover.tsx");














const StripeDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  display: flex;
  flex-direction: row;
  align-items: center;
  width: 100%;
  overflow: hidden;
  position: relative;

  height: ${renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__[/* standardCoverHeight */ "b"] + 2}px;

  padding: 1.2em 0;
  margin-bottom: 32px;
`;
const FloaterContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  background: ${(props) => props.theme.breadBackground};
  opacity: 0.7;
  padding: 4px;

  position: absolute;
  left: 5px;
  top: 5px;
  z-index: 20;
`;
const ViewAll = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].a `
  position: absolute;
  background: ${(props) => props.theme.breadBackground};
  box-shadow: 0 0 30px ${(props) => props.theme.breadBackground};
  padding: 0 4em;
  top: 0;
  bottom: 0;
  right: 0;
  display: flex;
  flex-direction: row;
  align-items: center;
  overflow: hidden;

  z-index: 4;
`;
const StripeItemDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* boxy */ "c"]};
  flex-shrink: 0;
  margin-right: 0.8em;
`;
const stripeLimit = 12;
function makeGameStripe(rc) {
    const Call = Object(renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_6__[/* default */ "b"])(rc);
    const hasItems = (result) => {
        if (!result) {
            return false;
        }
        return !Object(underscore__WEBPACK_IMPORTED_MODULE_12__[/* isEmpty */ "k"])(result.items);
    };
    class Stripe extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.renderCallContents = Call.renderCallback(({ result, error, loading }) => (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null,
                this.renderTitle(loading, result, error),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeDiv, null,
                    loading ? (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(FloaterContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], null))) : null,
                    this.renderViewAll(),
                    this.renderItems(result),
                    this.renderEmpty()))));
        }
        render() {
            const { params, sequence } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(Call, { params: Object.assign(Object.assign({}, params), { limit: stripeLimit }), sequence: sequence, loadingHandled: true, errorsHandled: true, render: this.renderCallContents }));
        }
        renderTitle(loading, result, error) {
            const { linkId, href, title, renderTitleExtras = renderNoop, } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null,
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__[/* TitleBox */ "c"], null,
                    react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__[/* Title */ "b"], null,
                        react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement("a", { id: linkId, href: href }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_11__[/* T */ "a"])(title)),
                        renderTitleExtras())),
                this.renderError(result, error)));
        }
        renderError(result, error) {
            if (!error) {
                return null;
            }
            if (hasItems(result) && Object(main_net_errors__WEBPACK_IMPORTED_MODULE_2__[/* isNetworkError */ "a"])(error)) {
                return null;
            }
            return react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { error: error });
        }
        renderItems(result) {
            if (!result) {
                return null;
            }
            if (Object(underscore__WEBPACK_IMPORTED_MODULE_12__[/* isEmpty */ "k"])(result.items)) {
                return null;
            }
            const doneSet = new Set();
            const { getGame } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null, result.items.map((item) => {
                const game = getGame(item);
                if (!game || doneSet.has(game.id)) {
                    return null;
                }
                doneSet.add(game.id);
                return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItem, { key: game.id, className: "stripe--item", "data-game-id": game.id, game: game }));
            })));
        }
        renderEmpty() {
            const { dispatch } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((id) => (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItem, { key: `empty-${id}` })))));
        }
        renderViewAll() {
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(ViewAll, { href: this.props.href }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_11__[/* T */ "a"])(["game_stripe.view_all"])));
        }
    }
    let result = Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_8__[/* withTab */ "b"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__[/* hookWithProps */ "b"])(Stripe)((map) => ({
        sequence: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).sequence),
    }))(Stripe));
    function identity(t) {
        return t;
    }
    let augmentedResult = result;
    augmentedResult.getGameCallback = identity;
    return augmentedResult;
}
function makeStripeCallbacks(rc) {
    return {
        getGame(f) {
            return f;
        },
    };
}
function renderNoop() {
    return null;
}
class StripeItem extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
    render() {
        const _a = this.props, { game } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["game"]);
        return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItemDiv, Object.assign({}, restProps),
            react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], { game: game, showInfo: true })));
    }
}


/***/ }),

/***/ "./src/renderer/pages/common/ItemList.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

/* harmony default export */ __webpack_exports__["a"] = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-grow: 1;
  overflow-y: auto;
  padding: 0 12px;

  user-select: none;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;
`);


/***/ }),

/***/ "./src/renderer/pages/common/SortsAndFilters.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return SortsAndFilters; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FilterGroup; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return FilterOptionLink; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FilterOptionButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return FilterOptionIcon; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return FilterSpacer; });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const SortsAndFilters = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__[/* FiltersContainerDiv */ "a"]) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* css */ "g"] `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  ${optionButtonLike};
`;
const FilterOptionIcon = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ })

}]);
//# sourceMappingURL=20.chunk.js.map