(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[24],{

/***/ "./src/main/net/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return isNetworkError; });
/* unused harmony export RequestError */
/* unused harmony export RequestTimeout */
/* unused harmony export RequestAborted */
/* unused harmony export RequestFormattingFailure */
/* unused harmony export RequestParsingFailure */
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


/**
 * Returns true if this is a network error
 */
function isNetworkError(e) {
    // this operates under the assumption that:
    //   * all our internal network errors should start with "err::"
    //   * all of chrome's already do
    //   * we transform fetch's into err:: variants.
    // we coerce e.message into a string on the off chance that it's not defined
    // or not a string.
    const isJavaScriptNetworkError = e && ("" + e.message).indexOf("net::") === 0;
    if (isJavaScriptNetworkError) {
        return true;
    }
    const re = Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re) {
        if (re.rpcError.code === common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__["Code"].NetworkDisconnected) {
            return true;
        }
    }
    return false;
}
class RequestError extends Error {
    constructor(message) {
        super(message.indexOf("net::") == 0 ? message : "net::REQUEST_ERROR::");
    }
}
class RequestTimeout extends RequestError {
    constructor() {
        super("TIMED_OUT");
    }
}
class RequestAborted extends RequestError {
    constructor() {
        super("ABORTED");
    }
}
class RequestFormattingFailure extends RequestError {
    constructor(message) {
        super("FORMATTING_FAILURE: " + message);
    }
}
class RequestParsingFailure extends RequestError {
    constructor(message) {
        super("PARSING_FAILURE: " + message);
    }
}


/***/ }),

/***/ "./src/renderer/pages/LibraryPage/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/FiltersContainer.tsx + 1 modules
var FiltersContainer = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withProfile.tsx
var withProfile = __webpack_require__("./src/renderer/hocs/withProfile.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/ItemList.tsx
var ItemList = __webpack_require__("./src/renderer/pages/common/ItemList.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__("./src/renderer/pages/common/Page.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/GameStripe.tsx
var GameStripe = __webpack_require__("./src/renderer/pages/common/GameStripe.tsx");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// CONCATENATED MODULE: ./src/renderer/pages/common/ScanningIndicator.tsx






const ScanningIndicatorDiv = styles["h" /* default */].div `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  height: 15px;
  opacity: 0;
  transition: all 0.4s;

  display: flex;
  flex-flow: row;
  align-items: center;
  padding: 0 12px;

  .spacer {
    width: 8px;
  }

  &.active {
    opacity: 1;
  }
`;
class ScanningIndicator_ScanningIndicator extends react_default.a.PureComponent {
    render() {
        const { progress } = this.props;
        const active = progress !== null;
        return (react_default.a.createElement(ScanningIndicatorDiv, { className: classnames_default()({ active }) }, active ? (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(LoadingCircle["a" /* default */], { progress: progress }),
            react_default.a.createElement("div", { className: "spacer" }),
            Object(t["a" /* T */])(Object(t["c" /* _ */])("preferences.scan_install_locations.title")))) : null));
    }
}
/* harmony default export */ var common_ScanningIndicator = (Object(hook["a" /* hook */])((map) => ({
    progress: map((rs) => rs.system.locationScanProgress),
}))(ScanningIndicator_ScanningIndicator));

// CONCATENATED MODULE: ./src/renderer/pages/LibraryPage/index.tsx












const OwnedGameStripe = Object(GameStripe["a" /* makeGameStripe */])(butlerd["h" /* messages */].FetchProfileOwnedKeys);
const InstalledGameStripe = Object(GameStripe["a" /* makeGameStripe */])(butlerd["h" /* messages */].FetchCaves);
class LibraryPage_LibraryPage extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.ownedGetGame = OwnedGameStripe.getGameCallback((x) => x.game);
        this.installedGetGame = InstalledGameStripe.getGameCallback((x) => x.game);
        this.installedTitleExtras = () => {
            return react_default.a.createElement(common_ScanningIndicator, null);
        };
    }
    render() {
        const { profile } = this.props;
        return (react_default.a.createElement(Page["a" /* default */], null,
            react_default.a.createElement(FiltersContainer["b" /* default */], { loading: false }),
            react_default.a.createElement(ItemList["a" /* default */], null,
                react_default.a.createElement(OwnedGameStripe, { title: Object(t["c" /* _ */])("sidebar.owned"), href: "itch://library/owned", params: { profileId: profile.id }, getGame: this.ownedGetGame, linkId: "library-owned" }),
                react_default.a.createElement(InstalledGameStripe, { title: Object(t["c" /* _ */])("sidebar.installed"), href: "itch://library/installed", params: { sortBy: "lastTouched" }, getGame: this.installedGetGame, renderTitleExtras: this.installedTitleExtras, linkId: "library-installed" }))));
    }
    componentDidMount() {
        Object(tab_utils["i" /* dispatchTabPageUpdate */])(this.props, { label: ["sidebar.library"] });
    }
}
/* harmony default export */ var pages_LibraryPage = __webpack_exports__["default"] = (Object(withProfile["b" /* withProfile */])(Object(withTab["b" /* withTab */])(Object(hook["a" /* hook */])()(LibraryPage_LibraryPage))));


/***/ }),

/***/ "./src/renderer/pages/common/GameStripe.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return makeGameStripe; });
/* unused harmony export makeStripeCallbacks */
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var main_net_errors__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/main/net/errors.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/ErrorState.tsx");
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/Floater.tsx");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/pages/common/StandardGameCover.tsx");














const StripeDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  display: flex;
  flex-direction: row;
  align-items: center;
  width: 100%;
  overflow: hidden;
  position: relative;

  height: ${renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__[/* standardCoverHeight */ "b"] + 2}px;

  padding: 1.2em 0;
  margin-bottom: 32px;
`;
const FloaterContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  background: ${(props) => props.theme.breadBackground};
  opacity: 0.7;
  padding: 4px;

  position: absolute;
  left: 5px;
  top: 5px;
  z-index: 20;
`;
const ViewAll = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].a `
  position: absolute;
  background: ${(props) => props.theme.breadBackground};
  box-shadow: 0 0 30px ${(props) => props.theme.breadBackground};
  padding: 0 4em;
  top: 0;
  bottom: 0;
  right: 0;
  display: flex;
  flex-direction: row;
  align-items: center;
  overflow: hidden;

  z-index: 4;
`;
const StripeItemDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_10__[/* boxy */ "c"]};
  flex-shrink: 0;
  margin-right: 0.8em;
`;
const stripeLimit = 12;
function makeGameStripe(rc) {
    const Call = Object(renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_6__[/* default */ "b"])(rc);
    const hasItems = (result) => {
        if (!result) {
            return false;
        }
        return !Object(underscore__WEBPACK_IMPORTED_MODULE_12__[/* isEmpty */ "k"])(result.items);
    };
    class Stripe extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.renderCallContents = Call.renderCallback(({ result, error, loading }) => (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null,
                this.renderTitle(loading, result, error),
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeDiv, null,
                    loading ? (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(FloaterContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], null))) : null,
                    this.renderViewAll(),
                    this.renderItems(result),
                    this.renderEmpty()))));
        }
        render() {
            const { params, sequence } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(Call, { params: Object.assign(Object.assign({}, params), { limit: stripeLimit }), sequence: sequence, loadingHandled: true, errorsHandled: true, render: this.renderCallContents }));
        }
        renderTitle(loading, result, error) {
            const { linkId, href, title, renderTitleExtras = renderNoop, } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null,
                react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__[/* TitleBox */ "c"], null,
                    react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_9__[/* Title */ "b"], null,
                        react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement("a", { id: linkId, href: href }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_11__[/* T */ "a"])(title)),
                        renderTitleExtras())),
                this.renderError(result, error)));
        }
        renderError(result, error) {
            if (!error) {
                return null;
            }
            if (hasItems(result) && Object(main_net_errors__WEBPACK_IMPORTED_MODULE_2__[/* isNetworkError */ "a"])(error)) {
                return null;
            }
            return react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { error: error });
        }
        renderItems(result) {
            if (!result) {
                return null;
            }
            if (Object(underscore__WEBPACK_IMPORTED_MODULE_12__[/* isEmpty */ "k"])(result.items)) {
                return null;
            }
            const doneSet = new Set();
            const { getGame } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null, result.items.map((item) => {
                const game = getGame(item);
                if (!game || doneSet.has(game.id)) {
                    return null;
                }
                doneSet.add(game.id);
                return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItem, { key: game.id, className: "stripe--item", "data-game-id": game.id, game: game }));
            })));
        }
        renderEmpty() {
            const { dispatch } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_3___default.a.Fragment, null, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((id) => (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItem, { key: `empty-${id}` })))));
        }
        renderViewAll() {
            return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(ViewAll, { href: this.props.href }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_11__[/* T */ "a"])(["game_stripe.view_all"])));
        }
    }
    let result = Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_8__[/* withTab */ "b"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__[/* hookWithProps */ "b"])(Stripe)((map) => ({
        sequence: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).sequence),
    }))(Stripe));
    function identity(t) {
        return t;
    }
    let augmentedResult = result;
    augmentedResult.getGameCallback = identity;
    return augmentedResult;
}
function makeStripeCallbacks(rc) {
    return {
        getGame(f) {
            return f;
        },
    };
}
function renderNoop() {
    return null;
}
class StripeItem extends react__WEBPACK_IMPORTED_MODULE_3___default.a.PureComponent {
    render() {
        const _a = this.props, { game } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["game"]);
        return (react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(StripeItemDiv, Object.assign({}, restProps),
            react__WEBPACK_IMPORTED_MODULE_3___default.a.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], { game: game, showInfo: true })));
    }
}


/***/ }),

/***/ "./src/renderer/pages/common/ItemList.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

/* harmony default export */ __webpack_exports__["a"] = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-grow: 1;
  overflow-y: auto;
  padding: 0 12px;

  user-select: none;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;
`);


/***/ })

}]);
//# sourceMappingURL=24.chunk.js.map