(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[27],{

/***/ "./src/common/util/resources.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ getImageURL; });
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ getInjectURL; });

// UNUSED EXPORTS: getImagePath, getLocalePath, getLocalesConfigPath, getInjectPath, getRendererFilePath

// EXTERNAL MODULE: external "path"
var external_path_ = __webpack_require__("path");

// EXTERNAL MODULE: external "electron"
var external_electron_ = __webpack_require__("electron");
var external_electron_default = /*#__PURE__*/__webpack_require__.n(external_electron_);

// CONCATENATED MODULE: ./src/common/helpers/app.ts

let app;
if (process.type) {
    app = external_electron_default.a.app || external_electron_default.a.remote.app;
}
function getAppPath() {
    if (!app) {
        return `<app path>`;
    }
    return app.getAppPath();
}
function getVersion() {
    if (!app) {
        return `<test version>`;
    }
    return app.getVersion();
}

// CONCATENATED MODULE: ./src/common/util/resources.ts


let absoluteAppPath = Object(external_path_["join"])(getAppPath(), "src");
let absoluteMainDistPath = Object(external_path_["join"])(getAppPath(), "dist", "main");
let absoluteRendererDistPath = Object(external_path_["join"])(getAppPath(), "dist", "renderer");
/*
 * Resources are files shipped with the app, that are static
 * and don't usually change, unless updated.
 */
function getPath(resourcePath) {
    return absoluteAppPath + "/" + resourcePath;
}
function getImagePath(path) {
    const resourcePath = "static/images/" + path;
    return getPath(resourcePath);
}
function getImageURL(path) {
    return `file://${getImagePath(path)}`;
}
function getLocalePath(path) {
    const resourcePath = "static/locales/" + path;
    return getPath(resourcePath);
}
function getLocalesConfigPath() {
    let resourcePath = "static/locales.json";
    return getPath(resourcePath);
}
function getInjectPath(name) {
    return Object(external_path_["join"])(absoluteMainDistPath, `inject-${name}.bundle.js`);
}
function getInjectURL(name) {
    return `file://${getInjectPath(name)}`;
}
function getRendererFilePath(name) {
    return Object(external_path_["join"])(absoluteRendererDistPath, name);
}


/***/ }),

/***/ "./src/renderer/modal-widgets/RecaptchaInput.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var common_util_resources__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/common/util/resources.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var common_modals__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/common/modals/index.ts");









const WidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_7__[/* default */ "h"].div `
  position: relative;
  height: 100%;
  padding: 20px;

  webview {
    position: absolute;
    top: 0px;
    left: 0px;
    bottom: 0px;
    right: 0px;
  }

  &.loading {
    webview {
      width: 0;
      height: 0;
    }
  }
`;
class RecaptchaInput extends react__WEBPACK_IMPORTED_MODULE_4___default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.gotWebview = (wv) => {
            this.webview = wv;
            this.clearChecker();
            if (!this.webview) {
                return;
            }
            this.webview.addEventListener("did-finish-load", () => {
                this.setState({ loaded: true });
            });
            this.checker = window.setInterval(() => {
                this.webview
                    .executeJavaScript(`window.captchaResponse`, false)
                    .then((response) => {
                    if (response) {
                        const { dispatch } = this.props;
                        dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].closeModal({
                            wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_2__[/* ambientWind */ "d"])(),
                            action: common_modals__WEBPACK_IMPORTED_MODULE_8__[/* modals */ "a"].recaptchaInput.action({
                                recaptchaResponse: response,
                            }),
                        }));
                    }
                })
                    .catch((e) => {
                    console.error(e);
                });
            }, 500);
        };
        this.state = {
            loaded: false,
        };
    }
    render() {
        const params = this.props.modal.widgetParams;
        const { url } = params;
        const { loaded } = this.state;
        const classes = classnames__WEBPACK_IMPORTED_MODULE_0___default()("modal-widget", { loaded });
        return (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(WidgetDiv, { className: classes },
            loaded ? null : react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { progress: -1 }),
            react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement("webview", { ref: this.gotWebview, src: url, preload: Object(common_util_resources__WEBPACK_IMPORTED_MODULE_3__[/* getInjectURL */ "b"])("captcha"), enableremotemodule: "false", webpreferences: "worldSafeExecuteJavaScript" })));
    }
    componentWillUnmount() {
        this.clearChecker();
    }
    clearChecker() {
        if (this.checker) {
            clearInterval(this.checker);
            this.checker = null;
        }
    }
}
/* harmony default export */ __webpack_exports__["default"] = (Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_6__[/* hook */ "a"])()(RecaptchaInput));


/***/ })

}]);
//# sourceMappingURL=27.chunk.js.map