(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[29],{

/***/ "./src/renderer/modal-widgets/SwitchVersionCave/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__("./src/common/format/datetime.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./node_modules/polished/dist/polished.esm.js + 10 modules
var polished_esm = __webpack_require__("./node_modules/polished/dist/polished.esm.js");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/modal-widgets/styles.tsx
var styles = __webpack_require__("./src/renderer/modal-widgets/styles.tsx");

// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__("./node_modules/react-intl/lib/src/components/injectIntl.js");

// CONCATENATED MODULE: ./src/renderer/modal-widgets/SwitchVersionCave/CustomDate.tsx



class CustomDate_CustomDate extends react_default.a.PureComponent {
    render() {
        const { intl, date, format = datetime["a" /* DATE_FORMAT */] } = this.props;
        const dateObject = new Date(date);
        if (!dateObject) {
            return null;
        }
        if (!dateObject.getTime || isNaN(dateObject.getTime())) {
            console.warn("CustomDate was passed an invalid date: ", this.props.date);
            return null;
        }
        return react_default.a.createElement(react_default.a.Fragment, null, Object(datetime["d" /* formatDate */])(dateObject, intl.locale, format));
    }
}
/* harmony default export */ var SwitchVersionCave_CustomDate = (Object(injectIntl["c" /* default */])(CustomDate_CustomDate));

// EXTERNAL MODULE: ./src/renderer/styles.ts
var renderer_styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// CONCATENATED MODULE: ./src/renderer/modal-widgets/SwitchVersionCave/index.tsx












const BuildListDiv = renderer_styles["h" /* default */].div `
  width: 100%;
  max-height: 400px;

  padding-right: 15px;

  overflow-y: scroll;

  .builds--month {
    width: 100%;
    border-left: 2px solid ${(props) => props.theme.accent};
    margin-top: 24px;
    padding-left: 12px;
    padding-top: 8px;
    padding-bottom: 8px;
    font-size: ${(props) => props.theme.fontSizes.larger};
    font-weight: bold;
  }

  .builds--item {
    display: flex;
    flex-direction: row;

    width: 100%;
    margin: 8px 0;
    background: ${(props) => props.theme.sidebarBackground};
    padding: 12px 16px;
    align-items: center;

    &:hover {
      cursor: pointer;
      background: ${(props) => Object(polished_esm["b" /* lighten */])(0.05, props.theme.sidebarBackground)};
    }

    .item--version {
      display: flex;
      flex-direction: column;
      flex-shrink: 0;
    }

    .filler {
      flex-grow: 1;
    }

    .spacer {
      flex-shrink: 0;
      width: 16px;
    }
  }

  .version--user {
    font-weight: bold;
    font-size: ${(props) => props.theme.fontSizes.large};
    margin-right: 16px;
  }

  .version--raw,
  .version--timeago {
    color: ${(props) => props.theme.secondaryText};
  }
`;
function monthFor(b) {
    const date = new Date(b.updatedAt);
    return date.getUTCFullYear() * 12 + date.getUTCMonth();
}
class SwitchVersionCave_SwitchVersionCave extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (ev) => {
            const index = parseInt(ev.currentTarget.dataset.index, 10);
            const res = { index };
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].closeModal({
                wind: Object(navigation["d" /* ambientWind */])(),
                action: actions["a" /* actions */].modalResponse(res),
            }));
        };
    }
    render() {
        const { builds } = this.props.modal.widgetParams;
        const buildElements = [];
        if (Object(index_all["k" /* isEmpty */])(builds)) {
            buildElements.push(react_default.a.createElement(react_default.a.Fragment, null, Object(t["a" /* T */])(["prompt.revert.no_other_version"])));
        }
        else {
            let lastMonth = 0;
            for (let index = 0; index < builds.length; index++) {
                const build = builds[index];
                const month = monthFor(build);
                if (month != lastMonth) {
                    const monthDate = build.updatedAt;
                    buildElements.push(react_default.a.createElement("div", { key: `month-${month}`, className: "builds--month" },
                        react_default.a.createElement(SwitchVersionCave_CustomDate, { date: new Date(monthDate), format: datetime["c" /* MONTH_YEAR_FORMAT */] })));
                    lastMonth = month;
                }
                buildElements.push(this.renderBuild(index, build));
            }
        }
        return (react_default.a.createElement(styles["a" /* ModalWidgetDiv */], null,
            react_default.a.createElement(BuildListDiv, null, buildElements)));
    }
    renderBuild(index, b) {
        const version = b.userVersion || b.version;
        const updatedAt = b.updatedAt;
        return (react_default.a.createElement("div", { className: "builds--item", key: b.id, "data-index": index, onClick: this.onClick },
            react_default.a.createElement(Icon["a" /* default */], { icon: "history" }),
            react_default.a.createElement("div", { className: "spacer" }),
            version ? (react_default.a.createElement("div", { className: "version--user" }, Object(t["a" /* T */])(["prompt.revert.version", { version }]))) : null,
            react_default.a.createElement("div", { className: "version--raw" }, `#${b.id}`),
            react_default.a.createElement("div", { className: "filler" }),
            react_default.a.createElement("div", { className: "spacer" }),
            react_default.a.createElement("div", { className: "timeago", "data-rh": JSON.stringify({ date: updatedAt }) },
                react_default.a.createElement(SwitchVersionCave_CustomDate, { date: updatedAt, format: datetime["b" /* DAY_MONTH_FORMAT */] }))));
    }
}
/* harmony default export */ var modal_widgets_SwitchVersionCave = __webpack_exports__["default"] = (Object(hook["a" /* hook */])()(SwitchVersionCave_SwitchVersionCave));


/***/ }),

/***/ "./src/renderer/modal-widgets/styles.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalWidgetDiv; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* heavyInput */ "j"]};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=29.chunk.js.map