(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[5],{

/***/ "./src/common/format/show-in-explorer.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return showInExplorerString; });
function showInExplorerString() {
    switch (process.platform) {
        case "linux": {
            return ["grid.item.open_file_location.linux"];
        }
        case "darwin": {
            return ["grid.item.open_file_location.osx"];
        }
        case "win32":
        default: {
            return ["grid.item.open_file_location.windows"];
        }
    }
}


/***/ }),

/***/ "./src/common/format/upload.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return formatUploadTitle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return formatUploadTitleFancy; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatBuildVersionInfo; });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ "./src/main/net/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return isNetworkError; });
/* unused harmony export RequestError */
/* unused harmony export RequestTimeout */
/* unused harmony export RequestAborted */
/* unused harmony export RequestFormattingFailure */
/* unused harmony export RequestParsingFailure */
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


/**
 * Returns true if this is a network error
 */
function isNetworkError(e) {
    // this operates under the assumption that:
    //   * all our internal network errors should start with "err::"
    //   * all of chrome's already do
    //   * we transform fetch's into err:: variants.
    // we coerce e.message into a string on the off chance that it's not defined
    // or not a string.
    const isJavaScriptNetworkError = e && ("" + e.message).indexOf("net::") === 0;
    if (isJavaScriptNetworkError) {
        return true;
    }
    const re = Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re) {
        if (re.rpcError.code === common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__["Code"].NetworkDisconnected) {
            return true;
        }
    }
    return false;
}
class RequestError extends Error {
    constructor(message) {
        super(message.indexOf("net::") == 0 ? message : "net::REQUEST_ERROR::");
    }
}
class RequestTimeout extends RequestError {
    constructor() {
        super("TIMED_OUT");
    }
}
class RequestAborted extends RequestError {
    constructor() {
        super("ABORTED");
    }
}
class RequestFormattingFailure extends RequestError {
    constructor(message) {
        super("FORMATTING_FAILURE: " + message);
    }
}
class RequestParsingFailure extends RequestError {
    constructor(message) {
        super("PARSING_FAILURE: " + message);
    }
}


/***/ }),

/***/ "./src/renderer/basics/EmptyState.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/t.tsx");





const EmptyStateDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  color: ${(props) => props.theme.secondaryText};
  width: 100%;
  text-align: center;
  margin: 60px 0;

  .leader {
    display: inline-block;
    font-size: 170px;
    margin-bottom: 20px;
  }

  h1 {
    font-size: ${(props) => props.theme.fontSizes.enormous};
    font-weight: bold;
    margin-bottom: 10px;
  }

  h2 {
    font-size: ${(props) => props.theme.fontSizes.huge};
  }
`;
const ButtonContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  margin: 20px;
  display: inline-block;
`;
const EmptyStateContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"].div `
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  overflow: hidden;
`;
class EmptyState extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
    render() {
        const { bigText, smallText, icon, buttonIcon, buttonText, buttonAction, componentAction, className, } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(EmptyStateContainer, null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(EmptyStateDiv, { className: className },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { icon: icon, className: "leader" }),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h1", null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(bigText)),
                smallText ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h2", null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(smallText)) : null,
                componentAction,
                buttonAction ? (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
                    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(ButtonContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"], { icon: buttonIcon, primary: true, onClick: buttonAction }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(buttonText))))) : null)));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (EmptyState);


/***/ }),

/***/ "./src/renderer/basics/GameStatusGetter.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/helpers/get-game-status.ts");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/hocs/hook.tsx");



class GameStatusGetter extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
    render() {
        const { status, render } = this.props;
        return render(status);
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_2__[/* hookWithProps */ "b"])(GameStatusGetter)((map) => ({
    status: map((rs, props) => Object(common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_1__[/* default */ "c"])(rs, props.game, props.caveId)),
}))(GameStatusGetter));


/***/ }),

/***/ "./src/renderer/basics/Link.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* secondaryLink */ "r"]};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_1___default.a.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Link);
class Props {
}


/***/ }),

/***/ "./src/renderer/basics/MainAction.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/helpers/get-game-status.ts");
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/common/util/action-for-game.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/basics/IconButton.tsx");
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var common_helpers_secret_click__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/common/helpers/secret-click.ts");












class MainAction extends react__WEBPACK_IMPORTED_MODULE_4___default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            e.stopPropagation();
            const { dispatch, game, status } = this.props;
            const { operation, update, cave, access } = status;
            if (Object(common_helpers_secret_click__WEBPACK_IMPORTED_MODULE_11__[/* isSecretClick */ "a"])(e)) {
                if (cave) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].viewCaveDetails({ caveId: cave.id }));
                }
                return;
            }
            if (operation) {
                if (operation.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Download) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].navigate({ wind: "root", url: "itch://downloads" }));
                }
                else if (operation.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Task) {
                    if (operation.name === "launch") {
                        dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].forceCloseGameRequest({ game }));
                    }
                }
            }
            else if (cave) {
                if (update) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].showGameUpdate({ update }));
                }
                else {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].queueGame({ game }));
                }
            }
            else {
                if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].None) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].initiatePurchase({ game }));
                }
                else {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__[/* actions */ "a"].queueGame({ game }));
                }
            }
        };
    }
    render() {
        const { wide } = this.props;
        const { cave, access, operation, update } = this.props.status;
        let translucent = false;
        let iconComponent;
        let icon;
        let label;
        let primary = false;
        if (operation) {
            const { type, progress } = operation;
            translucent = true;
            if (operation.paused) {
                iconComponent = react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__[/* default */ "a"], { icon: "stopwatch" });
            }
            else if (!operation.active) {
                iconComponent = react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__[/* default */ "a"], { icon: "stopwatch" });
            }
            else {
                iconComponent = (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_8__[/* default */ "a"], { bare: true, wide: wide, progress: progress > 0 ? progress : 0.1 }));
            }
            if (type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Download) {
                if (operation.paused) {
                    label = ["grid.item.downloads_paused"];
                }
                else if (operation.active) {
                    label = ["grid.item.installing"];
                }
                else {
                    label = ["grid.item.queued"];
                }
            }
            else if (type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* OperationType */ "b"].Task) {
                const { name, stage } = operation;
                if (name === "launch") {
                    if (stage === "prepare") {
                        label = ["grid.item.running.prepare"];
                    }
                    else if (stage === "clean") {
                        label = ["grid.item.running.clean"];
                    }
                    else {
                        label = ["grid.item.running"];
                    }
                }
                else if (name === "uninstall") {
                    label = ["grid.item.uninstalling"];
                }
                else if (name === "install-queue") {
                    label = ["grid.item.queueing"];
                }
                else {
                    label = ["grid.item.installing"];
                }
            }
        }
        else if (cave) {
            if (update) {
                label = ["grid.item.update"];
                icon = "star";
            }
            else {
                const action = Object(common_util_action_for_game__WEBPACK_IMPORTED_MODULE_3__[/* actionForGame */ "a"])(this.props.game, cave);
                label = [`grid.item.${action}`];
                if (action === "open") {
                    icon = "folder-open";
                }
                else {
                    icon = "play2";
                }
                primary = true;
            }
        }
        else {
            if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Demo || access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Press) {
                label = ["grid.item.review"];
                icon = "install";
            }
            else if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Pwyw ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Free ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Key ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__[/* Access */ "a"].Edit) {
                label = ["grid.item.install"];
                icon = "install";
            }
            else {
                label = ["grid.item.buy_now"];
                icon = "shopping_cart";
            }
        }
        if (!label) {
            return null;
        }
        const { iconOnly, className } = this.props;
        if (iconOnly) {
            if (!iconComponent) {
                if (icon) {
                    iconComponent = react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__[/* default */ "a"], { icon: icon });
                }
            }
            return (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], { onClick: this.onClick, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(className, "main-action"), "data-game-id": this.props.game.id, icon: iconComponent, hint: label, hintPosition: "left" }));
        }
        return (react__WEBPACK_IMPORTED_MODULE_4___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { onClick: this.onClick, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(className, "main-action"), wide: wide, translucent: translucent, iconComponent: iconComponent, label: Object(renderer_t__WEBPACK_IMPORTED_MODULE_9__[/* T */ "a"])(label), primary: primary, "data-game-id": this.props.game.id }));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__[/* hook */ "a"])()(MainAction));


/***/ }),

/***/ "./src/renderer/basics/TotalPlaytime.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/action-for-game.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/FormattedDuration.tsx");




class TotalPlaytime extends react__WEBPACK_IMPORTED_MODULE_1___default.a.PureComponent {
    render() {
        const { game, cave, short = false } = this.props;
        let { secondsRun = 0 } = (cave || {});
        const classification = game.classification || "game";
        const classAction = Object(common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__[/* actionForGame */ "a"])(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        if (secondsRun > 0 && classAction === "launch") {
            return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null,
                short ? null : (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("label", null,
                    Object(renderer_t__WEBPACK_IMPORTED_MODULE_2__[/* T */ "a"])([`usage_stats.has_${xed}_for_duration`]),
                    " ")),
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("span", { className: "total-playtime" },
                    react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { secs: secondsRun }))));
        }
        return null;
    }
}
/* harmony default export */ __webpack_exports__["a"] = (TotalPlaytime);


/***/ }),

/***/ "./src/renderer/pages/LocationPage/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__("./src/renderer/pages/common/Page.tsx");

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__("./src/common/format/filesize.ts");

// EXTERNAL MODULE: ./src/common/format/show-in-explorer.ts
var show_in_explorer = __webpack_require__("./src/common/format/show-in-explorer.ts");

// EXTERNAL MODULE: ./src/renderer/basics/Link.tsx
var Link = __webpack_require__("./src/renderer/basics/Link.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/Sort.tsx
var Sort = __webpack_require__("./src/renderer/pages/common/Sort.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");

// EXTERNAL MODULE: ./src/renderer/series/GameSeries.tsx
var GameSeries = __webpack_require__("./src/renderer/series/GameSeries.tsx");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/pages/common/StandardMainAction.tsx
var StandardMainAction = __webpack_require__("./src/renderer/pages/common/StandardMainAction.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/TotalPlaytime.tsx
var TotalPlaytime = __webpack_require__("./src/renderer/basics/TotalPlaytime.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/LastPlayed.tsx
var LastPlayed = __webpack_require__("./src/renderer/basics/LastPlayed.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/GameStatusGetter.tsx
var GameStatusGetter = __webpack_require__("./src/renderer/basics/GameStatusGetter.tsx");

// EXTERNAL MODULE: ./src/common/format/upload.ts
var upload = __webpack_require__("./src/common/format/upload.ts");

// EXTERNAL MODULE: ./src/common/format/truncate.ts
var truncate = __webpack_require__("./src/common/format/truncate.ts");

// CONCATENATED MODULE: ./src/renderer/pages/LocationPage/LocationItemExtras.tsx














const ExtrasDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: column;
  flex-shrink: 0;
  align-items: flex-start;
`;
const SizeDiv = styles["h" /* default */].div `
  white-space: nowrap;
  flex-shrink: 0;
  min-width: 260px;

  display: flex;
  flex-direction: row;
  align-items: center;
`;
class LocationItemExtras_LocationItemExtras extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.renderPlayStats = (status) => {
            const { cave } = this.props;
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(TotalPlaytime["a" /* default */], { game: cave.game, cave: status.cave }),
                react_default.a.createElement(LastPlayed["a" /* default */], { game: cave.game, cave: status.cave })));
        };
        this.onManage = () => {
            const { dispatch, cave } = this.props;
            dispatch(actions["a" /* actions */].manageCave({
                caveId: cave.id,
            }));
        };
    }
    render() {
        const { cave } = this.props;
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(ExtrasDiv, null,
                react_default.a.createElement(SortsAndFilters["e" /* FilterSpacer */], null),
                react_default.a.createElement("div", { title: Object(upload["b" /* formatUploadTitle */])(cave.upload) }, Object(truncate["a" /* truncate */])(Object(upload["b" /* formatUploadTitle */])(cave.upload), {
                    length: 20,
                })),
                react_default.a.createElement(GameStatusGetter["a" /* default */], { game: cave.game, caveId: cave.id, render: this.renderPlayStats }),
                react_default.a.createElement(SizeDiv, null,
                    Object(t["a" /* T */])([
                        "install_location.property.size_on_disk",
                        { size: Object(filesize["a" /* fileSize */])(cave.installInfo.installedSize) },
                    ]),
                    react_default.a.createElement(SortsAndFilters["e" /* FilterSpacer */], null),
                    react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["grid.item.manage"]), onClick: this.onManage }))),
            react_default.a.createElement(StandardMainAction["a" /* default */], { game: cave.game })));
    }
}
/* harmony default export */ var LocationPage_LocationItemExtras = (Object(hook["a" /* hook */])()(LocationItemExtras_LocationItemExtras));

// CONCATENATED MODULE: ./src/renderer/pages/LocationPage/LocationContents.tsx














const CaveGameSeries = Object(GameSeries["a" /* default */])(butlerd["h" /* messages */].FetchCaves);
class LocationContents_LocationContents extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.getRecord = CaveGameSeries.getRecordCallback((cave) => cave.game);
        this.getKey = CaveGameSeries.getKeyCallback((cave) => cave.id);
        this.renderMainFilters = () => {
            const { location } = this.props;
            return (react_default.a.createElement(react_default.a.Fragment, null,
                this.renderLocationInfo(),
                "\u00A0 \u00A0",
                react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(Object(show_in_explorer["a" /* showInExplorerString */])()), onClick: this.onBrowse })));
        };
        this.renderExtraFilters = () => (react_default.a.createElement(SortsAndFilters["f" /* SortsAndFilters */], null,
            react_default.a.createElement(SortsAndFilters["a" /* FilterGroup */], null,
                react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "title", label: Object(t["c" /* _ */])("sort_by.games.title") }),
                react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "lastTouched", label: Object(t["c" /* _ */])("sort_by.games.last_touched") }),
                react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "playTime", label: Object(t["c" /* _ */])("sort_by.games.play_time") }),
                react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "installedSize", label: Object(t["c" /* _ */])("sort_by.games.size_on_disk") }),
                react_default.a.createElement(Sort["a" /* SortOption */], { sortBy: "installedAt", label: Object(t["c" /* _ */])("sort_by.games.install_date") }))));
        this.renderItemExtras = CaveGameSeries.renderItemExtrasCallback((cave) => (react_default.a.createElement(LocationPage_LocationItemExtras, { cave: cave })));
        this.onBrowse = () => {
            const { dispatch, location } = this.props;
            dispatch(actions["a" /* actions */].browseInstallLocation({
                id: location.id,
            }));
        };
    }
    render() {
        const { sortBy, sortDir, location } = this.props;
        if (!location) {
            return "Location not found";
        }
        return (react_default.a.createElement(CaveGameSeries, { params: {
                filters: { installLocationId: location.id },
                sortBy,
                reverse: sortDir === "reverse",
            }, getRecord: this.getRecord, getKey: this.getKey, renderMainFilters: this.renderMainFilters, renderExtraFilters: this.renderExtraFilters, renderItemExtras: this.renderItemExtras }));
    }
    renderLocationInfo() {
        const { location } = this.props;
        return (react_default.a.createElement("div", { className: "info" }, Object(t["a" /* T */])([
            "install_location.property.size_on_disk",
            { size: Object(filesize["a" /* fileSize */])(location.sizeInfo.installedSize) },
        ])));
    }
}
/* harmony default export */ var LocationPage_LocationContents = (Object(withTab["b" /* withTab */])(Object(hook["b" /* hookWithProps */])(LocationContents_LocationContents)((map) => ({
    installLocationId: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.firstPathElement),
    sortBy: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.sortBy),
    sortDir: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.sortDir),
}))(LocationContents_LocationContents)));

// CONCATENATED MODULE: ./src/renderer/pages/LocationPage/index.tsx









const InstallLocationsGetByID = Object(butlerCaller["b" /* default */])(butlerd["h" /* messages */].InstallLocationsGetByID);
class LocationPage_LocationPage extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onResult = InstallLocationsGetByID.onResultCallback((result) => {
            if (!(result && result.installLocation)) {
                return;
            }
            const loc = result.installLocation;
            Object(tab_utils["i" /* dispatchTabPageUpdate */])(this.props, { label: `${loc.path}` });
        });
        this.renderCallContents = InstallLocationsGetByID.renderCallback(({ result }) => {
            return (react_default.a.createElement(LocationPage_LocationContents, { location: result ? result.installLocation : null }));
        });
    }
    render() {
        const { installLocationId } = this.props;
        return (react_default.a.createElement(Page["a" /* default */], null,
            react_default.a.createElement(InstallLocationsGetByID, { params: { id: installLocationId }, onResult: this.onResult, loadingHandled: true, render: this.renderCallContents })));
    }
}
/* harmony default export */ var pages_LocationPage = __webpack_exports__["default"] = (Object(withTab["b" /* withTab */])(Object(hook["b" /* hookWithProps */])(LocationPage_LocationPage)((map) => ({
    installLocationId: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.firstPathElement),
    sortBy: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.sortBy),
    sortDir: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.query.sortDir),
}))(LocationPage_LocationPage)));


/***/ }),

/***/ "./src/renderer/pages/PageStyles/boxes.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export BaseBox */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Box; });
/* unused harmony export BoxSingle */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return BoxInner; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const BaseBox = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  margin: 1em auto;
  line-height: 1.6;
`;
const Box = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* boxy */ "c"]};
  max-width: 1200px;

  margin: 1em auto;
  line-height: 1.6;
`;
const BoxSingle = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* boxy */ "c"]};

  margin: 1em auto;
  line-height: 1.6;
`;
const BoxInner = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  width: 100%;
  display: flex;
  flex-direction: row;
  align-items: center;
`;


/***/ }),

/***/ "./src/renderer/pages/common/ItemList.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

/* harmony default export */ __webpack_exports__["a"] = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-grow: 1;
  overflow-y: auto;
  padding: 0 12px;

  user-select: none;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;
`);


/***/ }),

/***/ "./src/renderer/pages/common/Sort.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SortOption; });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/t.tsx");








const SortOptionBase = (props) => {
    const { url, active, reverse, sortBy, label } = props;
    let href;
    let baseClass = `sortby--${sortBy}`;
    if (!active) {
        baseClass = `${baseClass}--default`;
        href = Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__[/* urlWithParams */ "l"])(url, { sortBy, sortDir: "default" });
    }
    else {
        if (!reverse) {
            baseClass = `${baseClass}--reverse`;
            href = Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__[/* urlWithParams */ "l"])(url, { sortBy, sortDir: "reverse" });
        }
        else {
            baseClass = `${baseClass}--disable`;
            href = Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_4__[/* urlWithParams */ "l"])(url, { sortBy: undefined, sortDir: undefined });
        }
    }
    return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_6__[/* FilterOptionLink */ "d"], { target: "_replace", href: href, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(baseClass, { active }) },
        react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_6__[/* FilterOptionIcon */ "c"], { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ inactive: !active }), icon: active && reverse ? "sort-amount-desc" : "sort-amount-asc" }),
        Object(renderer_t__WEBPACK_IMPORTED_MODULE_7__[/* T */ "a"])(label)));
};
const hooked = Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_3__[/* hookWithProps */ "b"])(SortOptionBase)((map) => ({
    url: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.url),
    active: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.query.sortBy === props.sortBy),
    reverse: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.query.sortDir === "reverse"),
}))(SortOptionBase);
const SortOption = Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_5__[/* withTab */ "b"])(hooked);


/***/ }),

/***/ "./src/renderer/pages/common/SortsAndFilters.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return SortsAndFilters; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FilterGroup; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return FilterOptionLink; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FilterOptionButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return FilterOptionIcon; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return FilterSpacer; });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const SortsAndFilters = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__[/* FiltersContainerDiv */ "a"]) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* css */ "g"] `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  ${optionButtonLike};
`;
const FilterOptionIcon = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ }),

/***/ "./src/renderer/pages/common/StandardGameDesc.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/Filler.tsx");
/* harmony import */ var renderer_basics_PlatformIcons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/PlatformIcons/index.tsx");
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/t.tsx");






const StandardGameDesc = ({ game, children, }) => {
    if (!game) {
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* TitleBox */ "c"], null,
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* Title */ "b"], null)));
    }
    return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* TitleBox */ "c"], null,
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("a", { href: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_0__[/* urlForGame */ "i"])(game.id), className: "gamedesc--titlelink" },
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* Title */ "b"], null,
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "gamedesc--title" }, game.title),
                children)),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null, game.shortText),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], null),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null,
            renderClassification(game.classification),
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_PlatformIcons__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { target: game, before: () => react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null, "\u00A0\u00A0") }))));
};
/* harmony default export */ __webpack_exports__["a"] = (StandardGameDesc);
function renderClassification(classification) {
    let label = [`usage_stats.description.${classification}`];
    return react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_5__[/* T */ "a"])(label));
}


/***/ }),

/***/ "./src/renderer/pages/common/StandardMainAction.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_basics_GameStatusGetter__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/GameStatusGetter.tsx");
/* harmony import */ var renderer_basics_MainAction__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/MainAction.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/styles.ts");




const UncollapsibleMainAction = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_3__[/* default */ "h"])(renderer_basics_MainAction__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"]) `
  flex-shrink: 0;
`;
/* harmony default export */ __webpack_exports__["a"] = (({ game }) => (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_GameStatusGetter__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"], { game: game, render: (status) => react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(UncollapsibleMainAction, { game: game, status: status }) })));


/***/ }),

/***/ "./src/renderer/series/GameSeries.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return makeGameSeries; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_series_Series__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/series/Series.tsx");
/* harmony import */ var renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/pages/PageStyles/boxes.tsx");
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");
/* harmony import */ var renderer_pages_common_StandardGameDesc__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/pages/common/StandardGameDesc.tsx");
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/Filler.tsx");
/* harmony import */ var reselect__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./node_modules/reselect/es/index.js");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/pages/common/StandardGameCover.tsx");









let fallbackGetKey = (g) => g.id;
function makeGameSeries(rc) {
    const Series = Object(renderer_series_Series__WEBPACK_IMPORTED_MODULE_1__[/* makeSeries */ "a"])(rc);
    class GameRecordComponent extends GenericGameRecordComponent {
    }
    class GameSeries extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
        constructor(props, context) {
            super(props, context);
            this.selector = Object(reselect__WEBPACK_IMPORTED_MODULE_6__[/* createStructuredSelector */ "a"])({
                renderDescExtras: (props) => props.renderDescExtras,
                renderItemExtras: (props) => props.renderItemExtras,
            });
        }
        render() {
            const { props } = this;
            return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(Series, Object.assign({}, props, { fallbackGetKey: fallbackGetKey, RecordComponent: GameRecordComponent, extraProps: this.selector(props) })));
        }
        static getRecordCallback(f) {
            return f;
        }
        static getKeyCallback(f) {
            return f;
        }
        static renderItemExtrasCallback(f) {
            return f;
        }
    }
    return GameSeries;
}
class GenericGameRecordComponent extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
    render() {
        const { item, record, renderDescExtras = renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_7__[/* renderNoop */ "c"], renderItemExtras = renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_7__[/* renderNoop */ "c"], } = this.props;
        const game = record;
        return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_2__[/* Box */ "a"], { className: "gameseries--box", "data-game-id": game.id },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_2__[/* BoxInner */ "b"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_8__[/* default */ "a"], { game: game }),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_3__[/* FilterSpacer */ "e"], null),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_common_StandardGameDesc__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { game: game }, renderDescExtras(item)),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], null),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_3__[/* FilterSpacer */ "e"], null),
                renderItemExtras(item),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_3__[/* FilterSpacer */ "e"], null))));
    }
}


/***/ }),

/***/ "./src/renderer/series/Series.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return makeSeries; });
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var main_net_errors__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/main/net/errors.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var react_fast_compare__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/react-fast-compare/index.js");
/* harmony import */ var react_fast_compare__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react_fast_compare__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var renderer_basics_EmptyState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/EmptyState.tsx");
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/ErrorState.tsx");
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/renderer/basics/Floater.tsx");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./src/renderer/hocs/tab-utils.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");
/* harmony import */ var renderer_pages_common_ItemList__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./src/renderer/pages/common/ItemList.tsx");
/* harmony import */ var renderer_pages_common_Page__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/pages/common/Page.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");

















const LoadMoreContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_14__[/* default */ "h"].div `
  height: 200px;
  display: flex;
  align-items: center;
  justify-content: center;

  &:hover {
    cursor: pointer;
  }
`;
const LoadMoreText = renderer_styles__WEBPACK_IMPORTED_MODULE_14__[/* default */ "h"].div `
  font-size: ${(props) => props.theme.fontSizes.huge};
`;
const limit = 15;
function makeSeries(rc) {
    const Call = Object(renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__[/* default */ "b"])(rc);
    const hasItems = (result) => {
        if (!result) {
            return false;
        }
        return !Object(underscore__WEBPACK_IMPORTED_MODULE_16__[/* isEmpty */ "k"])(result.items);
    };
    class NextPageButton extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.loadNextPage = () => {
                const { cursor, loadNextPage } = this.props;
                loadNextPage(cursor);
            };
        }
        render() {
            const { gotLoadMore } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(LoadMoreContainer, { ref: gotLoadMore, onClick: this.loadNextPage },
                react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(LoadMoreText, null, "Load more...")));
        }
    }
    class SeriesPage extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.renderCallContents = Call.renderCallback(({ result, loading, error }) => {
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_2___default.a.Fragment, null,
                    this.renderError(result, error),
                    this.renderItems(result, loading),
                    this.renderNextPage(result, loading)));
            });
        }
        render() {
            const { params, cursor, limit, sequence } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(Call, { errorsHandled: true, loadingHandled: true, params: Object.assign(Object.assign({}, params), { cursor, limit }), sequence: sequence, render: this.renderCallContents }));
        }
        renderNextPage(result, loading) {
            const { gotLoadMore, loadNextPage, isLast } = this.props;
            if (result && result.nextCursor && isLast) {
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(NextPageButton, { cursor: result.nextCursor, gotLoadMore: gotLoadMore, loadNextPage: loadNextPage }));
            }
            if (!hasItems(result) && loading) {
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(LoadMoreContainer, null,
                    react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_7__[/* default */ "a"], null)));
            }
            return null;
        }
        renderError(result, error) {
            if (!error) {
                return null;
            }
            if (hasItems(result) && Object(main_net_errors__WEBPACK_IMPORTED_MODULE_1__[/* isNetworkError */ "a"])(error)) {
                return null;
            }
            return react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { error: error });
        }
        renderItems(result, loading) {
            if (!hasItems(result)) {
                if (loading) {
                    return null;
                }
                else {
                    return this.renderEmpty();
                }
            }
            const { items } = result;
            const { fallbackGetKey, getKey, getRecord, RecordComponent, extraProps, } = this.props;
            let doneSet = new Set();
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_2___default.a.Fragment, null, items.map((item) => {
                const record = getRecord(item);
                if (!record) {
                    return null;
                }
                const key = getKey ? getKey(item) : fallbackGetKey(record);
                if (doneSet.has(key)) {
                    return null;
                }
                doneSet.add(key);
                return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(RecordComponent, Object.assign({ key: key, item: item, record: record }, extraProps)));
            })));
        }
        renderEmpty() {
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_EmptyState__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { bigText: Object(renderer_t__WEBPACK_IMPORTED_MODULE_15__[/* _ */ "c"])("empty_state.nothing_to_see_here"), icon: "neutral" }));
        }
    }
    class Series extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
        constructor(props, context) {
            super(props, context);
            this.gotItemList = (itemList) => {
                this.itemList = itemList;
            };
            this.lastScrollTop = 0;
            this.onScroll = Object(underscore__WEBPACK_IMPORTED_MODULE_16__[/* throttle */ "s"])(() => {
                const { itemList } = this;
                if (!itemList) {
                    return;
                }
                const { scrollTop, scrollHeight, clientHeight } = itemList;
                if (scrollTop < this.lastScrollTop) {
                    if (this.restoreScrollInterval) {
                        console.log(`Cancelling scroll restore (scrolled up!)`);
                        clearInterval(this.restoreScrollInterval);
                        this.restoreScrollInterval = null;
                    }
                }
                this.lastScrollTop = scrollTop;
                const runwayLeft = scrollHeight - clientHeight - scrollTop;
                const shouldLoadMore = runwayLeft < 1200;
                const { loadMore } = this;
                if (shouldLoadMore && loadMore) {
                    loadMore.click();
                }
                Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__[/* dispatchTabPageUpdate */ "i"])(this.props, { scrollTop });
            }, 100);
            this.gotLoadMore = (loadMore) => {
                this.loadMore = loadMore;
            };
            this.loadNextPage = (cursor) => {
                this.setState((state) => ({
                    cursors: [...state.cursors, cursor],
                }));
            };
            this.state = {
                cursors: [null],
                lastParams: null,
            };
            if (props.restoredScrollTop) {
                console.log(`Aiming for scrollTop ${props.restoredScrollTop}`);
                this.restoreScrollInterval = window.setInterval(() => {
                    if (this.itemList) {
                        this.itemList.scrollTop = props.restoredScrollTop;
                        const { scrollTop } = this.itemList;
                        if (scrollTop === props.restoredScrollTop) {
                            console.log(`Done adjusting, final scrollTop = ${scrollTop}`);
                            clearInterval(this.restoreScrollInterval);
                            this.restoreScrollInterval = null;
                        }
                    }
                }, 160);
            }
        }
        componentWillUnmount() {
            if (this.restoreScrollInterval) {
                clearInterval(this.restoreScrollInterval);
                this.restoreScrollInterval = null;
            }
        }
        static getDerivedStateFromProps(props, state) {
            if (!react_fast_compare__WEBPACK_IMPORTED_MODULE_3___default()(props.params, state.lastParams)) {
                return {
                    cursors: [null],
                    lastParams: props.params,
                };
            }
            return null;
        }
        getSnapshotBeforeUpdate(prevProps, prevState) {
            if (!react_fast_compare__WEBPACK_IMPORTED_MODULE_3___default()(this.props.params, prevProps.params)) {
                return {
                    resetScroll: true,
                };
            }
            return null;
        }
        componentDidUpdate(props, state, snapshot) {
            if (snapshot && snapshot.resetScroll && this.itemList) {
                console.log(`resetting scrollTop!`);
                this.itemList.scrollTop = 0;
                Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__[/* dispatchTabPageUpdate */ "i"])(this.props, { scrollTop: 0 });
            }
        }
        componentDidMount() {
            const { label } = this.props;
            if (label) {
                Object(renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_10__[/* dispatchTabPageUpdate */ "i"])(this.props, { label });
            }
        }
        render() {
            const { params, sequence } = this.props;
            const { renderMainFilters = renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__[/* renderNoop */ "c"], renderExtraFilters = renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_8__[/* renderNoop */ "c"], fallbackGetKey, getKey, getRecord, RecordComponent, extraProps, } = this.props;
            const { cursors } = this.state;
            return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_Page__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], null,
                react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_6__[/* default */ "b"], { loading: false }, renderMainFilters ? renderMainFilters() : null),
                renderExtraFilters ? renderExtraFilters() : null,
                react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_pages_common_ItemList__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { className: "series--itemlist", onScroll: this.onScroll, ref: this.gotItemList }, cursors.map((cursor, i) => (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(SeriesPage, { key: i, params: params, cursor: cursor, limit: limit, sequence: sequence, isLast: i === cursors.length - 1, gotLoadMore: this.gotLoadMore, loadNextPage: this.loadNextPage, fallbackGetKey: fallbackGetKey, getKey: getKey, getRecord: getRecord, RecordComponent: RecordComponent, extraProps: extraProps }))))));
        }
    }
    return Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_11__[/* withTab */ "b"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_9__[/* hookWithProps */ "b"])(Series)((map) => ({
        sequence: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_0__[/* ambientTab */ "c"])(rs, props).sequence),
        restoredScrollTop: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_0__[/* ambientPage */ "b"])(rs, props).restoredScrollTop),
    }))(Series));
}


/***/ })

}]);
//# sourceMappingURL=5.chunk.js.map