(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[6],{

/***/ "./src/common/constants/get-user-cover-url.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return getUserCoverURL; });
/* harmony import */ var common_util_resources__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/resources.ts");

function getUserCoverURL(user) {
    const { coverUrl, stillCoverUrl } = user;
    return stillCoverUrl || coverUrl || getFrogCoverURL(user.id);
}
const frogs = [
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-cyan.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-red.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-gold.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-blue.svg"),
];
function getFrogCoverURL(userId) {
    return frogs[userId % frogs.length];
}


/***/ }),

/***/ "./src/common/format/filesize.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return fileSize; });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ "./src/common/format/operation.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatOperation; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return taskIcon; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return formatTask; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return formatReason; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return formatOutcome; });
/* harmony import */ var common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/helpers/get-game-status.ts");

function formatOperation(op) {
    if (op.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_0__[/* OperationType */ "b"].Task) {
        return formatTask(op.name, op.stage);
    }
    else if (op.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_0__[/* OperationType */ "b"].Download) {
        return ["grid.item.downloading"];
    }
    else {
        return null;
    }
}
function taskIcon(name) {
    if (name === "launch") {
        return "stop";
    }
    else if (name === "uninstall") {
        return "uninstall";
    }
    else {
        return "install";
    }
}
function formatTask(name, stage) {
    if (name === "launch") {
        switch (stage) {
            case "prepare":
                return ["grid.item.running.prepare"];
            case "clean":
                return ["grid.item.running.clean"];
        }
        return ["grid.item.running"];
    }
    else if (name === "uninstall") {
        return ["grid.item.uninstalling"];
    }
    else {
        return ["grid.item.installing"];
    }
}
function formatReason(reason) {
    switch (reason) {
        case "install":
            return ["download.reason.install"];
        case "update":
            return ["download.reason.update"];
        case "reinstall":
            return ["download.reason.reinstall"];
        default:
            return null;
    }
}
function formatOutcome(reason) {
    switch (reason) {
        case "install":
            return ["download.outcome.installed"];
        case "update":
            return ["download.outcome.updated"];
        case "reinstall":
            return ["download.outcome.reinstalled"];
        default:
            return null;
    }
}


/***/ }),

/***/ "./src/common/helpers/get-game-status.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ Access; });
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ OperationType; });

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// CONCATENATED MODULE: ./src/common/helpers/get-by-ids.ts

const emptyArr = [];
function getByIds(records, ids) {
    if (Object(index_all["q" /* size */])(ids) === 0) {
        return emptyArr;
    }
    if (!records) {
        return emptyArr;
    }
    const result = [];
    for (const id of ids) {
        const record = records[id];
        if (record) {
            result.push(record);
        }
    }
    return result;
}
/* harmony default export */ var get_by_ids = (getByIds);

// EXTERNAL MODULE: ./src/main/reactors/downloads/getters.ts
var getters = __webpack_require__("./src/main/reactors/downloads/getters.ts");

// EXTERNAL MODULE: ./src/common/util/lru-memoize.ts
var lru_memoize = __webpack_require__("./src/common/util/lru-memoize.ts");

// CONCATENATED MODULE: ./src/common/helpers/get-game-status.ts




/**
 * What type of access we have to the game - do we own it,
 * have we created it, have we bought it, etc.
 */
var Access;
(function (Access) {
    /**
     * Game cannot be bought
     */
    Access[Access["Free"] = 0] = "Free";
    /**
     * Game is pay-what-you-want
     */
    Access[Access["Pwyw"] = 1] = "Pwyw";
    /**
     * Game has a demo that can be downloaded for free
     */
    Access[Access["Demo"] = 2] = "Demo";
    /**
     * Game is in press system and so are we
     */
    Access[Access["Press"] = 3] = "Press";
    /**
     * We have a download key for the game
     */
    Access[Access["Key"] = 4] = "Key";
    /**
     * We have edit rights on the game page
     */
    Access[Access["Edit"] = 5] = "Edit";
    /**
     * We have no access to the game whatsoever
     */
    Access[Access["None"] = 6] = "None";
})(Access || (Access = {}));
var OperationType;
(function (OperationType) {
    /** The current operation is a download */
    OperationType[OperationType["Download"] = 0] = "Download";
    /** The current operation is a task */
    OperationType[OperationType["Task"] = 1] = "Task";
})(OperationType || (OperationType = {}));
function getGameStatus(rs, game, caveId) {
    const { commons, tasks, downloads } = rs;
    const { profile } = rs.profile;
    let downloadKeys = get_by_ids(commons.downloadKeys, commons.downloadKeyIdsByGameId[game.id]);
    let cave;
    let numCaves = 0;
    if (!cave) {
        if (caveId) {
            cave = commons.caves[caveId];
        }
        else {
            let caves = get_by_ids(commons.caves, commons.caveIdsByGameId[game.id]);
            numCaves = Object(index_all["q" /* size */])(caves);
            cave = Object(index_all["h" /* first */])(caves);
        }
    }
    const downloadKey = Object(index_all["h" /* first */])(downloadKeys);
    const pressUser = profile.user.pressUser;
    const task = Object(index_all["h" /* first */])(tasks.tasksByGameId[game.id]);
    const pendingDownloads = Object(getters["d" /* getPendingForGame */])(downloads, game.id);
    let download;
    if (caveId) {
        download = Object(index_all["g" /* findWhere */])(pendingDownloads, { caveId });
    }
    else {
        download = Object(index_all["h" /* first */])(pendingDownloads);
    }
    let isActiveDownload = false;
    let areDownloadsPaused = false;
    let downloadProgress;
    if (download) {
        const activeDownload = Object(getters["a" /* getActiveDownload */])(downloads);
        isActiveDownload = download.id === activeDownload.id;
        areDownloadsPaused = downloads.paused;
        downloadProgress = downloads.progresses[download.id];
    }
    let update;
    if (cave) {
        update = rs.gameUpdates.updates[cave.id];
    }
    const profileId = profile.id;
    return realGetGameStatus(game, cave, numCaves, downloadKey, pressUser, task, download, downloadProgress, update, isActiveDownload, areDownloadsPaused, profileId);
}
/* harmony default export */ var get_game_status = __webpack_exports__["c"] = (getGameStatus);
function rawGetGameStatus(game, cave, numCaves, downloadKey, pressUser, task, download, downloadProgress, update, isDownloadActive, areDownloadsPaused, profileId) {
    let access = Access.None;
    if (game.userId == profileId) {
        access = Access.Edit;
    }
    else {
        const hasPrice = game.minPrice > 0;
        if (!hasPrice) {
            if (game.canBeBought) {
                access = Access.Pwyw;
            }
            else {
                access = Access.Free;
            }
        }
        else {
            // game has minimum price
            if (downloadKey) {
                // we have download keys
                access = Access.Key;
            }
            else {
                // we have no download keys
                if (game.inPressSystem && pressUser) {
                    access = Access.Press;
                }
                else {
                    // we have.. nothing
                }
            }
        }
    }
    let operation = null;
    if (task) {
        operation = {
            type: OperationType.Task,
            name: task.name,
            active: true,
            paused: false,
            progress: task.progress,
            eta: task.eta,
            bps: task.bps,
        };
    }
    else if (download) {
        let p = downloadProgress || {
            progress: null,
            eta: null,
            bps: null,
            stage: null,
        };
        operation = {
            type: OperationType.Download,
            id: download.id,
            reason: download.reason,
            active: isDownloadActive,
            paused: areDownloadsPaused,
            progress: p.progress,
            eta: p.eta,
            bps: p.bps,
            stage: p.stage,
        };
    }
    return {
        cave,
        numCaves,
        downloadKey,
        access,
        operation,
        update,
    };
}
const realGetGameStatus = Object(lru_memoize["a" /* memoize */])(300, rawGetGameStatus);


/***/ }),

/***/ "./src/common/util/action-for-game.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ actionForGame; });

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// CONCATENATED MODULE: ./src/common/constants/classification-actions.ts

const classificationActions = {
    [messages["GameClassification"].Game]: "launch",
    [messages["GameClassification"].Tool]: "launch",
    [messages["GameClassification"].Assets]: "open",
    [messages["GameClassification"].GameMod]: "open",
    [messages["GameClassification"].PhysicalGame]: "open",
    [messages["GameClassification"].Soundtrack]: "open",
    [messages["GameClassification"].Other]: "open",
    [messages["GameClassification"].Comic]: "open",
    [messages["GameClassification"].Book]: "open",
};

// CONCATENATED MODULE: ./src/common/util/action-for-game.ts

/**
 * Returns whether a game can be "launched" or "opened", where "launching" means
 * starting an executable, serving a web game, etc., and "opening" means showing files
 * in a file explorer.
 */
function actionForGame(game, cave) {
    // FIXME: we're not using the cave at all here - we probably should.
    return classificationActions[game.classification] || "launch";
}


/***/ }),

/***/ "./src/common/util/resources.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ getImageURL; });
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ getInjectURL; });

// UNUSED EXPORTS: getImagePath, getLocalePath, getLocalesConfigPath, getInjectPath, getRendererFilePath

// EXTERNAL MODULE: external "path"
var external_path_ = __webpack_require__("path");

// EXTERNAL MODULE: external "electron"
var external_electron_ = __webpack_require__("electron");
var external_electron_default = /*#__PURE__*/__webpack_require__.n(external_electron_);

// CONCATENATED MODULE: ./src/common/helpers/app.ts

let app;
if (process.type) {
    app = external_electron_default.a.app || external_electron_default.a.remote.app;
}
function getAppPath() {
    if (!app) {
        return `<app path>`;
    }
    return app.getAppPath();
}
function getVersion() {
    if (!app) {
        return `<test version>`;
    }
    return app.getVersion();
}

// CONCATENATED MODULE: ./src/common/util/resources.ts


let absoluteAppPath = Object(external_path_["join"])(getAppPath(), "src");
let absoluteMainDistPath = Object(external_path_["join"])(getAppPath(), "dist", "main");
let absoluteRendererDistPath = Object(external_path_["join"])(getAppPath(), "dist", "renderer");
/*
 * Resources are files shipped with the app, that are static
 * and don't usually change, unless updated.
 */
function getPath(resourcePath) {
    return absoluteAppPath + "/" + resourcePath;
}
function getImagePath(path) {
    const resourcePath = "static/images/" + path;
    return getPath(resourcePath);
}
function getImageURL(path) {
    return `file://${getImagePath(path)}`;
}
function getLocalePath(path) {
    const resourcePath = "static/locales/" + path;
    return getPath(resourcePath);
}
function getLocalesConfigPath() {
    let resourcePath = "static/locales.json";
    return getPath(resourcePath);
}
function getInjectPath(name) {
    return Object(external_path_["join"])(absoluteMainDistPath, `inject-${name}.bundle.js`);
}
function getInjectURL(name) {
    return `file://${getInjectPath(name)}`;
}
function getRendererFilePath(name) {
    return Object(external_path_["join"])(absoluteRendererDistPath, name);
}


/***/ }),

/***/ "./src/main/reactors/downloads/getters.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return getActiveDownload; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return getPendingDownloads; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return getFinishedDownloads; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return getPendingForGame; });
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");
/* harmony import */ var common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/lru-memoize.ts");


const getActiveDownload = Object(common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__[/* memoize */ "a"])(1, function (downloads) {
    return Object(underscore__WEBPACK_IMPORTED_MODULE_0__[/* first */ "h"])(getPendingDownloads(downloads));
});
const getPendingDownloads = Object(common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__[/* memoize */ "a"])(1, function (downloads) {
    const pending = Object(underscore__WEBPACK_IMPORTED_MODULE_0__[/* filter */ "e"])(downloads.items, (i) => !i.finishedAt);
    return Object(underscore__WEBPACK_IMPORTED_MODULE_0__[/* sortBy */ "r"])(pending, "position");
});
const getFinishedDownloads = Object(common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__[/* memoize */ "a"])(1, function (downloads) {
    const pending = Object(underscore__WEBPACK_IMPORTED_MODULE_0__[/* filter */ "e"])(downloads.items, (i) => !!i.finishedAt);
    return Object(underscore__WEBPACK_IMPORTED_MODULE_0__[/* sortBy */ "r"])(pending, "finishedAt").reverse();
});
function getPendingForGame(downloads, gameId) {
    return Object(underscore__WEBPACK_IMPORTED_MODULE_0__[/* filter */ "e"])(getPendingDownloads(downloads), (i) => i.game && +i.game.id === +gameId);
}


/***/ }),

/***/ "./src/renderer/basics/DownloadProgressSpan.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DownloadProgressSpan; });
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/format/filesize.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/FormattedDuration.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/t.tsx");




function DownloadProgressSpan({ bps, eta, downloadsPaused, onlyBPS, onlyETA, }) {
    if (downloadsPaused) {
        return react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_3__[/* T */ "a"])(["grid.item.downloads_paused"]));
    }
    if (onlyBPS) {
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null,
            Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_0__[/* fileSize */ "a"])(bps),
            "/s"));
    }
    if (onlyETA) {
        return react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { secs: eta });
    }
    const hasBPS = bps > 0;
    const hasETA = eta > 0;
    return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("span", null,
        hasBPS ? (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null,
            Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_0__[/* fileSize */ "a"])(bps),
            "/s")) : null,
        hasBPS && hasETA ? " — " : null,
        hasETA ? react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { secs: eta }) : null));
}


/***/ }),

/***/ "./src/renderer/basics/FormattedDuration.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/format/datetime.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react-intl/lib/src/components/message.js");



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ __webpack_exports__["a"] = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], Object.assign({}, Object(common_format_datetime__WEBPACK_IMPORTED_MODULE_0__[/* formatDurationAsMessage */ "e"])(secs)))));


/***/ }),

/***/ "./src/renderer/basics/LastPlayed.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/action-for-game.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/TimeAgo.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/t.tsx");





class LastPlayed extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
    render() {
        const { game, cave, short = false, className } = this.props;
        const { lastTouchedAt = null } = cave || {};
        const classification = game.classification || "game";
        const classAction = Object(common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__[/* actionForGame */ "a"])(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement("div", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()("last-playthrough", className) }, lastTouchedAt ? (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement("label", null, short ? (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { date: lastTouchedAt })) : (Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])([
            `usage_stats.last_${xed}_time_ago`,
            {
                time_ago: react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { date: lastTouchedAt }),
            },
        ])))) : (Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])([`usage_stats.never_${xed}`]))));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (LastPlayed);


/***/ }),

/***/ "./src/renderer/basics/TitleBar/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// UNUSED EXPORTS: titleBarHeight

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/env.ts
var env = __webpack_require__("./src/common/env.ts");

// EXTERNAL MODULE: ./src/common/helpers/space.ts
var space = __webpack_require__("./src/common/helpers/space.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/NewVersionAvailable.tsx






const Container = styles["h" /* default */].div `
  align-self: stretch;
  font-weight: bold;
  padding: 0 0.5em;
  margin-right: 1em;

  display: flex;
  flex-direction: row;
  align-items: center;
  border-radius: 2px;

  &:hover {
    background: ${(props) => props.theme.baseBackground};
    cursor: pointer;
  }
`;
const Spacer = styles["h" /* default */].div `
  height: 1px;
  width: 0.4em;
`;
class NewVersionAvailable_NewVersionAvailable extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].relaunchRequest({}));
        };
    }
    render() {
        const { available } = this.props;
        if (!available) {
            return null;
        }
        return (react_default.a.createElement(Container, { onClick: this.onClick },
            react_default.a.createElement(Icon["a" /* default */], { icon: "install" }),
            react_default.a.createElement(Spacer, null),
            Object(t["a" /* T */])(["prompt.self_update_ready.short"])));
    }
}
/* harmony default export */ var TitleBar_NewVersionAvailable = (Object(hook["a" /* hook */])((map) => ({
    available: map((rs) => {
        const pkg = rs.broth.packages[rs.system.appName];
        return pkg && pkg.stage === "need-restart";
    }),
}))(NewVersionAvailable_NewVersionAvailable));

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/common/constants/get-user-cover-url.ts
var get_user_cover_url = __webpack_require__("./src/common/constants/get-user-cover-url.ts");

// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/UserMenu.tsx







const UserMenuDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding: 8px;
  margin-right: 8px;

  transition: background 0.2s;
  &:hover {
    background: rgba(0, 0, 0, 0.2);
    cursor: pointer;
  }

  animation: ${styles["b" /* animations */].enterTop} 0.2s;

  .icon {
    margin: 0;
    transition: all 0.2s;
  }

  img {
    height: 24px;
    width: 24px;
    margin-right: 8px;
    border-radius: 2px;
    flex-shrink: 0;
  }

  span {
    flex-shrink: 1;
    ${styles["s" /* singleLine */]};
  }
`;
class UserMenu_UserMenu extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.openMenu = (e) => {
            if (e.button === 0) {
                const { dispatch } = this.props;
                dispatch(actions["a" /* actions */].openUserMenu({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    clientX: e.clientX,
                    clientY: e.clientY,
                }));
            }
        };
    }
    render() {
        if (!this.props.me) {
            return null; // cf. #1405
        }
        return this.me();
    }
    me() {
        const { me } = this.props;
        const { username, displayName } = me;
        const coverUrl = Object(get_user_cover_url["a" /* getUserCoverURL */])(me);
        return (react_default.a.createElement(UserMenuDiv, { className: "user-menu", onMouseDown: this.openMenu },
            react_default.a.createElement("img", { src: coverUrl }),
            react_default.a.createElement("span", null, displayName || username),
            react_default.a.createElement(Filler["a" /* default */], null)));
    }
}
/* harmony default export */ var TitleBar_UserMenu = (Object(hook["a" /* hook */])((map) => ({
    me: map((rs) => rs.profile.profile.user),
}))(UserMenu_UserMenu));

// EXTERNAL MODULE: ./src/common/modals/index.ts + 1 modules
var modals = __webpack_require__("./src/common/modals/index.ts");

// EXTERNAL MODULE: ./src/common/helpers/secret-click.ts
var secret_click = __webpack_require__("./src/common/helpers/secret-click.ts");

// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/index.tsx













const DraggableDiv = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};
  -webkit-app-region: drag;

  flex: 1 1;
  display: flex;
  align-self: stretch;
`;
const TitleBar_Spacer = styles["h" /* default */].div `
  width: 8px;
  flex-shrink: 0;
`;
const titleBarHeight = 40;
const WindowButton = Object(styles["h" /* default */])(IconButton["a" /* default */]) `
  align-self: flex-start;
  flex-shrink: 0;
  width: ${titleBarHeight * 1.1}px;
  height: ${titleBarHeight * 0.8}px;
  opacity: 0.7;

  &:hover {
    opacity: 1;
    background: rgba(255, 255, 255, 0.1);
  }

  &.exit:hover {
    background: rgba(174, 8, 7, 1);
  }
`;
const DraggableDivInner = styles["h" /* default */].div `
  flex: 1 1;
  display: flex;
  align-self: center;
  align-items: center;
  max-width: 100%;
`;
const TitleBar_Filler = styles["h" /* default */].div `
  flex: 1 1;
`;
const TitleBarDiv = styles["h" /* default */].div `
  display: flex;
  align-items: center;
  width: 100%;
  background: ${(props) => props.theme.sidebarBackground};
  padding-left: 10px;
  height: ${titleBarHeight}px;
`;
const TitleDiv = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};

  font-size: ${(props) => props.theme.fontSizes.large};
`;
const emptyObj = {};
class TitleBar_TitleBar extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if (Object(secret_click["a" /* isSecretClick */])(e)) {
                const { dispatch } = this.props;
                dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].secretSettings.make({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    title: "Secret settings",
                    message: "",
                    widgetParams: {},
                })));
                return;
            }
        };
        this.preferencesClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].navigate({ wind: "root", url: "itch://preferences" }));
        };
        this.minimizeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].minimizeWind({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
        this.maximizeRestoreClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].toggleMaximizeWind({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
        this.closeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].hideWind({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
    }
    render() {
        const { tab, macos, tabInstance } = this.props;
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        const sp = space["a" /* Space */].fromInstance(tab, tabInstance);
        let label = sp.lazyLabel();
        const loggedIn = tab !== "login";
        if (!loggedIn) {
            if (macos) {
                label = "";
            }
            else {
                label = env["a" /* default */].appName;
            }
        }
        return (react_default.a.createElement(TitleBarDiv, { className: "title-bar" },
            react_default.a.createElement(DraggableDiv, { id: "title-draggable", onClick: this.onClick },
                react_default.a.createElement(DraggableDivInner, null,
                    secondary ? react_default.a.createElement(TitleBar_Filler, null) : null,
                    react_default.a.createElement(TitleDiv, { className: "title-bar-text" }, Object(t["a" /* T */])(label)),
                    react_default.a.createElement(TitleBar_Filler, null))),
            secondary ? null : (react_default.a.createElement(react_default.a.Fragment, null,
                loggedIn ? react_default.a.createElement(TitleBar_UserMenu, null) : null,
                react_default.a.createElement(TitleBar_NewVersionAvailable, null))),
            react_default.a.createElement(TitleBar_Spacer, null),
            this.renderIcons()));
    }
    renderIcons() {
        const { macos, maximized } = this.props;
        if (macos) {
            return null;
        }
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        return (react_default.a.createElement(react_default.a.Fragment, null,
            secondary ? null : (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(WindowButton, { icon: "minus", onClick: this.minimizeClick }),
                react_default.a.createElement(WindowButton, { icon: maximized ? "window-restore" : "window-maximize", onClick: this.maximizeRestoreClick }))),
            react_default.a.createElement(WindowButton, { className: "exit", icon: "cross", onClick: this.closeClick })));
    }
}
/* harmony default export */ var basics_TitleBar = __webpack_exports__["a"] = (Object(hook["b" /* hookWithProps */])(TitleBar_TitleBar)((map) => ({
    tabInstance: map((rs, props) => Object(navigation["e" /* ambientWindState */])(rs).tabInstances[props.tab] || emptyObj),
    maximized: map((rs, props) => rs.winds[Object(navigation["d" /* ambientWind */])()].native.maximized),
    focused: map((rs, props) => rs.winds[Object(navigation["d" /* ambientWind */])()].native.focused),
    macos: map((rs, props) => rs.system.macos),
}))(TitleBar_TitleBar));


/***/ }),

/***/ "./src/renderer/helpers/doAsync.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return doAsync; });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ "./src/renderer/pages/BrowserPage/BrowserBar.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/basics/IconButton.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/renderer/hocs/withTab.tsx");







class BrowserBar extends react__WEBPACK_IMPORTED_MODULE_2___default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onMore = (ev) => {
            const { dispatch, tab, url } = this.props;
            const { clientX, clientY } = ev;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].popupContextMenu({
                wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
                clientX,
                clientY,
                template: [
                    {
                        localizedLabel: ["browser.popout"],
                        action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].openInExternalBrowser({
                            url,
                        }),
                    },
                    {
                        type: "separator",
                    },
                    {
                        localizedLabel: ["browser.open_devtools"],
                        action: common_actions__WEBPACK_IMPORTED_MODULE_0__[/* actions */ "a"].openDevTools({
                            wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientWind */ "d"])(),
                            tab,
                        }),
                    },
                ],
            }));
        };
    }
    render() {
        const { loading } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_3__[/* default */ "b"], { loading: loading },
            react__WEBPACK_IMPORTED_MODULE_2___default.a.createElement(renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_4__[/* default */ "a"], { icon: "more_vert", onClick: this.onMore })));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Object(renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_6__[/* withTab */ "b"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__[/* hookWithProps */ "b"])(BrowserBar)((map) => ({
    url: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).location.url),
    loading: map((rs, props) => Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_1__[/* ambientTab */ "c"])(rs, props).loading),
}))(BrowserBar)));


/***/ }),

/***/ "./src/renderer/pages/common/Page.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

/* harmony default export */ __webpack_exports__["a"] = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* meat */ "l"]};
`);


/***/ }),

/***/ "./src/renderer/scenes/HubScene/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./src/renderer/basics/FiltersContainer.tsx + 1 modules
var FiltersContainer = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/TitleBar/index.tsx + 2 modules
var TitleBar = __webpack_require__("./src/renderer/basics/TitleBar/index.tsx");

// EXTERNAL MODULE: ./src/common/modals/index.ts + 1 modules
var modals = __webpack_require__("./src/common/modals/index.ts");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// EXTERNAL MODULE: ./node_modules/react-loadable/lib/index.js
var lib = __webpack_require__("./node_modules/react-loadable/lib/index.js");
var lib_default = /*#__PURE__*/__webpack_require__.n(lib);

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__("./src/renderer/basics/Button.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__("./src/renderer/hocs/withTab.tsx");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/BrowserPage/BrowserBar.tsx
var BrowserBar = __webpack_require__("./src/renderer/pages/BrowserPage/BrowserBar.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__("./src/renderer/pages/common/Page.tsx");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Meats/Meat.tsx













const CrashyPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 37).then(__webpack_require__.bind(null, "./src/renderer/pages/CrashyPage.tsx")),
    loading: () => null,
});
const CavePage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 36).then(__webpack_require__.bind(null, "./src/renderer/pages/CavePage.tsx")),
    loading: () => null,
});
const GamePage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 39).then(__webpack_require__.bind(null, "./src/renderer/pages/GamePage.tsx")),
    loading: () => null,
});
const InstallPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 40).then(__webpack_require__.bind(null, "./src/renderer/pages/InstallPage.tsx")),
    loading: () => null,
});
const FeaturedPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 38).then(__webpack_require__.bind(null, "./src/renderer/pages/FeaturedPage.tsx")),
    loading: () => null,
});
const LibraryPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 24).then(__webpack_require__.bind(null, "./src/renderer/pages/LibraryPage/index.tsx")),
    loading: () => null,
});
const OwnedPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(1), __webpack_require__.e(33)]).then(__webpack_require__.bind(null, "./src/renderer/pages/LibraryPage/OwnedPage/index.tsx")),
    loading: () => null,
});
const InstalledPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(1), __webpack_require__.e(32)]).then(__webpack_require__.bind(null, "./src/renderer/pages/LibraryPage/InstalledPage/index.tsx")),
    loading: () => null,
});
const LocationsPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 20).then(__webpack_require__.bind(null, "./src/renderer/pages/LocationsPage/index.tsx")),
    loading: () => null,
});
const LocationPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 5).then(__webpack_require__.bind(null, "./src/renderer/pages/LocationPage/index.tsx")),
    loading: () => null,
});
const BrowserPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 19).then(__webpack_require__.bind(null, "./src/renderer/pages/BrowserPage/index.tsx")),
    loading: () => null,
});
const NewTabPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 41).then(__webpack_require__.bind(null, "./src/renderer/pages/NewTabPage/index.tsx")),
    loading: () => null,
});
const CollectionPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(1), __webpack_require__.e(30)]).then(__webpack_require__.bind(null, "./src/renderer/pages/CollectionPage/index.tsx")),
    loading: () => null,
});
const CollectionsPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 14).then(__webpack_require__.bind(null, "./src/renderer/pages/CollectionsPage/index.tsx")),
    loading: () => null,
});
const AppLogPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 18).then(__webpack_require__.bind(null, "./src/renderer/pages/AppLogPage/index.tsx")),
    loading: () => null,
});
const DashboardPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(1), __webpack_require__.e(31)]).then(__webpack_require__.bind(null, "./src/renderer/pages/DashboardPage/index.tsx")),
    loading: () => null,
});
const DownloadsPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(8), __webpack_require__.e(15)]).then(__webpack_require__.bind(null, "./src/renderer/pages/DownloadsPage/index.tsx")),
    loading: () => null,
});
const PreferencesPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 25).then(__webpack_require__.bind(null, "./src/renderer/pages/PreferencesPage/index.tsx")),
    loading: () => null,
});
const ScanInstallLocationsPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 13).then(__webpack_require__.bind(null, "./src/renderer/pages/ScanInstallLocationsPage/index.tsx")),
    loading: () => null,
});
const ErrorDiv = styles["h" /* default */].div `
  display: block;
  overflow: hidden;
  margin: 20px;
  width: 100%;
`;
const ErrorContents = styles["h" /* default */].div `
  overflow-y: scroll;
  max-height: fill-available;
  padding: 20px 0;

  pre {
    font-family: monospace;
    font-size: 12px;
    line-height: 1.4;
  }
`;
const ErrorHeader = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const ErrorButtons = styles["h" /* default */].div `
  margin: 20px 0;
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const ErrorSpacer = styles["h" /* default */].div `
  height: 1px;
  width: 8px;
`;
class Meat_Meat extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.renderError = () => {
            const { error, info } = this.state;
            return (react_default.a.createElement(ErrorDiv, null,
                react_default.a.createElement(ErrorHeader, null,
                    react_default.a.createElement("h3", null, "itch has encountered a rendering error")),
                react_default.a.createElement(ErrorButtons, null,
                    react_default.a.createElement(Button["a" /* default */], { icon: "repeat", onClick: this.reloadMeat }, this.state.loading ? react_default.a.createElement(LoadingCircle["a" /* default */], { progress: -1 }) : "Reload"),
                    react_default.a.createElement(ErrorSpacer, null),
                    react_default.a.createElement(Button["a" /* default */], { icon: "bug", onClick: this.onReportIssue }, Object(t["a" /* T */])(["menu.help.report_issue"]))),
                react_default.a.createElement("details", null,
                    react_default.a.createElement("summary", null, "View details for nerds"),
                    react_default.a.createElement(ErrorContents, null,
                        react_default.a.createElement("p", null,
                            react_default.a.createElement("pre", null, error
                                ? error.stack
                                    ? error.stack
                                    : String(error)
                                : "(no error)")),
                        react_default.a.createElement("p", null,
                            react_default.a.createElement("pre", null, info ? info.componentStack : "(no component stack)"))))));
        };
        this.reloadMeat = () => {
            this.setState({ loading: true });
            setTimeout(() => {
                this.setState({ hasError: false, loading: false });
            }, 400);
        };
        this.onReportIssue = () => {
            const { dispatch } = this.props;
            const e = this.state.error;
            dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].sendFeedback.make({
                wind: "root",
                title: Object(t["c" /* _ */])("prompt.show_error.generic_message"),
                widgetParams: {
                    log: `While rendering ${this.props.url}, caught:\n${e.stack}`,
                },
            })));
        };
        this.state = {
            hasError: false,
            loading: false,
            lastURL: null,
        };
    }
    static getDerivedStateFromProps(props, state) {
        if (props.url !== state.lastURL) {
            return {
                hasError: false,
                loading: false,
                error: null,
                info: null,
                lastURL: props.url,
            };
        }
        return null;
    }
    componentDidCatch(error, info) {
        this.setState({
            hasError: true,
            loading: false,
            error,
            info,
        });
    }
    render() {
        if (this.state.hasError) {
            return this.renderError();
        }
        const ConcreteMeat = this.getConcrete();
        if (ConcreteMeat) {
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(ConcreteMeat, Object.assign({}, this.props))));
        }
        else {
            return (react_default.a.createElement(Page["a" /* default */], null,
                react_default.a.createElement(BrowserBar["a" /* default */], null),
                react_default.a.createElement("div", null,
                    "Invalid url: ",
                    JSON.stringify(this.props.url))));
        }
    }
    getConcrete() {
        const { isBrowser, internalPage, firstPathElement } = this.props;
        if (isBrowser) {
            return BrowserPage;
        }
        switch (internalPage) {
            case "library":
                switch (firstPathElement) {
                    case "owned":
                        return OwnedPage;
                    case "installed":
                        return InstalledPage;
                    default:
                        return LibraryPage;
                }
            case "games":
                return GamePage;
            case "caves":
                return CavePage;
            case "install":
                return InstallPage;
            case "featured":
                return FeaturedPage;
            case "collections":
                if (firstPathElement) {
                    return CollectionPage;
                }
                else {
                    return CollectionsPage;
                }
            case "locations":
                if (firstPathElement) {
                    return LocationPage;
                }
                else {
                    return LocationsPage;
                }
            case "dashboard":
                return DashboardPage;
            case "downloads":
                return DownloadsPage;
            case "preferences":
                return PreferencesPage;
            case "applog":
                return AppLogPage;
            case "crashy":
                return CrashyPage;
            case "new-tab":
                return NewTabPage;
            case "scan-install-locations":
                return ScanInstallLocationsPage;
            default:
                return null;
        }
    }
}
/* harmony default export */ var Meats_Meat = (Object(withTab["b" /* withTab */])(Object(hook["b" /* hookWithProps */])(Meat_Meat)((map) => ({
    url: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.url),
    isBrowser: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.isBrowser),
    internalPage: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.internalPage),
    firstPathElement: map((rs, props) => Object(navigation["c" /* ambientTab */])(rs, props).location.firstPathElement),
}))(Meat_Meat)));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Meats/index.tsx












const MeatContainer = styles["h" /* default */].div `
  background: ${(props) => props.theme.meatBackground};
  overflow: hidden;
  display: flex;
  flex-direction: column;
  align-items: stretch;
  position: relative;

  flex-shrink: 1;
  flex-grow: 1;
`;
const MeatTab = styles["h" /* default */].div `
  position: absolute;
  top: ${FiltersContainer["c" /* filtersContainerHeight */]}px;
  right: 0;
  left: 0;
  bottom: 0;
  display: none;
  overflow: hidden;

  &.visible {
    display: flex;
  }
`;
class Meats_Meats extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (ev) => {
            if (ev.shiftKey && ev.ctrlKey) {
                const { tab, tabInstances, dispatch } = this.props;
                const tabInstance = tabInstances[tab];
                dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].exploreJson.make({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    title: "Tab information",
                    message: "",
                    widgetParams: {
                        data: { tab, tabInstance },
                    },
                    fullscreen: true,
                })));
            }
        };
    }
    render() {
        let { profile, openTabs, tabInstances, tab: currentId } = this.props;
        if (!profile) {
            return null;
        }
        return (react_default.a.createElement(MeatContainer, { onClick: this.onClick },
            react_default.a.createElement(TitleBar["a" /* default */], { tab: currentId }),
            Object(index_all["l" /* map */])(openTabs, (tab) => {
                const ti = tabInstances[tab];
                const visible = tab === currentId;
                return (react_default.a.createElement(withTab["a" /* TabProvider */], { key: tab, value: tab },
                    react_default.a.createElement(MeatTab, { key: tab, "data-id": tab, "data-url": ti.location.url, "data-resource": ti.resource ? ti.resource.value : null, className: classnames_default()("meat-tab", { visible }) },
                        react_default.a.createElement(Meats_Meat, { visible: visible, sequence: ti.sequence }))));
            })));
    }
}
/* harmony default export */ var HubScene_Meats = (Object(hook["a" /* hook */])((map) => ({
    profile: map((rs) => rs.profile.profile),
    tab: map((rs) => Object(navigation["a" /* ambientNavigation */])(rs).tab),
    openTabs: map((rs) => Object(navigation["a" /* ambientNavigation */])(rs).openTabs),
    tabInstances: map((rs) => Object(navigation["e" /* ambientWindState */])(rs).tabInstances),
}))(Meats_Meats));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/HubContent.tsx




const ContentContainer = styles["h" /* default */].div `
  overflow: hidden;
  display: flex;
  flex-direction: column;
  flex-grow: 1;
`;
class HubContent_HubContent extends react_default.a.PureComponent {
    render() {
        const { profile } = this.props;
        if (!profile) {
            return null;
        }
        return (react_default.a.createElement(ContentContainer, null,
            react_default.a.createElement(HubScene_Meats, null)));
    }
}
/* harmony default export */ var HubScene_HubContent = (Object(hook["a" /* hook */])((map) => ({
    profile: map((rs) => rs.profile.profile),
}))(HubContent_HubContent));

// EXTERNAL MODULE: ./node_modules/react-sortable-hoc/dist/react-sortable-hoc.esm.js + 19 modules
var react_sortable_hoc_esm = __webpack_require__("./node_modules/react-sortable-hoc/dist/react-sortable-hoc.esm.js");

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/common/helpers/secret-click.ts
var secret_click = __webpack_require__("./src/common/helpers/secret-click.ts");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Logo.tsx








const LogoDiv = styles["h" /* default */].div `
  text-align: center;
  cursor: pointer;

  margin-top: 10px;
  height: 59px;

  img {
    width: 110px;
    margin: 10px 0;
  }
`;
class Logo_Logo extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if (Object(secret_click["a" /* isSecretClick */])(e)) {
                const { dispatch } = this.props;
                dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].secretSettings.make({
                    wind: "root",
                    title: "Secret settings",
                    message: "",
                    widgetParams: {},
                })));
                return;
            }
            if (e.button === 0) {
                const { dispatch } = this.props;
                dispatch(actions["a" /* actions */].openUserMenu({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    clientX: e.clientX,
                    clientY: e.clientY,
                }));
            }
        };
    }
    render() {
        const { appVersion } = this.props;
        return (react_default.a.createElement(LogoDiv, { title: appVersion, className: classnames_default()("logo-div"), onClick: this.onClick },
            react_default.a.createElement("img", { src: __webpack_require__("./src/static/images/logos/app-white.svg").default })));
    }
}
/* harmony default export */ var Sidebar_Logo = (Object(hook["a" /* hook */])((map) => ({
    appVersion: map((rs) => rs.system.appVersion),
}))(Logo_Logo));

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__("./node_modules/tslib/tslib.es6.js");

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// CONCATENATED MODULE: ./src/common/constants/search-examples.ts
/* harmony default export */ var search_examples = ([
    "capsule",
    "race",
    "princess",
    "royals",
    "night",
    "garden",
    "tiger",
    "robot",
    "kenney",
    "quest",
    "simulator",
    "date",
    "lost",
    "tycoon",
    "grow",
    "fly",
    "basket",
    "legend",
    "drift",
    "galaxy",
    "rogue",
    "moon",
    "strategy",
    "shoot",
    "platform",
    "ghost",
    "tea",
    "parable",
    "sun",
    "market",
    "creator",
    "ville",
    "heart",
    "poem",
    "twine",
    "flower",
    "escape",
    "castle",
    "wild",
    "trouble",
    "purpose",
    "ludum dare",
    "challenge",
    "coop",
    "club",
    "dream",
    "midnight",
    "remix",
    "witch",
    "social",
    "hylics",
    "doggest",
    "crypt",
    "tower",
    "forest",
]);

// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__("./src/renderer/basics/Floater.tsx");

// EXTERNAL MODULE: ./src/renderer/butlerd/rcall.ts
var rcall = __webpack_require__("./src/renderer/butlerd/rcall.ts");

// EXTERNAL MODULE: ./src/renderer/helpers/doAsync.tsx
var doAsync = __webpack_require__("./src/renderer/helpers/doAsync.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__("./src/renderer/hocs/watching.tsx");

// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__("./src/common/constants/urls.ts");

// EXTERNAL MODULE: ./src/renderer/basics/Cover/index.tsx + 2 modules
var Cover = __webpack_require__("./src/renderer/basics/Cover/index.tsx");

// EXTERNAL MODULE: ./src/renderer/helpers/whenClickNavigates.ts
var whenClickNavigates = __webpack_require__("./src/renderer/helpers/whenClickNavigates.ts");

// EXTERNAL MODULE: ./node_modules/react-dom/index.js
var react_dom = __webpack_require__("./node_modules/react-dom/index.js");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/SearchResultsBar/GameSearchResult.tsx













const GameSearchResultDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: stretch;
  padding: 4px 8px;
  padding-left: 12px;

  flex-shrink: 0;

  border-left: 1px solid transparent;

  &.chosen {
    background-color: ${(props) => props.theme.sidebarEntryFocusedBackground};
    border-color: ${(props) => props.theme.accent};
    cursor: pointer;
  }

  &:hover {
    border-color: rgba(255, 255, 255, 0.5);
    cursor: pointer;
  }

  .cover-container {
    flex-shrink: 0;
    width: ${80 * 1}px;

    display: flex;
    flex-direction: row;
    align-items: flex-start;

    .cover {
      width: 100%;
    }
  }
`;
const SectionDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: column;
  align-items: stretch;

  overflow-x: hidden;
  ${styles["s" /* singleLine */]};
  line-height: 1.4;
`;
const TitleDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const Title = styles["h" /* default */].span `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  ${styles["s" /* singleLine */]};

  &.chosen {
    font-size: ${(props) => props.theme.fontSizes.larger};
  }
`;
const ShortText = styles["h" /* default */].span `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  color: ${(props) => props.theme.secondaryText};
  margin-right: 8px;
  overflow-x: hidden;
  text-overflow: ellipsis;
  word-wrap: break-all;
  white-space: normal;
`;
let GameSearchResult_GameSearchResult = class GameSearchResult extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (ev) => {
            Object(whenClickNavigates["b" /* whenClickNavigates */])(ev, ({ background }) => {
                if (background) {
                    ev.preventDefault();
                }
                const { game, dispatch } = this.props;
                dispatch(actions["a" /* actions */].navigate({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    url: Object(navigation["i" /* urlForGame */])(game.id),
                    background,
                }));
                dispatch(actions["a" /* actions */].closeSearch({}));
            });
        };
        this.onEnter = (ev) => {
            this.props.setSearchHighlight(this.props.index);
        };
    }
    subscribe(watcher) {
        watcher.on(actions["a" /* actions */].commandOk, async (store, action) => {
            if (this.props.chosen && this.props.active && !this.props.loading) {
                store.dispatch(this.getNavigateAction());
                store.dispatch(actions["a" /* actions */].closeSearch({}));
            }
        });
    }
    componentDidUpdate() {
        if (this.props.chosen) {
            const node = Object(react_dom["findDOMNode"])(this);
            if (node) {
                node.scrollIntoViewIfNeeded();
            }
        }
    }
    render() {
        const { game, chosen } = this.props;
        const { title, stillCoverUrl, coverUrl } = game;
        const resultClasses = classnames_default()("game-search-result", {
            chosen: chosen,
        });
        return (react_default.a.createElement(GameSearchResultDiv, { className: resultClasses, onMouseDown: this.onClick, onMouseEnter: this.onEnter, "data-game-id": game.id },
            react_default.a.createElement(SectionDiv, null,
                react_default.a.createElement(TitleDiv, null,
                    react_default.a.createElement(Title, { className: classnames_default()({ chosen }) }, title),
                    react_default.a.createElement(Filler["a" /* default */], null)),
                chosen ? (react_default.a.createElement(TitleDiv, null,
                    react_default.a.createElement(ShortText, null, game.shortText && game.shortText !== ""
                        ? game.shortText
                        : Object(t["a" /* T */])(["search.results.game.no_description"])),
                    game.user ? (react_default.a.createElement(ShortText, null,
                        "By ",
                        game.user.displayName || game.user.username)) : null)) : null),
            chosen ? (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(Filler["a" /* default */], null),
                react_default.a.createElement("div", { className: "cover-container" },
                    react_default.a.createElement(Cover["b" /* default */], { hover: false, showGifMarker: false, className: "cover", gameId: game.id, coverUrl: coverUrl, stillCoverUrl: stillCoverUrl })))) : null));
    }
    getNavigateAction() {
        const { game } = this.props;
        return actions["a" /* actions */].navigate({
            wind: Object(navigation["d" /* ambientWind */])(),
            url: Object(navigation["i" /* urlForGame */])(game.id),
        });
    }
};
GameSearchResult_GameSearchResult = Object(tslib_es6["b" /* __decorate */])([
    watching["a" /* default */]
], GameSearchResult_GameSearchResult);
/* harmony default export */ var SearchResultsBar_GameSearchResult = (Object(hook["a" /* hook */])()(GameSearchResult_GameSearchResult));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/SearchResultsBar/index.tsx












const ResultsContainer = styles["h" /* default */].div `
  background: ${(props) => props.theme.sidebarBackground};
  z-index: 40;

  position: absolute;
  box-shadow: 0 0 30px ${(props) => props.theme.sidebarBackground};
  border-radius: 0 0 0 2px;

  display: flex;
  flex-direction: column;

  width: 500px;
  max-height: 400px;

  left: -10px;
  top: 0;
  border: 1px solid rgba(255, 255, 255, 0.1);
`;
const ResultList = styles["h" /* default */].div `
  display: flex;
  flex-direction: column;
  overflow-x: hidden;
  overflow-y: auto;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;

  flex-grow: 1;

  font-size: ${(props) => props.theme.fontSizes.baseText};
`;
const NoResults = styles["h" /* default */].p `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  padding: 8px 12px;
`;
let SearchResultsBar_SearchResultsBar = class SearchResultsBar extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onResultList = (el) => {
            this.resultList = el;
        };
        this.onOpenAsTab = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].closeSearch({}));
            dispatch(actions["a" /* actions */].navigate({
                wind: Object(navigation["d" /* ambientWind */])(),
                url: `${urls["a" /* default */].itchio}?${encodeURIComponent(this.props.query)}`,
            }));
        };
    }
    render() {
        const { open, games } = this.props;
        if (!open) {
            return null;
        }
        return (react_default.a.createElement(ResultsContainer, { className: classnames_default()("results-container", { open }) }, this.resultsGrid(games)));
    }
    subscribe(watcher) {
        watcher.on(actions["a" /* actions */].searchFetched, async (store, action) => {
            if (this.resultList) {
                this.resultList.scrollTop = 0;
            }
        });
    }
    resultsGrid(games) {
        const { highlight, query, example, loading } = this.props;
        const active = this.props.open;
        const items = [];
        if (Object(index_all["k" /* isEmpty */])(games)) {
            items.push(react_default.a.createElement(NoResults, { key: "no-results" }, loading
                ? Object(t["a" /* T */])(["sidebar.loading"])
                : query
                    ? Object(t["a" /* T */])(["search.empty.no_results"])
                    : Object(t["a" /* T */])(["search.empty.tagline", { example }])));
        }
        else {
            let index = 0;
            Object(index_all["d" /* each */])(games, (game) => {
                items.push(react_default.a.createElement(SearchResultsBar_GameSearchResult, { key: `game-${game.id}`, game: game, index: index, chosen: index === highlight, active: active, loading: loading, setSearchHighlight: this.props.setSearchHighlight }));
                index++;
            });
        }
        return react_default.a.createElement(ResultList, null, items);
    }
};
SearchResultsBar_SearchResultsBar = Object(tslib_es6["b" /* __decorate */])([
    watching["a" /* default */]
], SearchResultsBar_SearchResultsBar);
/* harmony default export */ var Sidebar_SearchResultsBar = (Object(hook["a" /* hook */])()(SearchResultsBar_SearchResultsBar));

// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__("./node_modules/react-intl/lib/src/components/injectIntl.js");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Search.tsx

















const SearchContainerContainer = styles["h" /* default */].section `
  .relative-wrapper {
    position: relative;
    height: 0;
  }
`;
const SearchContainer = styles["h" /* default */].div `
  position: relative;
  padding: 0px 8px;
  margin: 16px 10px;
  font-size: 14px;
  border: 1px solid rgba(255, 255, 255, 0.1);
  background: rgba(0, 0, 0, 0.3);

  transition: border-color 0.4s;
  &.open {
    border-color: rgba(255, 255, 255, 0.4);
  }

  input[type="search"] {
    ${styles["q" /* searchInput */]} // mixin!
    width: 100%;
    margin-left: 4px;
    height: 32px;
    font-size: inherit;

    &:focus {
      outline: none;
    }
  }

  .search-icon {
    ${styles["p" /* searchIcon */]};
    font-size: inherit;
  }

  .search-icon-loading {
    display: flex;
    align-items: center;
    justify-content: center;
    height: 100%;
    transition: opacity 0.2s;
    left: 8px;

    &.enter-pending {
      opacity: 0.5;
    }
  }
`;
let Search_Search = class Search extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.trigger = Object(index_all["a" /* debounce */])(() => {
            if (!this.input) {
                return;
            }
            const { profileId } = this.props;
            const query = this.input.value;
            if (query === this.state.query) {
                this.setState({ loading: false });
                return;
            }
            this.setState({ query });
            if (query == "") {
                this.setState({
                    games: [],
                    example: pickExample(),
                    loading: false,
                });
                return;
            }
            Object(doAsync["a" /* doAsync */])(async () => {
                this.setState({ loading: true });
                try {
                    const { games } = await Object(rcall["a" /* rcall */])(butlerd["h" /* messages */].SearchGames, {
                        profileId,
                        query,
                    });
                    this.setState({ games });
                }
                catch (_a) {
                    this.setState({ games: [] });
                }
                finally {
                    this.setState({ loading: false, highlight: 0 });
                    if (query == this.state.query && this.state.enterPending) {
                        this.setState({ enterPending: false });
                        this.setOpened(false);
                        if (this.input) {
                            this.input.blur();
                        }
                        if (!Object(index_all["k" /* isEmpty */])(this.state.games)) {
                            const gameId = this.state.games[0].id;
                            this.props.dispatch(actions["a" /* actions */].navigate({
                                wind: "root",
                                url: Object(navigation["i" /* urlForGame */])(gameId),
                            }));
                        }
                    }
                }
            });
        }, 100);
        this.onFocus = (e) => {
            this.setOpened(true);
        };
        this.onBlur = (e) => {
            this.setOpened(false);
        };
        this.onChange = (e) => {
            this.setState({ loading: true });
            this.trigger();
        };
        this.setSearchHighlight = (index) => {
            let msSinceLastHighlightSet = Date.now() - this.state.lastHighlightOffset;
            if (msSinceLastHighlightSet < 500) {
                // ignore
                return;
            }
            this.setState({ highlight: index });
        };
        this.onKeyDown = (e) => {
            const { key } = e;
            let passthrough = false;
            if (key === "Escape") {
                // default behavior is to clear - don't
            }
            else if (key === "ArrowDown") {
                this.searchHighlightOffset(1);
                // default behavior is to jump to end of input - don't
            }
            else if (key === "ArrowUp") {
                this.searchHighlightOffset(-1);
                // default behavior is to jump to start of input - don't
            }
            else {
                passthrough = true;
            }
            if (!passthrough) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }
            return true;
        };
        this.onKeyUp = (e) => {
            const { key } = e;
            if (key === "Escape") {
                return;
            }
            else if (key === "ArrowDown") {
                return;
            }
            else if (key === "ArrowUp") {
                return;
            }
            else if (key === "Enter") {
                if (this.state.loading) {
                    this.setState({ enterPending: true });
                }
                return;
            }
            this.trigger();
        };
        this.gotInput = (input) => {
            this.input = input;
        };
        this.state = {
            open: false,
            loading: false,
            highlight: 0,
            games: [],
            example: pickExample(),
            query: "",
            lastHighlightOffset: 0,
            enterPending: false,
        };
    }
    searchHighlightOffset(offset) {
        let highlight = this.state.highlight + offset;
        const numGames = Object(index_all["q" /* size */])(this.state.games);
        if (numGames == 0) {
            highlight = 0;
        }
        else {
            if (highlight >= Object(index_all["q" /* size */])(this.state.games)) {
                highlight = Object(index_all["q" /* size */])(this.state.games) - 1;
            }
            if (highlight < 0) {
                highlight = 0;
            }
        }
        this.setState({ highlight, lastHighlightOffset: Date.now() });
    }
    subscribe(watcher) {
        watcher.on(actions["a" /* actions */].focusSearch, async (store, action) => {
            if (this.input) {
                this.input.focus();
                this.input.select();
            }
            this.setOpened(true);
        });
        watcher.on(actions["a" /* actions */].commandBack, async (store, action) => {
            if (this.input) {
                this.input.blur();
            }
            this.setOpened(false);
        });
        watcher.on(actions["a" /* actions */].closeSearch, async (store, action) => {
            if (this.input) {
                this.input.blur();
            }
            this.setOpened(false);
        });
    }
    render() {
        const { intl } = this.props;
        const { loading, open } = this.state;
        return (react_default.a.createElement(SearchContainerContainer, null,
            react_default.a.createElement(SearchContainer, { className: classnames_default()({ open }) },
                react_default.a.createElement("input", { id: "search", ref: this.gotInput, type: "search", placeholder: Object(t["b" /* TString */])(intl, ["search.placeholder"]) + "...", onKeyDown: this.onKeyDown, onKeyUp: this.onKeyUp, onChange: this.onChange, onBlur: this.onBlur, onFocus: this.onFocus }),
                loading ? (react_default.a.createElement("div", { className: classnames_default()("search-icon search-icon-loading", {
                        "enter-pending": this.state.enterPending,
                    }) },
                    react_default.a.createElement(Floater["a" /* default */], { tiny: true }))) : (react_default.a.createElement("span", { className: "icon icon-search search-icon" })),
                react_default.a.createElement("div", { className: "relative-wrapper" },
                    react_default.a.createElement(Sidebar_SearchResultsBar, { example: this.state.example, games: this.state.games, loading: this.state.loading, open: this.state.open, query: this.state.query, highlight: this.state.highlight, setSearchHighlight: this.setSearchHighlight })))));
    }
    setOpened(open) {
        this.setState({ open });
        const { dispatch } = this.props;
        dispatch(actions["a" /* actions */].searchVisibilityChanged({ open }));
    }
};
Search_Search = Object(tslib_es6["b" /* __decorate */])([
    watching["a" /* default */]
], Search_Search);
function pickExample() {
    return Object(index_all["p" /* sample */])(search_examples);
}
/* harmony default export */ var Sidebar_Search = (Object(hook["a" /* hook */])((map) => ({
    profileId: map((rs) => rs.profile.profile.id),
}))(Object(injectIntl["c" /* default */])(Search_Search)));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/styles.ts

const SidebarSection = styles["h" /* default */].div `
  color: ${(props) => props.theme.ternaryText};

  padding-left: 14px;
  margin: 12px 0;

  display: flex;
  flex-shrink: 0;
  align-items: center;

  a {
    text-decoration: none;
    font-size: 16px;
    color: ${(props) => props.theme.secondaryText};
    &:hover {
      color: ${(props) => props.theme.secondaryTextHover};
    }

    &.active {
      color: ${(props) => props.theme.baseText};
      font-weight: 400;
    }

    display: flex;
    align-items: center;

    .icon {
      padding-right: 0.6em;
      font-size: 140%;
    }
  }
`;
const SidebarHeading = styles["h" /* default */].span `
  text-transform: uppercase;
  font-weight: bold;
`;

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__("./src/common/format/datetime.ts");

// EXTERNAL MODULE: ./src/main/reactors/downloads/getters.ts
var getters = __webpack_require__("./src/main/reactors/downloads/getters.ts");

// EXTERNAL MODULE: ./node_modules/polished/dist/polished.esm.js + 10 modules
var polished_esm = __webpack_require__("./node_modules/polished/dist/polished.esm.js");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Item.tsx










const UnshrinkableIconButton = Object(styles["h" /* default */])(IconButton["a" /* default */]) `
  flex-shrink: 0;
`;
const ItemHeading = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};
  padding: 0.2em 0;
`;
const ItemSection = styles["h" /* default */].section `
  background: ${(props) => props.theme.sidebarBackground};
  font-size: 14px;
  border-radius: 0 4px 4px 0;
  word-break: break-word;

  flex-shrink: 0;
  display: flex;
  flex-direction: column;
  margin: 2px 0;
  margin-right: 0;
  padding-left: 8px;
  height: 32px;
  justify-content: center;

  position: relative;

  &.active {
    .icon-cross {
      opacity: 1;
      color: ${(props) => props.theme.secondaryText}

      &:hover {
        color: ${(props) => props.theme.secondaryTextHover}
      }
    }
    
    background: ${(props) => props.theme.sidebarEntryFocusedBackground}
  }

  &:hover {
    cursor: pointer;
    background: ${(props) => Object(polished_esm["a" /* darken */])(0.02, props.theme.sidebarEntryFocusedBackground)};
    color: ${(props) => props.theme.baseText};

    .icon-cross {
      opacity: 1;
    }
  }
`;
const Row = styles["h" /* default */].div `
  display: flex;
  flex-shrink: 0;
  flex-direction: row;
  align-items: center;
`;
const IconContainer = styles["h" /* default */].div `
  width: 18px;
  height: 16px;
  margin-right: 4px;
  text-align: center;
  flex-shrink: 0;

  img {
    width: 14px;
    height: 14px;
    margin-right: 2px;
    border-radius: 2px;
  }
`;
const ProgressOuter = styles["h" /* default */].div `
  ${styles["o" /* progress */]};
  width: 60px;
  height: 4px;
  margin: 4px 0 2px 10px;

  &,
  .progress-inner {
    border-radius: 4px;
  }

  .progress-inner {
    background-color: white;
  }
`;
const Bubble = styles["h" /* default */].span `
  font-size: 11px;
  background: white;
  border-radius: 2px;
  color: ${(props) => props.theme.sidebarBackground};
  font-weight: bold;
  padding: 1px 6px;
  margin-left: 8px;
  white-space: nowrap;
`;
class Item_Item extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if (Object(secret_click["a" /* isSecretClick */])(e)) {
                const { onExplore, tab } = this.props;
                if (onExplore) {
                    onExplore(tab);
                    return;
                }
            }
            // left (normal) click
            const { onClick } = this.props;
            if (onClick) {
                onClick();
            }
        };
        this.onMouseUp = (e) => {
            if (e.button === 1) {
                // middle click
                const { onClose } = this.props;
                if (onClose) {
                    onClose();
                }
            }
        };
        this.onCloseClick = (e) => {
            e.stopPropagation();
            const { onClose } = this.props;
            if (onClose) {
                onClose();
            }
        };
    }
    render() {
        const { count, sublabel, progress, tab, label, active, url, resource, } = this.props;
        const { onClose } = this.props;
        const progressColor = "white";
        const progressStyle = {
            width: `${Math.max(0, Math.min(1, progress)) * 100}%`,
            backgroundColor: progressColor,
        };
        return (react_default.a.createElement(ItemSection, { className: classnames_default()({ active }), "data-rh-at": "right", "data-rh": sublabel ? JSON.stringify(sublabel) : null, onClick: this.onClick, onMouseUp: this.onMouseUp, "data-id": tab, "data-url": url, "data-resource": resource },
            react_default.a.createElement(Row, null,
                react_default.a.createElement(IconContainer, null, this.props.loading ? (react_default.a.createElement(LoadingCircle["a" /* default */], { progress: -1 })) : this.props.iconImage ? (react_default.a.createElement("img", { className: "icon-image", src: this.props.iconImage })) : (react_default.a.createElement(Icon["a" /* default */], { icon: this.props.icon || "tag" }))),
                react_default.a.createElement(ItemHeading, null, Object(t["a" /* T */])(label)),
                count > 0 ? react_default.a.createElement(Bubble, null, count) : null,
                react_default.a.createElement(Filler["a" /* default */], null),
                progress !== null ? (react_default.a.createElement(ProgressOuter, null,
                    react_default.a.createElement("div", { className: "progress-inner", style: progressStyle }))) : null,
                onClose ? (react_default.a.createElement(UnshrinkableIconButton, { icon: "cross", onClick: this.onCloseClick })) : null)));
    }
}
/* harmony default export */ var Sidebar_Item = (Item_Item);

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Tab.tsx











const SortableItem = Object(react_sortable_hoc_esm["b" /* SortableElement */])((props) => {
    return react_default.a.createElement(Sidebar_Item, Object.assign({}, props.props));
});
class Tab_Tab extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { tab, dispatch } = this.props;
            dispatch(actions["a" /* actions */].tabFocused({ wind: Object(navigation["d" /* ambientWind */])(), tab }));
        };
        this.onClose = () => {
            const { tab, dispatch } = this.props;
            dispatch(actions["a" /* actions */].closeTab({ wind: Object(navigation["d" /* ambientWind */])(), tab }));
        };
        this.onExplore = (tab) => {
            const { dispatch, tabInstance } = this.props;
            dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].exploreJson.make({
                wind: Object(navigation["d" /* ambientWind */])(),
                title: "Tab information",
                message: "",
                widgetParams: {
                    data: { tab, tabInstance },
                },
                fullscreen: true,
            })));
        };
    }
    render() {
        const { tab, index, sortable, tabInstance, active } = this.props;
        const { onExplore } = this;
        const { location, status } = tabInstance;
        let loading = tabInstance.loading;
        const url = location.url;
        const resource = tabInstance.resource ? tabInstance.resource.value : null;
        const label = status.lazyLabel;
        let icon = status.icon;
        let count = 0;
        let progress = null;
        let sublabel = null;
        if (tab === "itch://downloads") {
            const { downloads } = this.props;
            count = Object(index_all["q" /* size */])(Object(getters["c" /* getPendingDownloads */])(downloads));
            const activeDownload = Object(getters["a" /* getActiveDownload */])(downloads);
            if (activeDownload) {
                const downloadProgress = downloads.progresses[activeDownload.id];
                if (downloads.paused) {
                    icon = "stopwatch";
                    sublabel = ["grid.item.downloads_paused"];
                }
                else if (downloadProgress && downloadProgress.eta) {
                    progress = downloadProgress.progress;
                    const title = activeDownload.game.title;
                    const { intl } = this.props;
                    const formatted = Object(datetime["e" /* formatDurationAsMessage */])(downloadProgress.eta);
                    const humanDuration = intl.formatMessage({
                        id: formatted.id,
                    }, formatted.values);
                    sublabel = `${title} — ${humanDuration}`;
                }
            }
        }
        let gameOverride = null;
        let { onClick, onClose } = this;
        if (!sortable) {
            onClose = null;
        }
        const props = {
            tab,
            url,
            resource,
            tabInstance,
            label,
            icon,
            active,
            onClick,
            count,
            progress,
            onClose,
            onExplore,
            sublabel,
            gameOverride,
            loading,
        };
        if (sortable) {
            return react_default.a.createElement(SortableItem, { key: tab, index: index, props: props });
        }
        else {
            return react_default.a.createElement(Sidebar_Item, Object.assign({ key: tab }, props));
        }
    }
}
/* harmony default export */ var Sidebar_Tab = (Object(injectIntl["c" /* default */])(Object(hook["b" /* hookWithProps */])(Tab_Tab)((map) => ({
    tabInstance: map((rs, p) => Object(navigation["e" /* ambientWindState */])(rs).tabInstances[p.tab]),
    downloads: map((rs, p) => p.tab === "itch://downloads" ? rs.downloads : null),
}))(Tab_Tab)));

// EXTERNAL MODULE: ./node_modules/react-fast-compare/index.js
var react_fast_compare = __webpack_require__("./node_modules/react-fast-compare/index.js");
var react_fast_compare_default = /*#__PURE__*/__webpack_require__.n(react_fast_compare);

// EXTERNAL MODULE: ./src/common/util/lru-memoize.ts
var lru_memoize = __webpack_require__("./src/common/util/lru-memoize.ts");

// CONCATENATED MODULE: ./src/main/reactors/tasks/getters.ts


const getActiveTask = Object(lru_memoize["a" /* memoize */])(1, function (tasks) {
    return Object(index_all["h" /* first */])(getRunningTasks(tasks));
});
const getRunningTasks = Object(lru_memoize["a" /* memoize */])(1, function (tasks) {
    return Object(index_all["t" /* values */])(tasks.tasks);
});

// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");

// EXTERNAL MODULE: ./src/common/format/operation.ts
var operation = __webpack_require__("./src/common/format/operation.ts");

// EXTERNAL MODULE: ./src/renderer/basics/DownloadProgressSpan.tsx
var DownloadProgressSpan = __webpack_require__("./src/renderer/basics/DownloadProgressSpan.tsx");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/PrimeDownload/GameTitle.tsx


const GameTitleDiv = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};
  max-width: 90%;
  text-align: center;
	font-weight: bold;
  font-size: ${(props) => props.theme.fontSizes.large};

  &.gt-17 {
    font-size: 14px;
  }

  &.gt-26 {
    font-size: 12px;
  }
`;
const GameTitle = (props) => {
    const { title } = props;
    let className = "";
    if (title.length > 26) {
        className = "gt-26";
    }
    else if (title.length > 17) {
        className = "gt-17";
    }
    return react_default.a.createElement(GameTitleDiv, { className: className }, title);
};

// EXTERNAL MODULE: ./src/renderer/basics/LastPlayed.tsx
var LastPlayed = __webpack_require__("./src/renderer/basics/LastPlayed.tsx");

// EXTERNAL MODULE: ./src/renderer/pages/common/StandardGameCover.tsx + 1 modules
var StandardGameCover = __webpack_require__("./src/renderer/pages/common/StandardGameCover.tsx");

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/PrimeDownload/PrimeDownloadContents.tsx


















const FetchCave = Object(butlerCaller["b" /* default */])(butlerd["h" /* messages */].FetchCave);
const CompactLastPlayed = Object(styles["h" /* default */])(LastPlayed["a" /* default */]) `
  max-width: 90%;
  text-align: center;
  line-height: 1.2;
`;
const TitleBlock = styles["h" /* default */].div `
  flex-shrink: 0;
  height: 40px;
  overflow: hidden;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
`;
const EnormousIcon = Object(styles["h" /* default */])(Icon["a" /* default */]) `
  font-size: ${(props) => props.theme.fontSizes.enormous};
`;
const GameCover = Object(styles["h" /* default */])(StandardGameCover["a" /* default */]) `
  position: relative;
  pointer-events: none;

  overflow: hidden;
  box-shadow: 0 0 4px rgba(0, 0, 0, 0.4);
`;
const PrimeDownloadDiv = styles["h" /* default */].div `
  ${styles["d" /* clickable */]};

  margin: 20px auto;
  padding-bottom: 1em;

  display: flex;
  flex-direction: column;
  align-items: center;
`;
const Overlay = styles["h" /* default */].div `
  background: rgba(0, 0, 0, 0.8);
  position: absolute;

  left: 0;
  right: 0;
  bottom: 0;
  top: 0;

  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: space-between;
`;
const ProgressContainer = styles["h" /* default */].div `
  height: 50px;
  margin: 16px 0;

  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
`;
class PrimeDownloadContents_PrimeDownloadContents extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onMainClick = () => {
            Object(doAsync["a" /* doAsync */])(async () => {
                const { dispatch, kind, game, taskName, caveId } = this.props;
                if (kind === "task") {
                    if (taskName === "launch") {
                        dispatch(actions["a" /* actions */].forceCloseGameRequest({ game }));
                    }
                    return;
                }
                if (caveId) {
                    try {
                        const { cave } = await Object(rcall["a" /* rcall */])(butlerd["h" /* messages */].FetchCave, {
                            caveId,
                        });
                        dispatch(actions["a" /* actions */].queueLaunch({ cave }));
                        return;
                    }
                    catch (e) { }
                }
                dispatch(actions["a" /* actions */].navigate({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    url: "itch://downloads",
                }));
            });
        };
        this.renderLastPlayed = FetchCave.renderCallback(({ result }) => {
            if (result && result.cave) {
                const { cave } = result;
                const { game } = this.props;
                return react_default.a.createElement(CompactLastPlayed, { cave: Object(butlerd["c" /* getCaveSummary */])(cave), game: game });
            }
            return null;
        });
        this.onContextMenu = (ev) => {
            ev.preventDefault();
            const { clientX, clientY } = ev;
            const { game, dispatch } = this.props;
            dispatch(actions["a" /* actions */].openGameContextMenu({
                wind: Object(navigation["d" /* ambientWind */])(),
                game,
                clientX,
                clientY,
            }));
        };
    }
    render() {
        const { game } = this.props;
        return (react_default.a.createElement(PrimeDownloadDiv, { onClick: this.onMainClick, onContextMenu: this.onContextMenu },
            react_default.a.createElement(GameCover, { game: game, showGifMarker: false },
                react_default.a.createElement(Overlay, null,
                    react_default.a.createElement(TitleBlock, null,
                        react_default.a.createElement(GameTitle, { title: game.title })),
                    this.renderProgress()))));
    }
    renderProgress() {
        const { progress, downloadsPaused, caveId, taskName, game } = this.props;
        if (taskName) {
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(ProgressContainer, null,
                    react_default.a.createElement(EnormousIcon, { icon: Object(operation["e" /* taskIcon */])(taskName) })),
                react_default.a.createElement(TitleBlock, null, Object(t["a" /* T */])(Object(operation["d" /* formatTask */])(taskName)))));
        }
        if (!progress && !caveId) {
            return (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(ProgressContainer, null,
                    react_default.a.createElement(EnormousIcon, { icon: "stopwatch" })),
                react_default.a.createElement(TitleBlock, null, Object(t["a" /* T */])(["grid.item.queued"]))));
        }
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(ProgressContainer, null, caveId ? (react_default.a.createElement(IconButton["a" /* default */], { icon: "play2", enormous: true })) : (react_default.a.createElement(LoadingCircle["a" /* default */], { progress: progress.progress, huge: true }))),
            caveId ? (react_default.a.createElement(TitleBlock, null,
                react_default.a.createElement(FetchCave, { params: { caveId }, render: this.renderLastPlayed }))) : (react_default.a.createElement(TitleBlock, null,
                react_default.a.createElement(DownloadProgressSpan["a" /* default */], Object.assign({}, progress, { downloadsPaused: downloadsPaused }))))));
    }
}
/* harmony default export */ var PrimeDownload_PrimeDownloadContents = (Object(hook["a" /* hook */])((map) => ({
    downloadsPaused: map((rs) => rs.downloads.paused),
}))(PrimeDownloadContents_PrimeDownloadContents));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/PrimeDownload/index.tsx








const FetchGame = Object(butlerCaller["b" /* default */])(butlerd["h" /* messages */].FetchGame);
const FetchCaves = Object(butlerCaller["b" /* default */])(butlerd["h" /* messages */].FetchCaves);
class PrimeDownload_PrimeDownload extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.renderGameForCave = FetchCaves.renderCallback(({ result }) => {
            if (result) {
                const { items } = result;
                const cave = Object(index_all["h" /* first */])(items);
                if (cave) {
                    const { game } = cave;
                    return (react_default.a.createElement(PrimeDownload_PrimeDownloadContents, { game: game, caveId: cave.id, kind: "recent" }));
                }
            }
            return null;
        });
        this.renderGameForTask = FetchGame.renderCallback(({ result }) => {
            if (result) {
                const { game } = result;
                const { task } = this.props;
                return (react_default.a.createElement(PrimeDownload_PrimeDownloadContents, { game: game, kind: "task", caveId: task.caveId, taskName: task.name }));
            }
            return null;
        });
    }
    render() {
        const { task } = this.props;
        if (task) {
            if (task.name === "launch" || task.name === "uninstall") {
                return (react_default.a.createElement(FetchGame, { loadingHandled: true, errorsHandled: true, params: { gameId: task.gameId }, render: this.renderGameForTask }));
            }
        }
        const { download, progress } = this.props;
        if (download) {
            const { game } = download;
            let caveId;
            if (download.finishedAt) {
                caveId = download.caveId;
            }
            return (react_default.a.createElement(PrimeDownload_PrimeDownloadContents, { game: game, kind: "download", caveId: caveId, progress: progress }));
        }
        return (react_default.a.createElement(FetchCaves, { loadingHandled: true, errorsHandled: true, params: {
                limit: 1,
                sortBy: "lastTouched",
            }, render: this.renderGameForCave }));
    }
}
/* harmony default export */ var Sidebar_PrimeDownload = (Object(hook["a" /* hook */])((map) => ({
    task: map((rs) => getActiveTask(rs.tasks)),
    download: map((rs) => Object(getters["a" /* getActiveDownload */])(rs.downloads)),
    progress: map((rs) => {
        const active = Object(getters["a" /* getActiveDownload */])(rs.downloads);
        if (active) {
            return rs.downloads.progresses[active.id];
        }
        return null;
    }),
}))(PrimeDownload_PrimeDownload));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Sidebar.tsx


















const SidebarDiv = styles["h" /* default */].div `
  width: 240px;
  background: ${(props) => props.theme.sidebarBackground};
  font-size: ${styles["i" /* fontSizes */].sidebar};

  animation: ${styles["b" /* animations */].enterLeft} 0.2s;

  padding-bottom: 8px;

  height: 100%;
  flex-grow: 0;
  flex-shrink: 0;

  display: flex;
  align-items: stretch;
  flex-direction: column;
`;
const SidebarItems = styles["h" /* default */].div `
  display: flex;
  align-items: stretch;
  flex-direction: column;

  overflow: hidden;

  &.no-shrink {
    flex-shrink: 0;
  }
`;
const SortableListContainer = styles["h" /* default */].div `
  overflow-y: auto;
`;
const SortableList = Object(react_sortable_hoc_esm["a" /* SortableContainer */])((params) => {
    const { sidebarProps, items } = params;
    const currentTab = sidebarProps.tab;
    return (react_default.a.createElement(SortableListContainer, null, Object(index_all["l" /* map */])(items, (tab, index) => {
        const active = currentTab === tab;
        return (react_default.a.createElement(Sidebar_Tab, { key: tab, tab: tab, active: active, index: index, sortable: true }));
    })));
});
class Sidebar_Sidebar extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.closeAllTabs = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].closeAllTabs({
                wind: Object(navigation["d" /* ambientWind */])(),
            }));
        };
        this.newTab = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].newTab({
                wind: Object(navigation["d" /* ambientWind */])(),
            }));
        };
        this.onSortEnd = (params) => {
            const { oldIndex, newIndex } = params;
            this.setState({
                openTabs: Object(react_sortable_hoc_esm["c" /* arrayMove */])(this.state.openTabs, oldIndex, newIndex),
            });
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].moveTab({
                wind: Object(navigation["d" /* ambientWind */])(),
                before: oldIndex,
                after: newIndex,
            }));
        };
        this.state = {
            openTabs: props.openTabs,
        };
    }
    render() {
        const { enableTabs } = this.props;
        return (react_default.a.createElement(SidebarDiv, { id: "sidebar" },
            react_default.a.createElement(Sidebar_Logo, null),
            react_default.a.createElement(Sidebar_Search, null),
            enableTabs ? this.renderTabs() : this.renderShortcuts(),
            this.renderShortcutsRest()));
    }
    renderTabs() {
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(SidebarItems, null,
                react_default.a.createElement(SidebarSection, null,
                    react_default.a.createElement(SidebarHeading, null, Object(t["a" /* T */])(["sidebar.category.tabs"])),
                    react_default.a.createElement(Filler["a" /* default */], null),
                    react_default.a.createElement(IconButton["a" /* default */], { icon: "delete", id: "sidebar-close-all-tabs", hint: Object(t["c" /* _ */])("sidebar.close_all_tabs"), hintPosition: "left", onClick: this.closeAllTabs }),
                    react_default.a.createElement(IconButton["a" /* default */], { id: "new-tab-icon", icon: "plus", hint: Object(t["c" /* _ */])("sidebar.new_tab"), hintPosition: "left", onClick: this.newTab })),
                react_default.a.createElement(SortableList, { items: this.state.openTabs, sidebarProps: this.props, onSortEnd: this.onSortEnd, distance: 5, lockAxis: "y" }))));
    }
    renderShortcuts() {
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement(SidebarItems, null,
                this.renderLink("itch://featured", "earth", ["sidebar.explore"]),
                this.renderLink("itch://library", "heart-filled", [
                    "sidebar.library",
                ]),
                this.renderLink("itch://collections", "video_collection", [
                    "sidebar.collections",
                ]),
                this.renderLink("itch://dashboard", "archive", [
                    "sidebar.dashboard",
                ]))));
    }
    renderShortcutsRest() {
        return (react_default.a.createElement(react_default.a.Fragment, null,
            react_default.a.createElement("div", { style: { flexGrow: 1 } }),
            react_default.a.createElement(Sidebar_PrimeDownload, null),
            react_default.a.createElement(SidebarItems, { className: "no-shrink" },
                this.renderLink("itch://downloads", "download", [
                    "sidebar.downloads",
                ]),
                this.renderLink("itch://preferences", "cog", [
                    "sidebar.preferences",
                ]))));
    }
    renderLink(url, icon, label) {
        return (react_default.a.createElement(SidebarSection, null,
            react_default.a.createElement("a", { href: url, className: classnames_default()({ active: this.props.url.startsWith(url) }) },
                react_default.a.createElement(Icon["a" /* default */], { icon: icon }),
                " ",
                Object(t["a" /* T */])(label))));
    }
    static getDerivedStateFromProps(props, state) {
        if (!react_fast_compare_default()(props.openTabs, state.openTabs)) {
            return {
                openTabs: props.openTabs,
            };
        }
        return null;
    }
}
/* harmony default export */ var HubScene_Sidebar_Sidebar = (Object(hook["a" /* hook */])((map) => ({
    me: map((rs) => rs.profile.profile.user),
    tab: map((rs) => Object(navigation["a" /* ambientNavigation */])(rs).tab),
    openTabs: map((rs) => Object(navigation["a" /* ambientNavigation */])(rs).openTabs),
    enableTabs: map((rs) => rs.preferences.enableTabs),
    url: map((rs) => {
        const ws = Object(navigation["e" /* ambientWindState */])(rs);
        const ti = ws.tabInstances[Object(navigation["a" /* ambientNavigation */])(rs).tab];
        return ti.history[ti.currentIndex].url;
    }),
}))(Sidebar_Sidebar));

// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/index.tsx




const HubSceneDiv = styles["h" /* default */].div `
  overflow: hidden;
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  flex-direction: row;
`;
class HubScene_HubScene extends react_default.a.PureComponent {
    render() {
        const iw = window.windSpec;
        return (react_default.a.createElement(HubSceneDiv, null,
            iw.role == "main" ? react_default.a.createElement(HubScene_Sidebar_Sidebar, null) : null,
            react_default.a.createElement(HubScene_HubContent, null)));
    }
}
/* harmony default export */ var scenes_HubScene = __webpack_exports__["default"] = (HubScene_HubScene);


/***/ }),

/***/ "./src/static/images/logos/app-white.svg":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = (__webpack_require__.p + "c143903d0c758898b2428036ce9061e6.svg");

/***/ })

}]);
//# sourceMappingURL=6.chunk.js.map