(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[7],{

/***/ "./src/common/format/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return getDownloadError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return getInstallPlanInfoError; });
/* unused harmony export getButlerdErrorFromTuple */
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");


function formatError(e, apiErrorPrefix) {
    const re = Object(common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re && re.rpcError) {
        const { code, data } = re.rpcError;
        if (data && data.apiError && apiErrorPrefix) {
            const { messages } = data.apiError;
            const message = Object(underscore__WEBPACK_IMPORTED_MODULE_1__[/* first */ "h"])(messages);
            if (message) {
                const snakeCaseMessage = message.replace(/\s/g, "_").toLowerCase();
                return [
                    `errors.api.${apiErrorPrefix}.${snakeCaseMessage}`,
                    {
                        defaultValue: `{message}`,
                        message,
                    },
                ];
            }
        }
        const { message } = re.rpcError;
        return [
            `butlerd.codes.${code}`,
            {
                defaultValue: `{message}`,
                message,
            },
        ];
    }
    return e.message;
}
function getDownloadError(item) {
    return getButlerdErrorFromTuple(item);
}
function getInstallPlanInfoError(item) {
    return getButlerdErrorFromTuple(item);
}
function getButlerdErrorFromTuple(item) {
    if (!item.errorMessage) {
        return null;
    }
    let rawError = new Error(item.errorMessage);
    rawError.stack = item.error;
    rawError.rpcError = {
        code: item.errorCode,
        message: item.errorMessage,
        data: {
            stack: item.error,
        },
    };
    return rawError;
}


/***/ }),

/***/ "./src/common/format/filesize.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return fileSize; });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ "./src/common/format/upload.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return formatUploadTitle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return formatUploadTitleFancy; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatBuildVersionInfo; });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ "./src/renderer/basics/SimpleSelect/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ SimpleSelect_SimpleSelect; });

// UNUSED EXPORTS: FloaterSpacer

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/SimpleSelect/DefaultOptionComponent.tsx



const DefaultOptionDiv = styles["h" /* default */].div `
  display: flex;
  flex-flow: row;
  align-items: center;
`;
class DefaultOptionComponent_DefaultOptionComponent extends react_default.a.PureComponent {
    render() {
        const { option } = this.props;
        return react_default.a.createElement(DefaultOptionDiv, null, Object(t["a" /* T */])(option.label));
    }
}

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__("./src/renderer/basics/Floater.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/SimpleSelect/index.tsx








const FloaterSpacer = styles["h" /* default */].div `
  width: 8px;
  flex-shrink: 0;
`;
const SimpleSelectDiv = styles["h" /* default */].div `
  cursor: default;
  flex-grow: 1;

  background: ${(props) => props.theme.inputBackground};
  border: 1px solid ${(props) => props.theme.inputBorder};
  border-radius: 2px;

  transition: border-color: 0.1s;

  &:hover {
    border-color: ${(props) => props.theme.inputBorderFocused};
  }

  &:focus {
    outline: none;
  }
`;
const wrapperPadding = 10;
const iconPadding = 14;
const wrapperLike = styles["g" /* css */] `
  ${styles["s" /* singleLine */]};
  min-width: 180px;
  min-height: 2em;
  padding: ${wrapperPadding}px;
`;
const ValueWrapper = styles["h" /* default */].div `
  ${wrapperLike};

  display: flex;
  flex-flow: row;
  align-items: center;
`;
const OptionWrapperDiv = styles["h" /* default */].div `
  ${wrapperLike};
  background: ${(props) => props.theme.inputBackground};

  &.focused {
    background: ${(props) => props.theme.inputFocusedBackground};
  }

  &.selected {
    background: ${(props) => props.theme.inputSelectedBackground};
  }
`;
class SimpleSelect_OptionWrapper extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.gotEl = (el) => {
            this.el = el;
            if (this.el) {
                this.updateScroll();
            }
        };
    }
    render() {
        return react_default.a.createElement(OptionWrapperDiv, Object.assign({}, this.props, { ref: this.gotEl }));
    }
    componentDidUpdate() {
        this.updateScroll();
    }
    updateScroll() {
        const { className } = this.props;
        if (/focused/.test(className)) {
            this.el.scrollIntoViewIfNeeded();
        }
    }
}
const Bar = styles["h" /* default */].div `
  height: auto;
  width: 1px;
  background: ${(props) => props.theme.inputBorderFocused};
  align-self: stretch;
`;
const IconWrapper = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
  padding-right: ${iconPadding - wrapperPadding}px;
  padding-left: ${iconPadding}px;
`;
const OptionsAnchorDiv = styles["h" /* default */].div `
  position: relative;
`;
const OptionsDiv = styles["h" /* default */].div `
  position: absolute;
  top: 4px;
  left: 0;
  right: 0;
  padding: 4px 0;
  border-radius: 2px;

  border: 1px solid ${(props) => props.theme.inputBorder};

  z-index: 10;

  max-height: 400px;
  overflow-y: auto;
`;
const DummyOption = styles["h" /* default */].div `
  display: flex;
  flex-flow: row;
  align-items: center;
  color: ${(props) => props.theme.ternaryText};
`;
const searchClearThreshold = 2000; // 2 seconds
const keyboardFocusTimeout = 250;
class SimpleSelect_SimpleSelect extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onKeyDown = (ev) => {
            if (ev.key === "ArrowUp" ||
                ev.key === "PageUp" ||
                ev.key === "ArrowDown" ||
                ev.key === "PageDown" ||
                ev.key === "Home" ||
                ev.key === "End") {
                ev.preventDefault();
                const { options } = this.props;
                let { focusedValue } = this.state;
                if (!focusedValue) {
                    focusedValue = this.props.value;
                }
                if (!focusedValue) {
                    return;
                }
                let currentIndex = options.indexOf(focusedValue);
                let newIndex = currentIndex;
                if (ev.key === "ArrowUp") {
                    newIndex -= 1;
                }
                else if (ev.key === "ArrowDown") {
                    newIndex += 1;
                }
                else if (ev.key === "PageUp") {
                    newIndex -= 5;
                }
                else if (ev.key === "PageDown") {
                    newIndex += 5;
                }
                else if (ev.key === "Home") {
                    newIndex = 0;
                }
                else if (ev.key === "End") {
                    newIndex = options.length - 1;
                }
                if (newIndex < 0) {
                    newIndex = 0;
                }
                else if (newIndex >= options.length) {
                    newIndex = options.length - 1;
                }
                let newFocusedValue = options[newIndex];
                this.setState({
                    focusedValue: newFocusedValue,
                    lastKeyboardFocusAt: Date.now(),
                });
            }
            if (ev.key === "Enter") {
                this.close();
                this.props.onChange(this.state.focusedValue);
            }
        };
        this.onKeyPress = (ev) => {
            let search;
            let state = this.state;
            let prefix = Date.now() - state.lastSearchAt > searchClearThreshold
                ? ""
                : state.search;
            search = (prefix + ev.key).toLowerCase();
            this.setState({
                search,
                lastSearchAt: Date.now(),
            });
            const focusedValue = Object(index_all["f" /* find */])(this.props.options, (x) => typeof x.label === "string" && x.label.toLowerCase().startsWith(search));
            if (focusedValue) {
                this.setState({ focusedValue, lastKeyboardFocusAt: Date.now() });
            }
        };
        this.onOptionClick = (ev) => {
            ev.stopPropagation();
            const { onChange } = this.props;
            onChange(this.getValueForWrapper(ev.currentTarget));
            this.close();
        };
        this.onOptionMouseEnter = (ev) => {
            if (Date.now() - this.state.lastKeyboardFocusAt < keyboardFocusTimeout) {
                return;
            }
            this.setState({ focusedValue: this.getValueForWrapper(ev.currentTarget) });
        };
        this.onToggle = () => {
            this.setState((state) => ({
                open: !state.open,
            }));
            if (this.state.open) {
                this.close();
            }
            else {
                this.open();
            }
        };
        this.onBlur = () => {
            this.close();
        };
        this.state = {
            open: false,
            focusedValue: Object(index_all["h" /* first */])(props.options),
            search: "",
            lastSearchAt: Date.now(),
            lastKeyboardFocusAt: 0,
        };
    }
    render() {
        const { value, OptionComponent = DefaultOptionComponent_DefaultOptionComponent, isLoading, className, } = this.props;
        return (react_default.a.createElement(SimpleSelectDiv, { className: className, onClick: this.onToggle, onKeyDown: this.onKeyDown, onKeyPress: this.onKeyPress, tabIndex: -1, onBlur: this.onBlur },
            react_default.a.createElement(ValueWrapper, null,
                value ? (react_default.a.createElement(OptionComponent, { option: value })) : (react_default.a.createElement(DummyOption, null, "Select...")),
                react_default.a.createElement(Filler["a" /* default */], null),
                isLoading ? (react_default.a.createElement(react_default.a.Fragment, null,
                    react_default.a.createElement(Floater["a" /* default */], null),
                    react_default.a.createElement(FloaterSpacer, null))) : null,
                react_default.a.createElement(Bar, null),
                react_default.a.createElement(IconWrapper, null,
                    react_default.a.createElement(Icon["a" /* default */], { icon: "caret-down" }))),
            react_default.a.createElement(OptionsAnchorDiv, null, this.renderOptions())));
    }
    renderOptions() {
        const { open } = this.state;
        if (!open) {
            return null;
        }
        const { focusedValue } = this.state;
        const { options, value, OptionComponent = DefaultOptionComponent_DefaultOptionComponent, } = this.props;
        return (react_default.a.createElement(OptionsDiv, null, options.map((option, i) => {
            const focused = focusedValue === option;
            const selected = value === option;
            return (react_default.a.createElement(SimpleSelect_OptionWrapper, { key: i, className: classnames_default()({ focused, selected }), "data-value": JSON.stringify(option.value), onClick: this.onOptionClick, onMouseEnter: this.onOptionMouseEnter },
                react_default.a.createElement(OptionComponent, { key: i, option: option })));
        })));
    }
    getValueForWrapper(el) {
        let dataValue = JSON.parse(el.dataset.value);
        const { options, onChange } = this.props;
        return Object(index_all["g" /* findWhere */])(options, { value: dataValue });
    }
    open() {
        this.setState({ open: true, focusedValue: this.props.value });
    }
    close() {
        this.setState({ open: false });
    }
}


/***/ }),

/***/ "./src/renderer/basics/UploadIcon.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__("./src/common/format/filesize.ts");

// EXTERNAL MODULE: ./src/common/constants/platform-data.ts
var platform_data = __webpack_require__("./src/common/constants/platform-data.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// CONCATENATED MODULE: ./src/main/reactors/make-upload-button.ts



function makeUploadButton(upload, opts = { showSize: true }) {
    let label = `${upload.displayName || upload.filename}`;
    let tags = [];
    if (upload.size > 0 && opts.showSize) {
        tags.push({
            label: `${Object(filesize["a" /* fileSize */])(upload.size)}`,
        });
    }
    if (upload.demo) {
        tags.push({
            label: ["pick_update_upload.tags.demo"],
        });
    }
    for (const prop of Object.keys(platform_data["a" /* default */])) {
        if (upload[prop]) {
            tags.push({
                icon: platform_data["a" /* default */][prop].icon,
            });
        }
    }
    const timeAgo = {
        date: upload.updatedAt,
    };
    const icon = uploadIcon(upload) || "download";
    return { label, tags, icon, timeAgo };
}
const uploadIcons = {
    [messages["UploadType"].Default]: "gamepad",
    [messages["UploadType"].Flash]: "neutral",
    [messages["UploadType"].Unity]: "neutral",
    [messages["UploadType"].Java]: "neutral",
    [messages["UploadType"].HTML]: "html5",
    [messages["UploadType"].Soundtrack]: "music",
    [messages["UploadType"].Book]: "book",
    [messages["UploadType"].Video]: "video",
    [messages["UploadType"].Documentation]: "book",
    [messages["UploadType"].Mod]: "shirt",
    [messages["UploadType"].AudioAssets]: "file-music",
    [messages["UploadType"].GraphicalAssets]: "images",
    [messages["UploadType"].Sourcecode]: "code",
    [messages["UploadType"].Other]: "zip",
};
function uploadIcon(upload) {
    return uploadIcons[upload.type];
}
// TODO: i18n that stuff
const uploadTypeHints = {
    [messages["UploadType"].Default]: "File",
    [messages["UploadType"].Flash]: "Flash embed",
    [messages["UploadType"].Unity]: "Unity embed (legacy)",
    [messages["UploadType"].Java]: "Java applet",
    [messages["UploadType"].HTML]: "HTML5 app",
    [messages["UploadType"].Soundtrack]: "Soundtrack",
    [messages["UploadType"].Book]: "Book",
    [messages["UploadType"].Video]: "Video",
    [messages["UploadType"].Documentation]: "Documentation",
    [messages["UploadType"].Mod]: "Mod",
    [messages["UploadType"].AudioAssets]: "Audio assets",
    [messages["UploadType"].GraphicalAssets]: "Graphical assets",
    [messages["UploadType"].Sourcecode]: "Source code",
    [messages["UploadType"].Other]: "Other",
};
function uploadTypeHint(upload) {
    return uploadTypeHints[upload.type];
}

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/UploadIcon.tsx



class UploadIcon_UploadIcon extends react_default.a.PureComponent {
    render() {
        const { upload } = this.props;
        if (!upload) {
            return null;
        }
        return react_default.a.createElement(Icon["a" /* default */], { icon: uploadIcon(upload), hint: uploadTypeHint(upload) });
    }
}
/* harmony default export */ var basics_UploadIcon = __webpack_exports__["a"] = (UploadIcon_UploadIcon);


/***/ }),

/***/ "./src/renderer/basics/modal-styles.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return ModalButtons; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalButtonSpacer; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const ModalButtons = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  width: 100%;
  flex-shrink: 0;
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
`;
const ModalButtonSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  flex-shrink: 0;
  flex-grow: 0;
  width: 1em;
`;


/***/ }),

/***/ "./src/renderer/helpers/doAsync.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return doAsync; });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ "./src/renderer/modal-widgets/PlanInstall/InstallLocationOptionComponent.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InstallLocationOptionAdd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return InstallLocationOptionComponent; });
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/format/filesize.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_modal_widgets_PlanInstall_select_common__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/modal-widgets/PlanInstall/select-common.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/t.tsx");





const InstallLocationOptionAdd = "_add";
function InstallLocationOptionComponent(props) {
    const l = props.option.location;
    if (!l) {
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_modal_widgets_PlanInstall_select_common__WEBPACK_IMPORTED_MODULE_3__[/* SelectValueDiv */ "a"], null,
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { icon: "plus" }),
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "spacer" }),
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "title" }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_4__[/* T */ "a"])(props.option.label)),
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "spacer" })));
    }
    return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_modal_widgets_PlanInstall_select_common__WEBPACK_IMPORTED_MODULE_3__[/* SelectValueDiv */ "a"], null,
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { icon: "folder-open" }),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "spacer" }),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "title", title: l.path }, l.path),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "spacer" }),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "tag" }, Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_0__[/* fileSize */ "a"])(l.sizeInfo.freeSize)),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "spacer" })));
}


/***/ }),

/***/ "./src/renderer/modal-widgets/PlanInstall/UploadOptionComponent.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UploadOptionComponent; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/UploadIcon.tsx");
/* harmony import */ var common_format_upload__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/format/upload.ts");
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/common/format/filesize.ts");
/* harmony import */ var renderer_modal_widgets_PlanInstall_select_common__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/modal-widgets/PlanInstall/select-common.tsx");
/* harmony import */ var renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/basics/PlatformIcons/PlatformIcon.tsx");






function UploadOptionComponent(props) {
    const u = props.option.upload;
    return (react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_modal_widgets_PlanInstall_select_common__WEBPACK_IMPORTED_MODULE_4__[/* SelectValueDiv */ "a"], null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"], { upload: u }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "title", title: Object(common_format_upload__WEBPACK_IMPORTED_MODULE_2__[/* formatUploadTitle */ "b"])(u) }, Object(common_format_upload__WEBPACK_IMPORTED_MODULE_2__[/* formatUploadTitleFancy */ "c"])(u)),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { target: u, field: "windows", before: react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" }) }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { target: u, field: "linux", before: react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" }) }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_5__[/* default */ "a"], { target: u, field: "osx", before: react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" }) }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" }),
        u.size > 0 ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "tag" }, Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_3__[/* fileSize */ "a"])(u.size)) : null,
        u.demo ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "tag" }, "demo") : null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", { className: "spacer" })));
}


/***/ }),

/***/ "./src/renderer/modal-widgets/PlanInstall/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(__filename) {/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/common/actions/index.ts");
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/common/butlerd/messages.ts");
/* harmony import */ var common_format_errors__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/common/format/errors.ts");
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./src/common/format/filesize.ts");
/* harmony import */ var common_format_upload__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./src/common/format/upload.ts");
/* harmony import */ var common_modals__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("./src/common/modals/index.ts");
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_10___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_10__);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("./node_modules/react-intl/lib/src/components/injectIntl.js");
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("./src/renderer/basics/Button.tsx");
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("./src/renderer/basics/Filler.tsx");
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__("./src/renderer/basics/Floater.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__("./src/renderer/basics/modal-styles.tsx");
/* harmony import */ var renderer_basics_SimpleSelect__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__("./src/renderer/basics/SimpleSelect/index.tsx");
/* harmony import */ var renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__("./src/renderer/butlerd/rcall.ts");
/* harmony import */ var renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__("./src/renderer/helpers/doAsync.tsx");
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__("./src/renderer/hocs/butlerCaller/index.tsx");
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__("./src/renderer/hocs/hook.tsx");
/* harmony import */ var renderer_hocs_watching__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__("./src/renderer/hocs/watching.tsx");
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__("./src/renderer/logger/index.ts");
/* harmony import */ var renderer_modal_widgets_PlanInstall_InstallLocationOptionComponent__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__("./src/renderer/modal-widgets/PlanInstall/InstallLocationOptionComponent.tsx");
/* harmony import */ var renderer_modal_widgets_PlanInstall_UploadOptionComponent__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__("./src/renderer/modal-widgets/PlanInstall/UploadOptionComponent.tsx");
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__("./src/renderer/modal-widgets/styles.tsx");
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__("./src/renderer/pages/common/SortsAndFilters.tsx");
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__("./src/renderer/pages/common/StandardGameCover.tsx");
/* harmony import */ var renderer_pages_common_StandardGameDesc__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__("./src/renderer/pages/common/StandardGameDesc.tsx");
/* harmony import */ var renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__("./src/renderer/pages/PageStyles/boxes.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__("./src/renderer/styles.ts");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__("./src/renderer/t.tsx");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__("./src/common/logger/index.ts");



































const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_23__[/* rendererLogger */ "a"].child(__filename);
const DiskSpaceIcon = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"])(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_15__[/* default */ "a"]) `
  margin-left: 8px;
`;
const ErrorContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].div `
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const ErrorButtons = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].div `
  flex-shrink: 0;
`;
const ErrorParagraph = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].div `
  flex-grow: 1;
  line-height: 1.4;
  margin-right: 1em;
  color: ${(props) => props.theme.error};
  font-size: ${(props) => props.theme.fontSizes.baseText};
`;
const WideBox = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"])(renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_30__[/* Box */ "a"]) `
  width: 100%;
`;
const SizeTable = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].table `
  td {
    line-height: 2.5;
    padding-right: 0.4em;

    &.low {
      color: ${(props) => props.theme.error};
    }

    &.desc {
      color: ${(props) => props.theme.secondaryText};
    }

    strong {
      font-weight: bold;
    }

    i {
      font-size: 80%;
      opacity: 0.6;
    }
  }
`;
const PlanInstallDiv = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"])(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_26__[/* ModalWidgetDiv */ "a"]) `
  min-width: 800px;
  max-width: 800px;
  min-height: 500px;
  max-height: 500px;
  display: flex;
  flex-direction: column;
`;
const SelectGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].div `
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: flex-start;
  align-items: center;

  padding: 0.4em 0;
`;
const SelectHeader = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].h3 `
  width: 150px;
`;
const StyledSelect = renderer_styles__WEBPACK_IMPORTED_MODULE_31__[/* default */ "h"].select `
  flex-grow: 1;
  padding: 0.4em;
  border: 1px solid ${(props) => props.theme.filterBorder};
  border-radius: 3px;
  color: ${(props) => props.theme.baseText};

  background: rgba(0, 0, 0, 0.1);
  font-size: ${(props) => props.theme.fontSizes.large};
`;
var PlanStage;
(function (PlanStage) {
    PlanStage[PlanStage["Planning"] = 0] = "Planning";
})(PlanStage || (PlanStage = {}));
let PlanInstall = class PlanInstall extends react__WEBPACK_IMPORTED_MODULE_10___default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onShowError = () => {
            const { dispatch, intl } = this.props;
            const { game, error, log } = this.state;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].openModal(common_modals__WEBPACK_IMPORTED_MODULE_8__[/* modals */ "a"].showError.make({
                wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_9__[/* ambientWind */ "d"])(),
                title: ["prompt.install_error.title"],
                message: Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* TString */ "b"])(intl, Object(common_format_errors__WEBPACK_IMPORTED_MODULE_5__[/* formatError */ "a"])(error)),
                widgetParams: {
                    game,
                    rawError: error,
                    log,
                },
                buttons: ["ok"],
            })));
        };
        this.onInstallLocationChange = (item) => {
            if (item.value === renderer_modal_widgets_PlanInstall_InstallLocationOptionComponent__WEBPACK_IMPORTED_MODULE_24__[/* InstallLocationOptionAdd */ "a"]) {
                const { dispatch } = this.props;
                dispatch(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].addInstallLocation({ wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_9__[/* ambientWind */ "d"])() }));
                return;
            }
            this.setState({
                pickedInstallLocationId: item.value,
            });
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].updatePreferences({
                defaultInstallLocation: item.value,
            }));
        };
        this.onUploadChange = (item) => {
            const id = item.value;
            this.setState({
                pickedUploadId: id,
                busy: true,
            });
            this.pickUpload(id);
        };
        this.onCancel = (ev) => {
            this.close();
        };
        this.onInstall = (ev) => {
            this.close();
            Object(renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_19__[/* doAsync */ "a"])(async () => {
                const { dispatch } = this.props;
                const { game } = this.state;
                const { pickedInstallLocationId, pickedUploadId, uploads } = this.state;
                const upload = Object(underscore__WEBPACK_IMPORTED_MODULE_33__[/* findWhere */ "g"])(uploads, { id: pickedUploadId });
                const logger = Object(common_logger__WEBPACK_IMPORTED_MODULE_34__[/* recordingLogger */ "e"])(renderer_logger__WEBPACK_IMPORTED_MODULE_23__[/* rendererLogger */ "a"]);
                logger.info(`Queuing install for ${game.url}...`);
                try {
                    await Object(renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_18__[/* rcall */ "a"])(common_butlerd__WEBPACK_IMPORTED_MODULE_3__[/* messages */ "h"].InstallQueue, {
                        reason: common_butlerd_messages__WEBPACK_IMPORTED_MODULE_4__["DownloadReason"].Install,
                        installLocationId: pickedInstallLocationId,
                        game,
                        upload,
                        build: upload.build,
                        queueDownload: true,
                        fastQueue: true,
                    }, (convo) => {
                        Object(common_butlerd__WEBPACK_IMPORTED_MODULE_3__[/* hookLogging */ "f"])(convo, logger);
                    });
                    logger.info(`Queued!`);
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].downloadQueued({}));
                }
                catch (e) {
                    logger.error(`While queuing download: ${e.stack}`);
                    const { intl } = this.props;
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].openModal(common_modals__WEBPACK_IMPORTED_MODULE_8__[/* modals */ "a"].showError.make({
                        wind: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_9__[/* ambientWind */ "d"])(),
                        title: ["prompt.install_error.title"],
                        message: Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* TString */ "b"])(intl, Object(common_format_errors__WEBPACK_IMPORTED_MODULE_5__[/* formatError */ "a"])(e)),
                        widgetParams: {
                            game,
                            rawError: e,
                            log: logger.getLog(),
                        },
                        buttons: ["ok"],
                    })));
                }
            });
        };
        const { game } = props.modal.widgetParams;
        this.state = {
            stage: PlanStage.Planning,
            busy: true,
            game,
            gameId: game.id,
            installLocations: [],
        };
    }
    subscribe(watcher) {
        watcher.on(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].installLocationsChanged, async () => {
            this.loadInstallLocations();
        });
    }
    render() {
        return react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(PlanInstallDiv, null, this.renderBody());
    }
    renderBody() {
        const { stage } = this.state;
        switch (stage) {
            case PlanStage.Planning:
                return this.renderPlanning();
        }
    }
    renderPlanning() {
        const { game, uploads, pickedUploadId, installLocations, pickedInstallLocationId, busy, error, } = this.state;
        let canInstall = !error && !busy;
        let locationOptions = installLocations.map((il) => {
            let val = {
                label: `${il.path} (${Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_6__[/* fileSize */ "a"])(il.sizeInfo.freeSize)} free)`,
                value: il.id,
                location: il,
            };
            return val;
        });
        locationOptions.push({
            label: Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* _ */ "c"])("preferences.install_location.add"),
            value: renderer_modal_widgets_PlanInstall_InstallLocationOptionComponent__WEBPACK_IMPORTED_MODULE_24__[/* InstallLocationOptionAdd */ "a"],
            location: null,
        });
        let locationValue = Object(underscore__WEBPACK_IMPORTED_MODULE_33__[/* findWhere */ "g"])(locationOptions, {
            value: pickedInstallLocationId,
        });
        let uploadOptions = [];
        if (uploads) {
            uploadOptions = uploads.map((u) => {
                let val = {
                    label: `${Object(common_format_upload__WEBPACK_IMPORTED_MODULE_7__[/* formatUploadTitle */ "b"])(u)} ${u.size > 0 ? Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_6__[/* fileSize */ "a"])(u.size) : ""}`,
                    value: u.id,
                    upload: u,
                };
                return val;
            });
        }
        let uploadValue = Object(underscore__WEBPACK_IMPORTED_MODULE_33__[/* findWhere */ "g"])(uploadOptions, { value: pickedUploadId });
        return (react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_10___default.a.Fragment, null,
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(WideBox, null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_30__[/* BoxInner */ "b"], null,
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_28__[/* default */ "a"], { game: game }),
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_27__[/* FilterSpacer */ "e"], null),
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_pages_common_StandardGameDesc__WEBPACK_IMPORTED_MODULE_29__[/* default */ "a"], { game: game }),
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_27__[/* FilterSpacer */ "e"], null))),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(SelectGroup, null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(SelectHeader, null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* _ */ "c"])("plan_install.select_upload"))),
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_SimpleSelect__WEBPACK_IMPORTED_MODULE_17__[/* default */ "a"], { onChange: this.onUploadChange, value: uploadValue, options: uploadOptions, OptionComponent: renderer_modal_widgets_PlanInstall_UploadOptionComponent__WEBPACK_IMPORTED_MODULE_25__[/* default */ "a"], isLoading: busy })),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(SelectGroup, null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(SelectHeader, null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* _ */ "c"])("plan_install.select_install_location"))),
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_SimpleSelect__WEBPACK_IMPORTED_MODULE_17__[/* default */ "a"], { onChange: this.onInstallLocationChange, value: locationValue, options: locationOptions, OptionComponent: renderer_modal_widgets_PlanInstall_InstallLocationOptionComponent__WEBPACK_IMPORTED_MODULE_24__[/* default */ "b"] })),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], null),
            busy
                ? this.renderBusy()
                : error
                    ? this.renderError()
                    : this.renderSizes(),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], null),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_16__[/* ModalButtons */ "b"], null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { onClick: this.onCancel }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(["prompt.action.cancel"])),
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_13__[/* default */ "a"], null),
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { disabled: !canInstall, icon: "install", primary: true, onClick: this.onInstall, id: canInstall ? "modal-install-now" : null }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(["grid.item.install"])))));
    }
    renderError() {
        const { error } = this.state;
        return (react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(ErrorContainer, null,
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(ErrorParagraph, null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_15__[/* default */ "a"], { icon: "error" }),
                " ",
                Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(Object(common_format_errors__WEBPACK_IMPORTED_MODULE_5__[/* formatError */ "a"])(error))),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(ErrorButtons, null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_12__[/* default */ "a"], { label: Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(["grid.item.view_details"]), onClick: this.onShowError }))));
    }
    renderBusy() {
        return (react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_20__[/* LoadingStateDiv */ "a"], null,
            Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* _ */ "c"])("plan_install.computing_space_requirements")),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_27__[/* FilterSpacer */ "e"], null),
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_14__[/* default */ "a"], null)));
    }
    renderSizes() {
        const { info, pickedInstallLocationId, installLocations } = this.state;
        if (!info) {
            return null;
        }
        const installLocation = Object(underscore__WEBPACK_IMPORTED_MODULE_33__[/* findWhere */ "g"])(installLocations, {
            id: pickedInstallLocationId,
        });
        if (!installLocation) {
            return null;
        }
        const requiredSpace = info ? info.diskUsage.neededFreeSpace : -1;
        const freeSpace = installLocation.sizeInfo.freeSize;
        const haveEnoughSpace = requiredSpace <= freeSpace;
        return (react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(SizeTable, null,
            react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("tbody", null,
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("tr", null,
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("td", { className: "desc" }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* _ */ "c"])("plan_install.disk_space_required"))),
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("td", null,
                        react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("strong", null, requiredSpace > 0 ? Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_6__[/* fileSize */ "a"])(requiredSpace) : "?"))),
                react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("tr", null,
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("td", { className: "desc" }, Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* T */ "a"])(Object(renderer_t__WEBPACK_IMPORTED_MODULE_32__[/* _ */ "c"])("plan_install.disk_space_available"))),
                    react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("td", { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()({ low: !haveEnoughSpace }) },
                        react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement("strong", null, Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_6__[/* fileSize */ "a"])(freeSpace)),
                        haveEnoughSpace ? (react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(DiskSpaceIcon, { icon: "checkmark" })) : (react__WEBPACK_IMPORTED_MODULE_10___default.a.createElement(DiskSpaceIcon, { icon: "warning" })))))));
    }
    close() {
        const { wind, id } = this.props.modal;
        const { dispatch } = this.props;
        dispatch(common_actions__WEBPACK_IMPORTED_MODULE_2__[/* actions */ "a"].closeModal({ wind, id }));
    }
    componentDidMount() {
        this.loadInstallLocations();
        const { uploadId } = this.props.modal.widgetParams;
        this.pickUpload(uploadId);
    }
    loadInstallLocations() {
        Object(renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_19__[/* doAsync */ "a"])(async () => {
            const { defaultInstallLocation } = this.props;
            const { installLocations } = await Object(renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_18__[/* rcall */ "a"])(common_butlerd__WEBPACK_IMPORTED_MODULE_3__[/* messages */ "h"].InstallLocationsList, {});
            const defaultRecord = Object(underscore__WEBPACK_IMPORTED_MODULE_33__[/* findWhere */ "g"])(installLocations, {
                id: defaultInstallLocation,
            });
            this.setState({
                stage: PlanStage.Planning,
                installLocations,
                pickedInstallLocationId: defaultRecord
                    ? defaultRecord.id
                    : installLocations[0].id,
            });
        });
    }
    pickUpload(uploadId) {
        Object(renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_19__[/* doAsync */ "a"])(async () => {
            try {
                const { gameId } = this.state;
                const logger = Object(common_logger__WEBPACK_IMPORTED_MODULE_34__[/* recordingLogger */ "e"])(renderer_logger__WEBPACK_IMPORTED_MODULE_23__[/* rendererLogger */ "a"]);
                const res = await Object(renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_18__[/* rcall */ "a"])(common_butlerd__WEBPACK_IMPORTED_MODULE_3__[/* messages */ "h"].InstallPlan, { gameId, uploadId }, (convo) => {
                    Object(common_butlerd__WEBPACK_IMPORTED_MODULE_3__[/* hookLogging */ "f"])(convo, logger);
                });
                this.setState({
                    stage: PlanStage.Planning,
                    game: res.game,
                    uploads: res.uploads,
                    pickedUploadId: res.info ? res.info.upload.id : null,
                    info: res.info,
                    busy: false,
                    error: res.info && res.info.error
                        ? Object(common_format_errors__WEBPACK_IMPORTED_MODULE_5__[/* getInstallPlanInfoError */ "c"])(res.info)
                        : null,
                    log: logger.getLog(),
                });
            }
            catch (e) {
                this.setState({
                    busy: false,
                    error: e,
                });
            }
        });
    }
};
PlanInstall = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __decorate */ "b"])([
    renderer_hocs_watching__WEBPACK_IMPORTED_MODULE_22__[/* default */ "a"]
], PlanInstall);
/* harmony default export */ __webpack_exports__["default"] = (Object(react_intl__WEBPACK_IMPORTED_MODULE_11__[/* default */ "c"])(Object(renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_21__[/* hook */ "a"])((map) => ({
    defaultInstallLocation: map((rs) => rs.preferences.defaultInstallLocation),
}))(PlanInstall)));

/* WEBPACK VAR INJECTION */}.call(this, "src/renderer/modal-widgets/PlanInstall/index.tsx"))

/***/ }),

/***/ "./src/renderer/modal-widgets/PlanInstall/select-common.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SelectValueDiv; });
/* harmony import */ var styled_components__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/styled-components/dist/styled-components.browser.esm.js");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/styles.ts");


const SelectValueDiv = styled_components__WEBPACK_IMPORTED_MODULE_0__["default"].div `
  display: flex;
  flex-flow: row wrap;
  align-items: center;

  .spacer {
    width: 0.5em;
    flex-shrink: 0;
  }

  .title {
    font-size: 90%;
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__[/* singleLine */ "s"]};
  }

  .tag {
    color: ${(props) => props.theme.secondaryText};
    text-shadow: none;

    font-size: 80%;
    padding-right: 8px;
    &:last-child {
      padding-right: 0;
    }

    border-radius: ${(props) => props.theme.borderRadii.explanation};
    flex-shrink: 0;
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__[/* singleLine */ "s"]};
  }
`;


/***/ }),

/***/ "./src/renderer/modal-widgets/styles.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalWidgetDiv; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* heavyInput */ "j"]};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ }),

/***/ "./src/renderer/pages/PageStyles/boxes.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export BaseBox */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Box; });
/* unused harmony export BoxSingle */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return BoxInner; });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/styles.ts");

const BaseBox = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  margin: 1em auto;
  line-height: 1.6;
`;
const Box = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* boxy */ "c"]};
  max-width: 1200px;

  margin: 1em auto;
  line-height: 1.6;
`;
const BoxSingle = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* boxy */ "c"]};

  margin: 1em auto;
  line-height: 1.6;
`;
const BoxInner = renderer_styles__WEBPACK_IMPORTED_MODULE_0__[/* default */ "h"].div `
  width: 100%;
  display: flex;
  flex-direction: row;
  align-items: center;
`;


/***/ }),

/***/ "./src/renderer/pages/common/SortsAndFilters.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return SortsAndFilters; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FilterGroup; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return FilterOptionLink; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FilterOptionButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return FilterOptionIcon; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return FilterSpacer; });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/renderer/basics/FiltersContainer.tsx");
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/basics/Icon.tsx");
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const SortsAndFilters = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__[/* FiltersContainerDiv */ "a"]) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* css */ "g"] `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  ${optionButtonLike};
`;
const FilterOptionIcon = Object(renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"])(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ }),

/***/ "./src/renderer/pages/common/StandardGameDesc.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/navigation.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/Filler.tsx");
/* harmony import */ var renderer_basics_PlatformIcons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/basics/PlatformIcons/index.tsx");
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./src/renderer/pages/PageStyles/games.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./src/renderer/t.tsx");






const StandardGameDesc = ({ game, children, }) => {
    if (!game) {
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* TitleBox */ "c"], null,
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* Title */ "b"], null)));
    }
    return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* TitleBox */ "c"], null,
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("a", { href: Object(common_util_navigation__WEBPACK_IMPORTED_MODULE_0__[/* urlForGame */ "i"])(game.id), className: "gamedesc--titlelink" },
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_4__[/* Title */ "b"], null,
                react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", { className: "gamedesc--title" }, game.title),
                children)),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null, game.shortText),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], null),
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("div", null,
            renderClassification(game.classification),
            react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_PlatformIcons__WEBPACK_IMPORTED_MODULE_3__[/* default */ "a"], { target: game, before: () => react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null, "\u00A0\u00A0") }))));
};
/* harmony default export */ __webpack_exports__["a"] = (StandardGameDesc);
function renderClassification(classification) {
    let label = [`usage_stats.description.${classification}`];
    return react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_5__[/* T */ "a"])(label));
}


/***/ })

}]);
//# sourceMappingURL=7.chunk.js.map