(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[9],{

/***/ "./src/common/butlerd/index.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return messages; });
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "a", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["a"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "b", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["b"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "c", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["c"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "d", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["d"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "e", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["e"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "f", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["f"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "g", function() { return common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__["g"]; });

/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/common/butlerd/messages.ts");


const messages = common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__;


/***/ }),

/***/ "./src/common/butlerd/utils.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ call; });
__webpack_require__.d(__webpack_exports__, "f", function() { return /* binding */ hookLogging; });
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ getCaveSummary; });
__webpack_require__.d(__webpack_exports__, "g", function() { return /* binding */ isInternalError; });
__webpack_require__.d(__webpack_exports__, "d", function() { return /* binding */ getErrorStack; });
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ asRequestError; });
__webpack_require__.d(__webpack_exports__, "e", function() { return /* binding */ getRpcErrorData; });

// UNUSED EXPORTS: hookProgress, getErrorMessage, mergeLogAndError

// EXTERNAL MODULE: ./node_modules/butlerd/lib/index.js
var lib = __webpack_require__("./node_modules/butlerd/lib/index.js");

// EXTERNAL MODULE: ./src/common/logger/index.ts
var common_logger = __webpack_require__("./src/common/logger/index.ts");

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__("./src/common/butlerd/messages.ts");

// EXTERNAL MODULE: ./src/common/types/index.ts
var types = __webpack_require__("./src/common/types/index.ts");

// CONCATENATED MODULE: ./src/main/reactors/delay.ts
/** returns a promise that resolves after 'ms' milliseconds */
function delay(ms) {
    return new Promise((resolve, reject) => setTimeout(resolve, ms));
}

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__("./src/common/format/datetime.ts");

// CONCATENATED MODULE: ./src/common/butlerd/utils.ts






var clientPromises = new WeakMap();
async function makeClient(store, parentLogger) {
    const logger = parentLogger.childWithName("butlerd/make-client");
    while (true) {
        const { endpoint } = store.getState().butlerd;
        if (endpoint) {
            const client = new lib["Client"](endpoint);
            client.onWarning((msg) => {
                logger.warn(`(butlerd) ${msg}`);
            });
            return client;
        }
        logger.info(`Waiting for butlerd endpoint...`);
        await delay(1000);
    }
}
async function getClient(store, parentLogger) {
    let p;
    if (clientPromises.has(store)) {
        p = clientPromises.get(store);
    }
    else {
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    const client = await p;
    const currentEndpoint = store.getState().butlerd.endpoint;
    if (client.endpoint !== currentEndpoint) {
        parentLogger.warn(`(butlerd) Endpoint changed (${client.endpoint.tcp.address} => ${currentEndpoint.tcp.address}), making fresh client`);
        p = makeClient(store, parentLogger);
        clientPromises.set(store, p);
    }
    return p;
}
async function call(store, logger, rc, params, setup) {
    const client = await getClient(store, logger);
    try {
        logger.debug(`Calling ${rc({})(client).method}`);
        return await client.call(rc, params, setup);
    }
    catch (e) {
        if (Object(types["isCancelled"])(e)) {
            // nvm
        }
        else if (Object(types["isAborted"])(e)) {
            // nvm
        }
        else {
            logger.error(`Caught butler error:`);
            if (isInternalError(e)) {
                const ed = getRpcErrorData(e);
                if (ed) {
                    logger.error(`butler version: ${ed.butlerVersion}`);
                    logger.error(`Golang stack:\n${ed.stack}`);
                }
                logger.error(`JavaScript stack: ${e.stack}`);
            }
            else {
                logger.error(`${e.message}`);
            }
        }
        throw e;
    }
}
function hookProgress(convo, ctx) {
    convo.onNotification(messages["Progress"], (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages["Log"], async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = Object(datetime["d" /* formatDate */])(new Date(obj.time), "en-US", datetime["a" /* DATE_FORMAT */]);
                    let level = common_logger["c" /* levels */][obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}
function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}


/***/ }),

/***/ "./src/common/constants/get-user-cover-url.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return getUserCoverURL; });
/* harmony import */ var common_util_resources__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/util/resources.ts");

function getUserCoverURL(user) {
    const { coverUrl, stillCoverUrl } = user;
    return stillCoverUrl || coverUrl || getFrogCoverURL(user.id);
}
const frogs = [
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-cyan.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-red.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-gold.svg"),
    Object(common_util_resources__WEBPACK_IMPORTED_MODULE_0__[/* getImageURL */ "a"])("avatars/frog-blue.svg"),
];
function getFrogCoverURL(userId) {
    return frogs[userId % frogs.length];
}


/***/ }),

/***/ "./src/common/format/errors.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return formatError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return getDownloadError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return getInstallPlanInfoError; });
/* unused harmony export getButlerdErrorFromTuple */
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/utils.ts");
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/underscore/modules/index-all.js");


function formatError(e, apiErrorPrefix) {
    const re = Object(common_butlerd_utils__WEBPACK_IMPORTED_MODULE_0__[/* asRequestError */ "a"])(e);
    if (re && re.rpcError) {
        const { code, data } = re.rpcError;
        if (data && data.apiError && apiErrorPrefix) {
            const { messages } = data.apiError;
            const message = Object(underscore__WEBPACK_IMPORTED_MODULE_1__[/* first */ "h"])(messages);
            if (message) {
                const snakeCaseMessage = message.replace(/\s/g, "_").toLowerCase();
                return [
                    `errors.api.${apiErrorPrefix}.${snakeCaseMessage}`,
                    {
                        defaultValue: `{message}`,
                        message,
                    },
                ];
            }
        }
        const { message } = re.rpcError;
        return [
            `butlerd.codes.${code}`,
            {
                defaultValue: `{message}`,
                message,
            },
        ];
    }
    return e.message;
}
function getDownloadError(item) {
    return getButlerdErrorFromTuple(item);
}
function getInstallPlanInfoError(item) {
    return getButlerdErrorFromTuple(item);
}
function getButlerdErrorFromTuple(item) {
    if (!item.errorMessage) {
        return null;
    }
    let rawError = new Error(item.errorMessage);
    rawError.stack = item.error;
    rawError.rpcError = {
        code: item.errorCode,
        message: item.errorMessage,
        data: {
            stack: item.error,
        },
    };
    return rawError;
}


/***/ }),

/***/ "./src/common/format/filesize.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return fileSize; });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ "./src/common/util/resources.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ getImageURL; });
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ getInjectURL; });

// UNUSED EXPORTS: getImagePath, getLocalePath, getLocalesConfigPath, getInjectPath, getRendererFilePath

// EXTERNAL MODULE: external "path"
var external_path_ = __webpack_require__("path");

// EXTERNAL MODULE: external "electron"
var external_electron_ = __webpack_require__("electron");
var external_electron_default = /*#__PURE__*/__webpack_require__.n(external_electron_);

// CONCATENATED MODULE: ./src/common/helpers/app.ts

let app;
if (process.type) {
    app = external_electron_default.a.app || external_electron_default.a.remote.app;
}
function getAppPath() {
    if (!app) {
        return `<app path>`;
    }
    return app.getAppPath();
}
function getVersion() {
    if (!app) {
        return `<test version>`;
    }
    return app.getVersion();
}

// CONCATENATED MODULE: ./src/common/util/resources.ts


let absoluteAppPath = Object(external_path_["join"])(getAppPath(), "src");
let absoluteMainDistPath = Object(external_path_["join"])(getAppPath(), "dist", "main");
let absoluteRendererDistPath = Object(external_path_["join"])(getAppPath(), "dist", "renderer");
/*
 * Resources are files shipped with the app, that are static
 * and don't usually change, unless updated.
 */
function getPath(resourcePath) {
    return absoluteAppPath + "/" + resourcePath;
}
function getImagePath(path) {
    const resourcePath = "static/images/" + path;
    return getPath(resourcePath);
}
function getImageURL(path) {
    return `file://${getImagePath(path)}`;
}
function getLocalePath(path) {
    const resourcePath = "static/locales/" + path;
    return getPath(resourcePath);
}
function getLocalesConfigPath() {
    let resourcePath = "static/locales.json";
    return getPath(resourcePath);
}
function getInjectPath(name) {
    return Object(external_path_["join"])(absoluteMainDistPath, `inject-${name}.bundle.js`);
}
function getInjectURL(name) {
    return `file://${getInjectPath(name)}`;
}
function getRendererFilePath(name) {
    return Object(external_path_["join"])(absoluteRendererDistPath, name);
}


/***/ }),

/***/ "./src/renderer/basics/DownloadProgressSpan.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DownloadProgressSpan; });
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/format/filesize.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/basics/FormattedDuration.tsx");
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./src/renderer/t.tsx");




function DownloadProgressSpan({ bps, eta, downloadsPaused, onlyBPS, onlyETA, }) {
    if (downloadsPaused) {
        return react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null, Object(renderer_t__WEBPACK_IMPORTED_MODULE_3__[/* T */ "a"])(["grid.item.downloads_paused"]));
    }
    if (onlyBPS) {
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null,
            Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_0__[/* fileSize */ "a"])(bps),
            "/s"));
    }
    if (onlyETA) {
        return react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { secs: eta });
    }
    const hasBPS = bps > 0;
    const hasETA = eta > 0;
    return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement("span", null,
        hasBPS ? (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_1___default.a.Fragment, null,
            Object(common_format_filesize__WEBPACK_IMPORTED_MODULE_0__[/* fileSize */ "a"])(bps),
            "/s")) : null,
        hasBPS && hasETA ? " — " : null,
        hasETA ? react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], { secs: eta }) : null));
}


/***/ }),

/***/ "./src/renderer/basics/FormattedDuration.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/format/datetime.ts");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/react-intl/lib/src/components/message.js");



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ __webpack_exports__["a"] = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"], Object.assign({}, Object(common_format_datetime__WEBPACK_IMPORTED_MODULE_0__[/* formatDurationAsMessage */ "e"])(secs)))));


/***/ }),

/***/ "./src/renderer/basics/Link.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/tslib/tslib.es6.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/styles.ts");



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* default */ "h"].span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_2__[/* secondaryLink */ "r"]};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_1___default.a.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __rest */ "d"])(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ __webpack_exports__["a"] = (Link);
class Props {
}


/***/ }),

/***/ "./src/renderer/basics/TitleBar/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// UNUSED EXPORTS: titleBarHeight

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/env.ts
var env = __webpack_require__("./src/common/env.ts");

// EXTERNAL MODULE: ./src/common/helpers/space.ts
var space = __webpack_require__("./src/common/helpers/space.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/NewVersionAvailable.tsx






const Container = styles["h" /* default */].div `
  align-self: stretch;
  font-weight: bold;
  padding: 0 0.5em;
  margin-right: 1em;

  display: flex;
  flex-direction: row;
  align-items: center;
  border-radius: 2px;

  &:hover {
    background: ${(props) => props.theme.baseBackground};
    cursor: pointer;
  }
`;
const Spacer = styles["h" /* default */].div `
  height: 1px;
  width: 0.4em;
`;
class NewVersionAvailable_NewVersionAvailable extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].relaunchRequest({}));
        };
    }
    render() {
        const { available } = this.props;
        if (!available) {
            return null;
        }
        return (react_default.a.createElement(Container, { onClick: this.onClick },
            react_default.a.createElement(Icon["a" /* default */], { icon: "install" }),
            react_default.a.createElement(Spacer, null),
            Object(t["a" /* T */])(["prompt.self_update_ready.short"])));
    }
}
/* harmony default export */ var TitleBar_NewVersionAvailable = (Object(hook["a" /* hook */])((map) => ({
    available: map((rs) => {
        const pkg = rs.broth.packages[rs.system.appName];
        return pkg && pkg.stage === "need-restart";
    }),
}))(NewVersionAvailable_NewVersionAvailable));

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/common/constants/get-user-cover-url.ts
var get_user_cover_url = __webpack_require__("./src/common/constants/get-user-cover-url.ts");

// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/UserMenu.tsx







const UserMenuDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding: 8px;
  margin-right: 8px;

  transition: background 0.2s;
  &:hover {
    background: rgba(0, 0, 0, 0.2);
    cursor: pointer;
  }

  animation: ${styles["b" /* animations */].enterTop} 0.2s;

  .icon {
    margin: 0;
    transition: all 0.2s;
  }

  img {
    height: 24px;
    width: 24px;
    margin-right: 8px;
    border-radius: 2px;
    flex-shrink: 0;
  }

  span {
    flex-shrink: 1;
    ${styles["s" /* singleLine */]};
  }
`;
class UserMenu_UserMenu extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.openMenu = (e) => {
            if (e.button === 0) {
                const { dispatch } = this.props;
                dispatch(actions["a" /* actions */].openUserMenu({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    clientX: e.clientX,
                    clientY: e.clientY,
                }));
            }
        };
    }
    render() {
        if (!this.props.me) {
            return null; // cf. #1405
        }
        return this.me();
    }
    me() {
        const { me } = this.props;
        const { username, displayName } = me;
        const coverUrl = Object(get_user_cover_url["a" /* getUserCoverURL */])(me);
        return (react_default.a.createElement(UserMenuDiv, { className: "user-menu", onMouseDown: this.openMenu },
            react_default.a.createElement("img", { src: coverUrl }),
            react_default.a.createElement("span", null, displayName || username),
            react_default.a.createElement(Filler["a" /* default */], null)));
    }
}
/* harmony default export */ var TitleBar_UserMenu = (Object(hook["a" /* hook */])((map) => ({
    me: map((rs) => rs.profile.profile.user),
}))(UserMenu_UserMenu));

// EXTERNAL MODULE: ./src/common/modals/index.ts + 1 modules
var modals = __webpack_require__("./src/common/modals/index.ts");

// EXTERNAL MODULE: ./src/common/helpers/secret-click.ts
var secret_click = __webpack_require__("./src/common/helpers/secret-click.ts");

// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/index.tsx













const DraggableDiv = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};
  -webkit-app-region: drag;

  flex: 1 1;
  display: flex;
  align-self: stretch;
`;
const TitleBar_Spacer = styles["h" /* default */].div `
  width: 8px;
  flex-shrink: 0;
`;
const titleBarHeight = 40;
const WindowButton = Object(styles["h" /* default */])(IconButton["a" /* default */]) `
  align-self: flex-start;
  flex-shrink: 0;
  width: ${titleBarHeight * 1.1}px;
  height: ${titleBarHeight * 0.8}px;
  opacity: 0.7;

  &:hover {
    opacity: 1;
    background: rgba(255, 255, 255, 0.1);
  }

  &.exit:hover {
    background: rgba(174, 8, 7, 1);
  }
`;
const DraggableDivInner = styles["h" /* default */].div `
  flex: 1 1;
  display: flex;
  align-self: center;
  align-items: center;
  max-width: 100%;
`;
const TitleBar_Filler = styles["h" /* default */].div `
  flex: 1 1;
`;
const TitleBarDiv = styles["h" /* default */].div `
  display: flex;
  align-items: center;
  width: 100%;
  background: ${(props) => props.theme.sidebarBackground};
  padding-left: 10px;
  height: ${titleBarHeight}px;
`;
const TitleDiv = styles["h" /* default */].div `
  ${styles["s" /* singleLine */]};

  font-size: ${(props) => props.theme.fontSizes.large};
`;
const emptyObj = {};
class TitleBar_TitleBar extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if (Object(secret_click["a" /* isSecretClick */])(e)) {
                const { dispatch } = this.props;
                dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].secretSettings.make({
                    wind: Object(navigation["d" /* ambientWind */])(),
                    title: "Secret settings",
                    message: "",
                    widgetParams: {},
                })));
                return;
            }
        };
        this.preferencesClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].navigate({ wind: "root", url: "itch://preferences" }));
        };
        this.minimizeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].minimizeWind({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
        this.maximizeRestoreClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].toggleMaximizeWind({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
        this.closeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].hideWind({ wind: Object(navigation["d" /* ambientWind */])() }));
        };
    }
    render() {
        const { tab, macos, tabInstance } = this.props;
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        const sp = space["a" /* Space */].fromInstance(tab, tabInstance);
        let label = sp.lazyLabel();
        const loggedIn = tab !== "login";
        if (!loggedIn) {
            if (macos) {
                label = "";
            }
            else {
                label = env["a" /* default */].appName;
            }
        }
        return (react_default.a.createElement(TitleBarDiv, { className: "title-bar" },
            react_default.a.createElement(DraggableDiv, { id: "title-draggable", onClick: this.onClick },
                react_default.a.createElement(DraggableDivInner, null,
                    secondary ? react_default.a.createElement(TitleBar_Filler, null) : null,
                    react_default.a.createElement(TitleDiv, { className: "title-bar-text" }, Object(t["a" /* T */])(label)),
                    react_default.a.createElement(TitleBar_Filler, null))),
            secondary ? null : (react_default.a.createElement(react_default.a.Fragment, null,
                loggedIn ? react_default.a.createElement(TitleBar_UserMenu, null) : null,
                react_default.a.createElement(TitleBar_NewVersionAvailable, null))),
            react_default.a.createElement(TitleBar_Spacer, null),
            this.renderIcons()));
    }
    renderIcons() {
        const { macos, maximized } = this.props;
        if (macos) {
            return null;
        }
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        return (react_default.a.createElement(react_default.a.Fragment, null,
            secondary ? null : (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement(WindowButton, { icon: "minus", onClick: this.minimizeClick }),
                react_default.a.createElement(WindowButton, { icon: maximized ? "window-restore" : "window-maximize", onClick: this.maximizeRestoreClick }))),
            react_default.a.createElement(WindowButton, { className: "exit", icon: "cross", onClick: this.closeClick })));
    }
}
/* harmony default export */ var basics_TitleBar = __webpack_exports__["a"] = (Object(hook["b" /* hookWithProps */])(TitleBar_TitleBar)((map) => ({
    tabInstance: map((rs, props) => Object(navigation["e" /* ambientWindState */])(rs).tabInstances[props.tab] || emptyObj),
    maximized: map((rs, props) => rs.winds[Object(navigation["d" /* ambientWind */])()].native.maximized),
    focused: map((rs, props) => rs.winds[Object(navigation["d" /* ambientWind */])()].native.focused),
    macos: map((rs, props) => rs.system.macos),
}))(TitleBar_TitleBar));


/***/ }),

/***/ "./src/renderer/butlerd/rcall.ts":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return rcall; });
/* harmony import */ var common_butlerd__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./src/common/butlerd/index.ts");
/* harmony import */ var renderer_store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./src/renderer/store.ts");
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./src/renderer/logger/index.ts");



if (process.type !== "renderer") {
    throw new Error(`rcall cannot be required from main process`);
}
const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_2__[/* rendererLogger */ "a"].childWithName("rcall");
/**
 * Perform a butlerd call from the renderer process
 */
async function rcall(rc, params, setup) {
    return await Object(common_butlerd__WEBPACK_IMPORTED_MODULE_0__[/* call */ "b"])(renderer_store__WEBPACK_IMPORTED_MODULE_1__["default"], logger, rc, params, setup);
}


/***/ }),

/***/ "./src/renderer/helpers/doAsync.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return doAsync; });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ "./src/renderer/scenes/GateScene/index.tsx":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__("./node_modules/react/index.js");
var react_default = /*#__PURE__*/__webpack_require__.n(react);

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__("./src/renderer/basics/Filler.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/TitleBar/index.tsx + 2 modules
var TitleBar = __webpack_require__("./src/renderer/basics/TitleBar/index.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__("./src/renderer/hocs/hook.tsx");

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__("./src/common/actions/index.ts");

// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__("./src/common/constants/urls.ts");

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__("./src/common/format/filesize.ts");

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__("./src/renderer/basics/Button.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__("./src/renderer/basics/Icon.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/Link.tsx
var Link = __webpack_require__("./src/renderer/basics/Link.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__("./src/renderer/basics/LoadingCircle/index.tsx");

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__("./src/renderer/styles.ts");

// EXTERNAL MODULE: ./src/renderer/t.tsx + 1 modules
var t = __webpack_require__("./src/renderer/t.tsx");

// EXTERNAL MODULE: ./src/renderer/basics/DownloadProgressSpan.tsx
var DownloadProgressSpan = __webpack_require__("./src/renderer/basics/DownloadProgressSpan.tsx");

// EXTERNAL MODULE: ./src/common/modals/index.ts + 1 modules
var modals = __webpack_require__("./src/common/modals/index.ts");

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__("./src/common/util/navigation.ts");

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/BlockingOperation.tsx














const BlockingOperationDiv = styles["h" /* default */].div `
  font-size: ${(props) => props.theme.fontSizes.large};

  .message {
    padding: 1em;
    display: flex;
    flex-direction: row;
    justify-content: center;
    white-space: pre-wrap;
    max-height: 150px;
    overflow-y: auto;
    user-select: initial;
  }

  .antivirus-message {
    background: rgba(0, 0, 0, 0.3);
    margin: 1em 0;
    padding: 1em;
  }

  .progress {
    padding: 1em;
    font-size: ${(props) => props.theme.fontSizes.smaller};
    color: ${(props) => props.theme.secondaryText};
    text-align: center;
  }

  .error-actions {
    padding: 1em;
    display: flex;
    flex-direction: row;
    justify-content: center;
  }
`;
const Spacer = styles["h" /* default */].div `
  display: inline-block;
  height: 1px;
  min-width: 8px;
`;
class BlockingOperation_BlockingOperation extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.viewBlockingOperationLog = () => {
            const { dispatch, blockingOperation } = this.props;
            dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].showError.make({
                wind: Object(navigation["d" /* ambientWind */])(),
                title: "Setup",
                message: ["login.status.setup_failure", { error: "" }],
                widgetParams: {
                    rawError: blockingOperation.rawError,
                    log: blockingOperation.log,
                    forceDetails: true,
                    showSendReport: true,
                },
                buttons: ["ok"],
            })));
        };
        this.onRetrySetup = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].retrySetup({}));
        };
        this.learnAboutAntivirus = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].openInExternalBrowser({ url: urls["a" /* default */].windowsAntivirus }));
        };
    }
    render() {
        const { dispatch, blockingOperation, windows } = this.props;
        const { message, icon, progressInfo } = blockingOperation;
        const hasError = icon === "error";
        let iconElement;
        if (hasError) {
            iconElement = react_default.a.createElement(Icon["a" /* default */], { icon: icon });
        }
        else {
            iconElement = (react_default.a.createElement(LoadingCircle["a" /* default */], { wide: true, progress: progressInfo ? progressInfo.progress : -1 }));
        }
        const { bps = 0, eta = 0 } = progressInfo ? progressInfo : {};
        return (react_default.a.createElement(BlockingOperationDiv, null,
            react_default.a.createElement("div", { className: "message" },
                iconElement ? (react_default.a.createElement(react_default.a.Fragment, null,
                    iconElement,
                    react_default.a.createElement(Spacer, null))) : null,
                Object(t["a" /* T */])(message)),
            !!progressInfo && progressInfo.doneBytes > 0 ? (react_default.a.createElement("div", { className: "progress" },
                Object(filesize["a" /* fileSize */])(progressInfo.doneBytes),
                " /",
                " ",
                Object(filesize["a" /* fileSize */])(progressInfo.totalBytes),
                bps !== 0 || eta !== 0 ? (react_default.a.createElement(react_default.a.Fragment, null,
                    " @ ",
                    react_default.a.createElement(DownloadProgressSpan["a" /* default */], { eta: eta, bps: bps, downloadsPaused: false }))) : null)) : null,
            hasError ? (react_default.a.createElement(react_default.a.Fragment, null,
                react_default.a.createElement("div", { className: "error-actions" },
                    react_default.a.createElement(Button["a" /* default */], { icon: "repeat", label: Object(t["a" /* T */])(["login.action.retry_setup"]), onClick: this.onRetrySetup }),
                    react_default.a.createElement(Spacer, null),
                    react_default.a.createElement(Button["a" /* default */], { icon: "bug", label: Object(t["a" /* T */])(["grid.item.open_debug_log"]), onClick: this.viewBlockingOperationLog })),
                windows ? (react_default.a.createElement("p", { className: "antivirus-message" },
                    react_default.a.createElement(Icon["a" /* default */], { icon: "lifebuoy" }),
                    react_default.a.createElement(Spacer, null),
                    Object(t["a" /* T */])(["login.status.antivirus_warning"]),
                    react_default.a.createElement(Spacer, null),
                    react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["toast.actions.learn_more"]), onClick: this.learnAboutAntivirus }))) : null)) : null));
    }
}
/* harmony default export */ var GateScene_BlockingOperation = (Object(hook["a" /* hook */])((map) => ({
    windows: map((rs) => rs.system.windows),
}))(BlockingOperation_BlockingOperation));

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__("./node_modules/tslib/tslib.es6.js");

// EXTERNAL MODULE: ./src/common/butlerd/index.ts
var butlerd = __webpack_require__("./src/common/butlerd/index.ts");

// EXTERNAL MODULE: ./src/renderer/butlerd/rcall.ts
var rcall = __webpack_require__("./src/renderer/butlerd/rcall.ts");

// EXTERNAL MODULE: ./src/renderer/helpers/doAsync.tsx
var doAsync = __webpack_require__("./src/renderer/helpers/doAsync.tsx");

// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__("./src/renderer/hocs/watching.tsx");

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__("./node_modules/underscore/modules/index-all.js");

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__("./node_modules/classnames/index.js");
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);

// EXTERNAL MODULE: ./src/common/format/errors.ts
var errors = __webpack_require__("./src/common/format/errors.ts");

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__("./src/renderer/basics/IconButton.tsx");

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/styles.tsx

const Links = styles["h" /* default */].div `
  margin: 1em 0;
  text-align: center;
`;

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/LoginForm/index.tsx













const ErrorDiv = styles["h" /* default */].div `
  min-width: 500px;
  margin: 1.4em 0;

  .header {
    text-align: center;
  }

  .icon {
    margin-right: 8px;
  }

  color: ${(props) => props.theme.error};
`;
const PasswordContainer = styles["h" /* default */].div `
  position: relative;
`;
const RevealButton = Object(styles["h" /* default */])(IconButton["a" /* default */]) `
  position: absolute;
  right: 8px;
  top: 0;
  height: 100%;
  font-size: 20px;

  .icon {
    color: ${(props) => props.theme.ternaryText} !important;
  }

  &.passwordShown {
    .icon {
      color: ${(props) => props.theme.accent} !important;
    }
  }
`;
class LoginForm_LoginForm extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.openRegisterPage = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].openInExternalBrowser({ url: urls["a" /* default */].accountRegister }));
        };
        this.openPasswordResetPage = () => {
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].openInExternalBrowser({
                url: urls["a" /* default */].accountForgotPassword,
            }));
        };
        this.togglePasswordReveal = (ev) => {
            ev.preventDefault();
            this.setState({
                passwordShown: !this.state.passwordShown,
            });
        };
        this.username = null;
        this.gotUsernameField = (el) => (this.username = el);
        this.password = null;
        this.gotPasswordField = (el) => (this.password = el);
        this.handleSubmit = () => {
            const { username, password } = this;
            if (!username || !password) {
                return;
            }
            const { dispatch } = this.props;
            dispatch(actions["a" /* actions */].loginWithPassword({
                username: username.value,
                password: password.value,
            }));
        };
        this.handleKeyDown = (e) => {
            if (e.key === "Enter") {
                this.handleSubmit();
            }
        };
        this.state = {
            passwordShown: false,
        };
    }
    render() {
        const { dispatch, showSaved, lastUsername } = this.props;
        const { passwordShown } = this.state;
        return (react_default.a.createElement(LoginFormDiv, null,
            react_default.a.createElement(Form, { onSubmit: this.handleSubmit },
                this.renderError(),
                react_default.a.createElement("label", null,
                    Object(t["a" /* T */])(["login.field.username"]),
                    react_default.a.createElement("input", { id: "login-username", ref: this.gotUsernameField, type: "text", defaultValue: lastUsername, autoFocus: !lastUsername, onKeyDown: this.handleKeyDown })),
                react_default.a.createElement("label", null,
                    Object(t["a" /* T */])(["login.field.password"]),
                    react_default.a.createElement(PasswordContainer, null,
                        react_default.a.createElement(RevealButton, { onMouseDown: this.togglePasswordReveal, icon: passwordShown ? "visibility" : "visibility_off", hint: passwordShown
                                ? ["login.action.hide_password"]
                                : ["login.action.reveal_password"], className: classnames_default()({ passwordShown }), hintPosition: "top" }),
                        react_default.a.createElement("input", { id: "login-password", ref: this.gotPasswordField, type: passwordShown ? "text" : "password", autoFocus: !!lastUsername, onKeyDown: this.handleKeyDown }))),
                react_default.a.createElement(Button["a" /* default */], { id: "login-button", className: "login-button", fat: true, primary: true, label: Object(t["a" /* T */])(["login.action.login"]), onClick: this.handleSubmit })),
            react_default.a.createElement(Links, null,
                react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["login.action.register"]), onClick: this.openRegisterPage }),
                react_default.a.createElement("span", null, " · "),
                react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["login.action.reset_password"]), onClick: this.openPasswordResetPage }),
                react_default.a.createElement("span", { key: "separator" }, " · "),
                react_default.a.createElement(Link["a" /* default */], { key: "show-saved-logins", label: Object(t["a" /* T */])(["login.action.show_saved_logins"]), onClick: showSaved }))));
    }
    renderError() {
        const err = this.props.error;
        if (!err) {
            return null;
        }
        return (react_default.a.createElement(ErrorDiv, null,
            react_default.a.createElement("div", { className: "header" },
                react_default.a.createElement(Icon["a" /* default */], { icon: "error" }),
                Object(t["a" /* T */])(Object(errors["a" /* formatError */])(err, "login")))));
    }
}
const Form = styles["h" /* default */].form `
  display: flex;
  flex-direction: column;
  align-items: center;

  label {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    margin: 0.5em 1em;

    span {
      margin: 0 4px;
      color: ${(props) => props.theme.secondaryText};
      font-size: 90%;
    }
  }

  #login-password {
    padding-right: 35px;
  }

  input {
    ${styles["j" /* heavyInput */]};
    font-size: ${(props) => props.theme.fontSizes.large};
    width: 380px;
  }

  .login-button {
    margin: 1em 0;
  }
`;
const LoginFormDiv = styles["h" /* default */].div ``;
/* harmony default export */ var GateScene_LoginForm = (Object(hook["a" /* hook */])((map) => ({
    lastUsername: map((rs) => rs.profile.login.lastUsername),
    error: map((rs) => rs.profile.login.error),
}))(LoginForm_LoginForm));

// EXTERNAL MODULE: ./src/renderer/basics/TimeAgo.tsx + 1 modules
var TimeAgo = __webpack_require__("./src/renderer/basics/TimeAgo.tsx");

// EXTERNAL MODULE: ./src/common/constants/get-user-cover-url.ts
var get_user_cover_url = __webpack_require__("./src/common/constants/get-user-cover-url.ts");

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/RememberedProfiles/RememberedProfile.tsx









class RememberedProfile_RememberedProfile extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.useThisProfile = () => {
            const { dispatch, profile } = this.props;
            dispatch(actions["a" /* actions */].useSavedLogin({ profile }));
        };
        this.onForget = (e) => {
            e.stopPropagation();
            const { profile, dispatch } = this.props;
            const { username } = profile.user;
            dispatch(actions["a" /* actions */].openModal(modals["a" /* modals */].naked.make({
                wind: "root",
                title: ["prompt.forget_session.title"],
                message: ["prompt.forget_session.message", { username }],
                detail: ["prompt.forget_session.detail"],
                buttons: [
                    {
                        id: "modal-forget-profile",
                        label: ["prompt.forget_session.action"],
                        action: actions["a" /* actions */].forgetProfile({ profile }),
                        icon: "cross",
                    },
                    "cancel",
                ],
                widgetParams: null,
            })));
        };
    }
    render() {
        const { profile } = this.props;
        const { user } = profile;
        const { username, displayName } = user;
        const coverUrl = Object(get_user_cover_url["a" /* getUserCoverURL */])(user);
        return (react_default.a.createElement(RememberedProfileDiv, { className: "remembered-profile", onClick: this.useThisProfile },
            react_default.a.createElement("img", { className: "avatar", src: coverUrl }),
            react_default.a.createElement("div", { className: "rest" },
                react_default.a.createElement("p", { className: "username" }, displayName || username),
                react_default.a.createElement("p", { className: "last-connected" },
                    Object(t["a" /* T */])(["login.remembered_session.last_connected"]),
                    " ",
                    react_default.a.createElement(TimeAgo["a" /* default */], { date: profile.lastConnected }))),
            react_default.a.createElement("div", { className: "filler" }),
            react_default.a.createElement("span", { "data-rh-at": "left", "data-rh": JSON.stringify(["prompt.forget_session.action"]) },
                react_default.a.createElement(IconButton["a" /* default */], { icon: "cross", className: "forget-profile", onClick: this.onForget }))));
    }
}
/* harmony default export */ var RememberedProfiles_RememberedProfile = (Object(hook["a" /* hook */])()(RememberedProfile_RememberedProfile));
const RememberedProfileDiv = styles["h" /* default */].div `
  ${styles["c" /* boxy */]};
  flex-shrink: 0;
  min-width: 380px;
  border-radius: 2px;
  display: flex;
  flex-direction: row;
  align-items: center;
  margin: 8px 4px;

  .avatar {
    filter: grayscale(100%);

    width: 64px;
    height: 64px;
    border-radius: 2px;
    margin-right: 4px;
  }

  &:hover .avatar {
    filter: grayscale(0%);
  }

  p {
    padding: 2px 0;
  }

  .rest {
    padding: 6px 8px;
  }

  .filler {
    flex-grow: 8;
  }

  .username {
    color: ${(props) => props.theme.baseText};
    font-size: ${(props) => props.theme.fontSizes.huge};
    font-weight: bold;
    padding: 4px 0;
  }

  .last-connected {
    color: ${(props) => props.theme.secondaryText};
    font-size: 14px;
  }

  box-shadow: 0 0 4px ${(props) => props.theme.sidebarBackground};

  &:hover {
    box-shadow: 0 0 8px ${(props) => props.theme.sidebarBackground};
    cursor: pointer;
  }

  &:active {
    -webkit-filter: brightness(70%);
  }
`;

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/RememberedProfiles/index.tsx












const RememberedProfilesDiv = styles["h" /* default */].div `
  animation: fade-in 0.2s;

  display: flex;
  flex-direction: column;
  align-items: center;
  overflow-y: auto;
`;
let RememberedProfiles_RememberedProfiles = class RememberedProfiles extends react_default.a.PureComponent {
    render() {
        const { profiles, showForm } = this.props;
        return (react_default.a.createElement(RememberedProfilesDiv, null,
            Object(index_all["l" /* map */])(profiles, (profile) => (react_default.a.createElement(RememberedProfiles_RememberedProfile, { key: profile.user.id, profile: profile }))),
            react_default.a.createElement(Links, null,
                react_default.a.createElement(Link["a" /* default */], { label: Object(t["a" /* T */])(["login.action.show_form"]), onClick: showForm }))));
    }
    subscribe(watcher) {
        watcher.on(actions["a" /* actions */].forgetProfile, async (store, action) => {
            const { profile } = action.payload;
            await Object(rcall["a" /* rcall */])(butlerd["h" /* messages */].ProfileForget, { profileId: profile.id });
            store.dispatch(actions["a" /* actions */].profilesUpdated({}));
        });
    }
};
RememberedProfiles_RememberedProfiles = Object(tslib_es6["b" /* __decorate */])([
    watching["a" /* default */]
], RememberedProfiles_RememberedProfiles);
/* harmony default export */ var GateScene_RememberedProfiles = (RememberedProfiles_RememberedProfiles);

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/LoginScreen.tsx












let LoginScreen_LoginScreen = class LoginScreen extends react_default.a.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.showForm = () => {
            this.setState({ showingSaved: false });
        };
        this.showSaved = () => {
            this.setState({ showingSaved: true });
        };
        this.state = {
            loading: true,
            showingSaved: true,
            profiles: [],
        };
    }
    componentDidMount() {
        this.refresh();
    }
    subscribe(watcher) {
        watcher.on(actions["a" /* actions */].profilesUpdated, async (store, action) => {
            this.refresh();
        });
        watcher.on(actions["a" /* actions */].loginFailed, async (store, action) => {
            this.showForm();
        });
    }
    refresh() {
        Object(doAsync["a" /* doAsync */])(async () => {
            const { profiles } = await Object(rcall["a" /* rcall */])(butlerd["h" /* messages */].ProfileList, {});
            this.setState({ loading: false, profiles });
            if (Object(index_all["k" /* isEmpty */])(profiles)) {
                this.setState({ showingSaved: false });
            }
        });
    }
    render() {
        const { loading, showingSaved, profiles } = this.state;
        if (loading) {
            return react_default.a.createElement(LoadingCircle["a" /* default */], { progress: -1, wide: true });
        }
        if (showingSaved) {
            return (react_default.a.createElement(GateScene_RememberedProfiles, { profiles: profiles, showForm: this.showForm }));
        }
        else {
            return react_default.a.createElement(GateScene_LoginForm, { showSaved: this.showSaved });
        }
    }
};
LoginScreen_LoginScreen = Object(tslib_es6["b" /* __decorate */])([
    watching["a" /* default */]
], LoginScreen_LoginScreen);
/* harmony default export */ var GateScene_LoginScreen = (Object(hook["a" /* hook */])()(LoginScreen_LoginScreen));

// EXTERNAL MODULE: ./node_modules/vivus/dist/vivus.js
var vivus = __webpack_require__("./node_modules/vivus/dist/vivus.js");
var vivus_default = /*#__PURE__*/__webpack_require__.n(vivus);

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/LogoIndicator.tsx




const appWhiteContour = __webpack_require__("./src/static/images/logos/app-white-contour.svg")
    .default;
const LogoIndicatorDiv = styles["h" /* default */].div `
  pointer-events: none;

  margin-top: 50px;

  &,
  svg {
    height: 170px;
    width: 430px;
  }

  svg {
    display: block;
    overflow: hidden;

    path {
      transition: stroke-dashoffset 2s ease-out;
    }
  }
`;
class LogoIndicator_LogoIndicator extends react_default.a.PureComponent {
    constructor() {
        super(...arguments);
        this.gotEl = (el) => {
            if (el) {
                new vivus_default.a(el.id, {
                    file: appWhiteContour,
                    type: "delayed",
                    start: "manual",
                    animTimingFunction: vivus_default.a.EASE_OUT,
                    onReady: (vivus) => {
                        this.vivus = vivus;
                        this.update();
                    },
                });
            }
        };
        this.update = () => {
            if (this.vivus) {
                this.vivus.setFrameProgress(this.props.progress);
            }
        };
    }
    render() {
        return react_default.a.createElement(LogoIndicatorDiv, { id: "logo-indicator-div", ref: this.gotEl });
    }
    componentDidUpdate() {
        this.update();
    }
}
/* harmony default export */ var GateScene_LogoIndicator = (Object(hook["a" /* hook */])((map) => ({
    progress: map((rs) => {
        const { blockingOperation, done } = rs.setup;
        if (done) {
            return 1.0;
        }
        else {
            if (blockingOperation && blockingOperation.progressInfo) {
                return blockingOperation.progressInfo.progress;
            }
            else {
                return 0.0;
            }
        }
    }),
}))(LogoIndicator_LogoIndicator));

// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/index.tsx








const GateSceneDiv = styles["h" /* default */].div `
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  height: 100%;

  .crux {
    flex-grow: 1;
    display: flex;
    flex-direction: column;
    align-self: stretch;
    align-items: center;
  }
`;
class GateScene_GateScene extends react_default.a.PureComponent {
    render() {
        return (react_default.a.createElement(GateSceneDiv, null,
            react_default.a.createElement(TitleBar["a" /* default */], { tab: "login" }),
            react_default.a.createElement(GateScene_LogoIndicator, null),
            react_default.a.createElement(Filler["a" /* default */], null),
            react_default.a.createElement("section", { className: "crux" }, this.renderChild()),
            react_default.a.createElement(Filler["a" /* default */], null)));
    }
    renderChild() {
        const { blockingOperation } = this.props;
        if (blockingOperation) {
            return react_default.a.createElement(GateScene_BlockingOperation, { blockingOperation: blockingOperation });
        }
        return react_default.a.createElement(GateScene_LoginScreen, null);
    }
}
/* harmony default export */ var scenes_GateScene = __webpack_exports__["default"] = (Object(hook["a" /* hook */])((map) => ({
    stage: map((rs) => (rs.setup.done ? "login" : "setup")),
    errors: map((rs) => (rs.setup.done ? null : rs.setup.errors)),
    blockingOperation: map((rs) => rs.setup.done
        ? rs.profile.login.blockingOperation
        : rs.setup.blockingOperation),
}))(GateScene_GateScene));


/***/ }),

/***/ "./src/static/images/logos/app-white-contour.svg":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = (__webpack_require__.p + "45416ee3387c41c6a09090e575792a09.svg");

/***/ })

}]);
//# sourceMappingURL=9.chunk.js.map